Package: BiocCheck
Title: Bioconductor-specific package checks
Version: 1.48.1
Date: 2026-06-30
Authors@R: c(
    person("Bioconductor", "Package Maintainer", ,
        "maintainer@bioconductor.org", "aut"),
    person("Lori", "Shepherd", role = "aut"),
    person("Daniel", "von Twisk", role = "ctb"),
    person("Kevin", "Rue", role = "ctb"),
    person("Marcel", "Ramos", , "marcel.ramos@sph.cuny.edu",
        c("aut", "cre"), c(ORCID = "0000-0002-3242-0582")),
    person("Leonardo", "Collado-Torres", role = "ctb"),
    person("Federico", "Marini", role = "ctb")
  )
Description: BiocCheck guides maintainers through Bioconductor best
    practicies. It runs Bioconductor-specific package checks by searching
    through package code, examples, and vignettes. Maintainers are
    required to address all errors, warnings, and most notes produced.
License: Artistic-2.0
URL: https://github.com/Bioconductor/BiocCheck
BugReports: https://github.com/Bioconductor/BiocCheck/issues
Depends: R (>= 4.4.0)
Imports: BiocBaseUtils, BiocFileCache, BiocManager, biocViews, callr,
        cli, codetools, commonmark, graph, httr2, knitr, methods,
        rvest, stringdist, tools, utils, xml2
Suggests: BiocStyle, devtools, gert, jsonlite, rmarkdown, tinytest,
        usethis
VignetteBuilder: knitr
biocViews: Infrastructure
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
git_url: https://git.bioconductor.org/packages/BiocCheck
git_branch: RELEASE_3_23
git_last_commit: 6029e2b
git_last_commit_date: 2026-06-30
Repository: Bioconductor 3.23
Date/Publication: 2026-07-02
NeedsCompilation: no
Packaged: 2026-07-02 20:37:42 UTC; biocbuild
Author: Bioconductor Package Maintainer [aut],
  Lori Shepherd [aut],
  Daniel von Twisk [ctb],
  Kevin Rue [ctb],
  Marcel Ramos [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3242-0582>),
  Leonardo Collado-Torres [ctb],
  Federico Marini [ctb]
Maintainer: Marcel Ramos <marcel.ramos@sph.cuny.edu>

Package: testpkg0
Title: bla
Description: blsa
Version: 0.1
Author: Joe Blow
Maintainer: Joe Blow <joe@blow.com>
Depends: R (>= 3.1.0), jsonlite
License: GPL-2
LazyData: true
Imports: devtools, tools
Remotes:
VignetteBuilder: knitr

# [BiocCheck](https://bioconductor.org/packages/BiocCheck) <a href='https://bioconductor.org/packages/BiocCheck/'><img src='https://raw.githubusercontent.com/Bioconductor/BiocStickers/devel/BiocCheck/BiocCheck.png' align="right" height="204" /></a>

<!-- badges: start -->
[![BioC status](http://www.bioconductor.org/shields/build/devel/bioc/BiocCheck.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/BiocCheck)
[![Platforms](http://www.bioconductor.org/shields/availability/devel/BiocCheck.svg)](https://www.bioconductor.org/packages/devel/bioc/html/BiocCheck.html#archives)
[![Codecov test coverage](https://codecov.io/gh/Bioconductor/BiocCheck/graph/badge.svg)](https://app.codecov.io/gh/Bioconductor/BiocCheck)
[![Downloads](http://www.bioconductor.org/shields/downloads/devel/BiocCheck.svg)](https://bioconductor.org/packages/stats/bioc/BiocCheck)
<!-- badges: end -->

The `BiocCheck` package provides a set of tools for checking a package
against the current version of Bioconductor coding and style standards.

## Installation 

To install this package, start R and enter:

```r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("BiocCheck")
```

## Bioconductor Guidelines

The Bioconductor guidelines are available at
https://contributions.bioconductor.org/. This site provides the basis for
many of the checks performed by `BiocCheck`. We encourage packages to
follow these guidelines to ensure that they are of high quality and
interoperate well with other Bioconductor packages.

## Usage

To check a package, use the `BiocCheck::BiocCheck()` function. For
example, to check the `BiocCheck` package itself, use:

```r
BiocCheck::BiocCheck("BiocCheck")
```

in the directory above the source package directory. 

Note that the `BiocCheck` package must be installed to use this function.

If you are using RStudio, you can use the `BiocCheck` addin to check a
package. First, install the BiocAddins package:

```r
BiocManager::install("Bioconductor/BiocAddins")
```

Then, in RStudio, click on the "Addins" menu, and select "Run BiocCheck".

## Documentation

The `BiocCheck` package contains a vignette that describes the package
in more detail. To view the vignette, start R and enter:

```r
vignette("BiocCheck")
```

suppressMessages({
    suppressWarnings({
        pkgdir <- commandArgs(TRUE)
        options(useFancyQuotes=FALSE)
        pkgname <- strsplit(basename(pkgdir), "_")[[1]][1]
        # if (.Platform$OS.type == "windows")
        # {
        #     libdir <- file.path(tempdir(), "libdir")
        #     install.packages(pkgname, repos=NULL, type="source",
        #         INSTALL_opts=sprintf("--library=%s",
        #             libdir))
        # } else {
            libdir <- sub(paste0(pkgname, "$"), "", pkgdir)
            libdir <- sub("/$|\\$", "", libdir)
        # }
        .libPaths(c(libdir, .libPaths()))
        cat(utils::capture.output(codetools::checkUsageEnv(base::getNamespace(pkgname))), sep="\n")
    })
})

cli_warning <- function(...) {
    cli::cli_div(theme = list(.warning = list(color = "orange")))
    cli::cli_alert_warning(paste0("{.warning WARNING: ", ..., "}"), wrap = TRUE)
}

cli_error <- function(...) {
    cli::cli_div(theme = list(.error = list(color = "red")))
    cli::cli_alert_danger(paste0("{.error ERROR: ", ..., "}"), wrap = TRUE)
}

cli_note <- function(...) {
    cli::cli_div(theme = list(.note = list(color = "blue")))
    cli::cli_alert_info(paste0("{.note NOTE: ", ..., "}"), wrap = TRUE)
}

# Message-class and methods------------------------------------------------

#' @name Message-class
#'
#' @docType class
#'
#' @title A lower level Message helper class for BiocCheck
#'
#' @aliases setMessage,Message-method setCondition,Message-method
#'   getCondition,Message-method
#'
#' @field msg `list()` A list of character messages usually grown with `append`
#'   with conditions raised by a check
#'
#' @field condition `character(1)` One of the three conditions handled: `error`,
#'   `warning`, or `note`
#'
#' @param condition `character(1)` One of the three conditions handled: `error`,
#'   `warning`, or `note`
#'
#' @param \dots `list()` A nested list with the check name as the top level
#'   layer. Second level lists include any `help_text` and `messages` that are
#'   part of the check.
#'
#' @section methods:
#'   * `setMessage`: Set the message and condition (`error`, `warning`, or
#'     `note`) for the check
#'   * `setCondition`: Change the condition for the check
#'   * `getCondition`: Get the condition from the `Message` class
#'
#' @importFrom BiocBaseUtils selectSome
#'
#' @seealso [BiocCheck-class], [BiocPackage-class]
#'
#' @return `.MessageCondition`: An internal `R5` Reference Class to handle
#'   messages and their conditions, e.g., for errors, warnings, or notes.
#'
#' @keywords internal
.MessageCondition <- setRefClass("Message",
    fields = list(
        msg = "list",
        condition = "character"
    ),
    methods = list(
        setMessage = function(..., condition) {
            text <- list(...)[[1L]]
            .self$setCondition(condition)
            clifun <- switch(
                condition,
                error = cli_error,
                warning = cli_warning,
                note = cli_note
            )
            .self$msg <- append(.self$msg, text)
            comps <- unlist(text, recursive = FALSE, use.names = FALSE)
            if (identical(length(comps), 1L)) {
                clifun(unlist(comps, use.names = FALSE))
            } else {
                dotlist <- selectSome(tail(comps, 1L)[[1L]], maxToShow = 3L)
                names(dotlist) <- rep("*", length(dotlist))
                dotlist <- gsub("{", "{{", dotlist, fixed = TRUE) |>
                    gsub("}", "}}", x = _, fixed = TRUE)
                alerttitle <- head(
                    unlist(text, recursive = FALSE, use.names = FALSE), -1L
                )
                clifun(
                    head(unlist(alerttitle, use.names = FALSE), 1L)
                )
                id <- cli::cli_div(theme = list(div = list("margin-left" = 2L)))
                if (identical(length(comps), 3L)) {
                    cli::cli_text(unlist(alerttitle, use.names = FALSE)[2L])
                    id2 <- cli::cli_div(theme = list(div = list("margin-left" = 2L)))
                }
                for (item in dotlist)
                    cli::cli_li(item)
                if (identical(length(comps), 3L))
                    cli::cli_end(id2)
                cli::cli_end(id)
            }
            .self$msg
        },
        setCondition = function(condition) {
            stopifnot(
                "'condition' must be one of 'error', 'warning', 'note'" =
                condition %in% c("error", "warning", "note")
            )
            .self$condition <- append(.self$condition, condition)
        },
        getCondition = function() {
            .self$condition
        }
    )
)

.messages <- .MessageCondition()

#Stolen from devtools:

#' Check if you have a development environment installed.
#'
#' Thanks to the suggestion of Simon Urbanek.
#'
#' @return TRUE if your development environment is correctly set up, otherwise
#'   returns an error.
#' @export
#' @examples
#' has_devel()
has_devel <- function() {
    foo_path <- file.path(tempdir(), "foo.c")

    cat("void foo(int *bar) { *bar=1; }\n", file = foo_path)
    on.exit(unlink(foo_path))

    R("CMD SHLIB foo.c", tempdir())
    dylib <- file.path(tempdir(), paste("foo", .Platform$dynlib.ext, sep=''))
    on.exit(unlink(dylib), add = TRUE)

    dll <- dyn.load(dylib)
    on.exit(dyn.unload(dylib), add = TRUE)

    stopifnot(.C(dll$bar, 0L)[[1]] == 1L)

    TRUE
}

# BiocPackage-class -------------------------------------------------------

#' @name BiocPackage-class
#'
#' @docType class
#'
#' @aliases BiocPackage
#'
#' @title A class for representing files in a Bioconductor package
#'
#' @description The BiocPackage class is used to represent a Bioconductor
#'   package. It is used by BiocCheck to store information about the package
#'   being checked. The class has several methods to identify the type of
#'   package, check for common issues, and store metadata about the package.
#'
#' @field isValid `logical` indicating whether the package's `DESCRIPTION` file
#'   was able to be read without any errors
#'
#' @field isTar `logical` indicating whether the package is a tarball
#'
#' @field isSourceDir `logical` indicating whether the package being checked is
#'   from a source directory
#'
#' @field isInfrastructure `logical` indicating whether the package is an
#'   Bioconductor infrastructure package based on the `biocViews` field
#'
#' @field usesRoxygen `logical` indicating whether the package uses `roxygen2`
#'   documentation
#'
#' @field usesRdpack `logical` indicating whether the package uses `Rdpack`
#'   package
#'
#' @field DESCRIPTION `matrix` containing the DCF contents of the `DESCRIPTION`
#'   file
#'
#' @field dependencies `character` vector of package dependencies
#'
#' @field readError `character` error message if the `DESCRIPTION` file could
#'   not be read
#'
#' @field packageVersion `character` version of the package
#'
#' @field packageType `character` indicating the type of package based on the
#'   `biocViews` field; can be `NA_character_` there are invalid `biocViews`
#'   terms
#'
#' @field sourceDir `character` path to the source directory
#'
#' @field vignettesDir `character` path to the vignettes directory
#'
#' @field RSources `character` vector of R source files
#'
#' @field VigSources `character` vector of vignette source files
#'
#' @field manSources `character` vector of Rd source files
#'
#' @field BiocCheckDir `character` path to the directory where the package
#'   BiocCheck logs are written
#'
#' @field packageName `character` name of the package
#'
#' @field tarFilename `character` filename of the tarball
#'
#' @field metadata `list` containing metadata about the package
#'
#' @return An object of class `BiocPackage`
#'
#' @keywords internal
#'
#' @section methods:
#'
#' * `initialize`: Initialize a `BiocPackage` object
#' * `getPackageDir`: Get the package directory
#' * `getRSources`: Get the R source files
#' * `getVigSources`: Get the vignette source files
#' * `getManSources`: Get the Rd source files
#' * `getBiocCheckDir`: Get the directory where the BiocCheck logs are written
#' * `getBiocViews`: Get the `biocViews` field from the `DESCRIPTION` file
#' * `getPackageType`: Get the package type based on the `biocViews` field
#' * `readDESCRIPTION`: Read the `DESCRIPTION` file
#' * `getVigBuilder`: Get the vignette builder
#' * `getAllDependencies`: Get all dependencies from the `DESCRIPTION` file
#' * `findInfrastructure`: Is the package an infrastructure package?
#' * `findRoxygen`: Does the package use `roxygen2`?
#' * `getPackageVersion`: Get the package version
#' * `untarTarball`: Untar the source tarball
#'
#' @seealso [BiocCheck-class], [Message-class]
#' @examples
#'
#' # Create a BiocPackage object
#' packageDirectory <- "path/to/package"
#' if (dir.exists(packageDirectory))
#'     .bioctest <- .BiocPackage$initialize(packageDirectory)
#'
#' .bioctest <- BiocCheck:::.BiocPackage
#'
#' .bioctest$DESCRIPTION
#'
#' @importFrom utils untar
#' @exportClass BiocPackage
.BiocPackage <- setRefClass(
    "BiocPackage",
    fields = list(
        isValid = "logical",
        isTar = "logical",
        isSourceDir = "logical",
        isInfrastructure = "logical",
        usesRoxygen = "logical",
        usesRdpack = "logical",
        DESCRIPTION = "matrix",
        dependencies = "character",
        readError = "character",
        packageVersion = "character",
        packageType = "character",
        sourceDir = "character",
        vignettesDir = "character",
        RSources = "character",
        VigSources = "character",
        VigBuilder = "character",
        manSources = "character",
        BiocCheckDir = "character",
        packageName = "character",
        tarFilename = "character",
        metadata = "list"
    ),
    methods = list(
        initialize = function(packageDir, checkDir = dirname(packageDir), ...) {
            if (!missing(packageDir)) {
                packageDir <- normalizePath(packageDir)
                .self[["isTar"]] <- grepl("\\.tar\\.[gx]z$", packageDir)
                .self[["isSourceDir"]] <-
                    !.self$isTar && file.info(packageDir)[["isdir"]]
                .self$getPackageDir(packageDir)
                .self$getRSources()
                .self$getVigSources()
                .self$getManSources()
                .self$readDESCRIPTION()
                .self$getVigBuilder()
                .self$getAllDependencies()
                .self$getBiocCheckDir(checkDir)
                .self$getPackageType()
                .self$findInfrastructure()
                .self$findRoxygen()
            }
            callSuper(...)
        },
        getPackageDir = function(packageDir) {
            if (.self[["isTar"]]) {
                .self[["tarFilename"]] <- packageDir
                packageDir <- .self$untarTarball(packageDir)
            } else if (!file.info(packageDir)[["isdir"]]) {
                .stop(
                    "'%s' is not a directory or package source tarball.",
                    packageDir
                )
            }
            if (identical(.Platform$OS.type, "windows"))
                packageDir <- gsub("\\\\", "/", packageDir)
            .self[["sourceDir"]] <- packageDir
        },
        getRSources = function() {
            Rdir <- file.path(.self[["sourceDir"]], "R")
            rfiles <-
                list.files(Rdir, pattern = "\\.[Rr]$", full.names = TRUE)
            if (length(rfiles))
                names(rfiles) <- paste0("R/", basename(rfiles))
            .self[["RSources"]] <- rfiles
        },
        getVigSources = function() {
            .self[["vignettesDir"]] <-
                file.path(.self[["sourceDir"]], "vignettes")
            vigfiles <- list.files(
                .self[["vignettesDir"]],
                pattern="\\.Rmd$|\\.qmd$|\\.Rnw$|\\.Rrst$|\\.Rhtml$|\\.Rtex$",
                ignore.case=TRUE, full.names=TRUE
            )
            if (length(vigfiles))
                names(vigfiles) <- paste0("vignettes/", basename(vigfiles))
            .self[["VigSources"]] <- vigfiles
        },
        getManSources = function() {
            mandir <- file.path(.self[["sourceDir"]], "man")
            manfiles <- list.files(
                mandir, pattern="\\.Rd$", full.names = TRUE, ignore.case = TRUE
            )
            if (length(manfiles))
                names(manfiles) <- paste0("man/", basename(manfiles))
            .self[["manSources"]] <- manfiles
        },
        getBiocCheckDir = function(checkDir) {
            checkDir <- normalizePath(checkDir, winslash = "/")
            .self[["BiocCheckDir"]] <- file.path(
                checkDir, paste(.self[["packageName"]], "BiocCheck", sep = ".")
            )
        },
        getBiocViews = function() {
            views <- ""
            dcf <- .self[["DESCRIPTION"]]
            if ("biocViews" %in% colnames(dcf))
                views <- strsplit(dcf[, "biocViews"], "\\s*,\\s*")[[1]]
            views
        },
        getPackageType = function() {
            views <- .self$getBiocViews()
            if (identical(length(views), 1L) && !nzchar(views))
                type <- NA
            biocViewsVocab <- .load_data("biocViewsVocab", "biocViews")
            if (any(!views %in% nodes(biocViewsVocab)))
                type <- NA
            parents <- vapply(views, getParent, character(1L), biocViewsVocab)
            u <- unique(parents)
            type <- if (identical(length(u), 1L)) u else NA_character_
            .self[["packageType"]] <- type
        },
        readDESCRIPTION = function() {
            desc <- file.path(.self[["sourceDir"]], "DESCRIPTION")
            dcf <- try({ read.dcf(desc) }, silent=TRUE)
            .self[["isValid"]] <- !inherits(dcf, "try-error")
            if (.self[["isValid"]]) {
                .self[["DESCRIPTION"]] <- dcf
                .self[["packageName"]] <- as.character(dcf[, "Package"])
                .self[["packageVersion"]] <- as.character(dcf[, "Version"])
            } else {
                .self[["readError"]] <- conditionMessage(attr(dcf, "condition"))
            }
        },
        getVigBuilder = function() {
            dcf <- .self[["DESCRIPTION"]]
            if (.self[["isValid"]] && "VignetteBuilder" %in% colnames(dcf))
                .self[["VigBuilder"]] <- unlist(
                    strsplit(dcf[, "VignetteBuilder"], ",\\s*\\n?"),
                    use.names = FALSE
                )
        },
        getAllDependencies = function() {
            dcf <- .self[["DESCRIPTION"]]
            fields <-
                c("Depends", "Imports", "Suggests", "Enhances", "LinkingTo")
            afields <- intersect(fields, colnames(dcf))
            out <- lapply(afields, function(field) {
                cleanupDependency(dcf[, field])
            })
            .self[["dependencies"]] <- as.character(unlist(out))
            .self[["usesRdpack"]] <- "Rdpack" %in% out
        },
        findInfrastructure = function() {
            dcf <- .self[["DESCRIPTION"]]
            if (!nrow(dcf) || !"biocViews" %in% colnames(dcf))
                return()
            biocViews <- dcf[, "biocViews"]
            views <- strsplit(gsub("\\s", "", biocViews), ",")[[1]]
            .self[["isInfrastructure"]] <- "Infrastructure" %in% views
        },
        findRoxygen = function() {
            .self[["usesRoxygen"]] <-
                "RoxygenNote" %in% colnames(.self[["DESCRIPTION"]])
        },
        getPackageVersion = function() {
            .self[["packageVersion"]]
        },
        untarTarball = function(pkgTarball, tempDir = tempfile()) {
            if (!dir.exists(tempDir))
                dir.create(tempDir)
            suppressMessages({ untar(pkgTarball, exdir = tempDir) })
            .self[["packageName"]] <-
                list.dirs(tempDir, recursive = FALSE, full.names = FALSE)
            file.path(tempDir, .self[["packageName"]])
        }
    )
)

#' @export
.BiocPackage <- .BiocPackage()

#' @importFrom graph nodes acc
#' @importFrom tools Rd2ex
#' @importFrom utils Stangle
#' @importFrom codetools walkCode findGlobals
NULL

.msg <- function(..., appendLF = TRUE, indent = 0, exdent = 2)
{
    contents <- list(...)
    txt <- if (length(contents) != 1L) do.call(sprintf, contents) else contents
    message(
        paste(strwrap(txt, indent = indent, exdent = exdent), collapse = "\n"),
        appendLF = appendLF
    )
}

.stop <- function(...) stop(noquote(sprintf(...)), call. = FALSE)

handleCondition <-
    function(
        ...,
        condition,
        help_text = character(0L),
        messages = character(0L),
        nframe = 2L
    )
{
    msg <- list(paste0(...))
    if (!tolower(condition) %in% c("warning", "error", "note"))
        stop(
            "<Internal> Designate input with 'warning', 'error', or 'note'."
        )
    cl <- sys.call(sys.parent(n = nframe))[[1L]]
    ml <- structure(msg, .Names = tail(as.character(cl), 1L))
    .BiocCheck$add(
        ml,
        condition = condition,
        help_text = help_text,
        messages = messages
    )
    .BiocCheck$log
}

#' @importFrom cli symbol
handleCheck <- function(..., appendLF = TRUE)
{
    msg <- paste0(...)
    .BiocCheck$setCheck(msg)
    if (!interactive())
        cli::cli_text(paste("*", msg))
    else
        cli::cli_progress_step(msg = msg)
}

handleError <- function(...)
{
    handleCondition(..., condition = "error")
}

handleErrorFiles <- function(..., help_text = "Found in files:") {
    handleCondition(..., help_text = help_text, condition = "error")
}

handleWarning <- function(...)
{
    handleCondition(..., condition = "warning")
}

handleWarningFiles <- function(..., help_text = "Found in files:") {
    handleCondition(..., help_text = help_text, condition = "warning")
}

handleNote <- function(...)
{
    handleCondition(..., condition = "note")
}

handleNoteFiles <- function(..., help_text = "Found in files:") {
    handleCondition(..., help_text = help_text, condition = "note")
}

handleMessage <- function(..., indent = 4, exdent = 6)
{
    msg <- paste0(...)
    cli::cli_alert_info(msg, wrap = TRUE)
}

.tryInstallwLoad <- function(.BiocPackage, install_dir = tempfile()) {
    pkgpath <- .BiocPackage$sourceDir
    pkgname <- .BiocPackage$packageName
    if (!dir.exists(install_dir))
        dir.create(install_dir)
    dir.create(libdir <- file.path(install_dir, "lib"))
    file.create(stderr <- file.path(install_dir, "install.stderr"))

    r_libs_user <- paste(c(libdir, .libPaths()), collapse = .Platform$path.sep)
    lpath <- paste0("--library=", libdir)
    res <- callr::rcmd_safe(
        "INSTALL",
        c(
            "--use-vanilla",
            lpath,
            pkgpath
        ),
        env = c(callr::rcmd_safe_env(), R_LIBS_USER = r_libs_user)
    )

    if (!identical(res[["status"]], 0L))
        handleError(pkgpath, " must be installable and loadable.")

    install_dir
}

# Takes as input the value of an Imports, Depends,
# or LinkingTo field and returns a named character
# vector of Bioconductor dependencies, where the names
# are version specifiers or blank.
cleanupDependency <- function(input, remove.R = TRUE)
{
    if (is.null(input) || !nchar(input))
        return(character(0))
    output <- gsub("\\s", "", input)
    raw_nms <- output
    nms <- strsplit(raw_nms, ",")[[1]]
    namevec <- vector(mode = "character", length(nms))
    output <- gsub("\\([^)]*\\)", "", output)
    res <- strsplit(output, ",")[[1]]
    for (i in seq_along(nms))
    {
        if (grepl(">=", nms[i], fixed = TRUE))
        {
            tmp <- gsub(".*>=", "", nms[i])
            tmp <- gsub(")", "", tmp, fixed = TRUE)
            namevec[i] <- tmp
        } else {
            namevec[i] <- ''
        }
    }
    names(res) <- namevec
    if (remove.R)
        res <- res[which(res != "R")]
    res
}

get_deprecated_status_db_url <- function(version) {
    sprintf(
        "https://bioconductor.org/checkResults/%s/bioc-LATEST/meat-index.dcf",
        version
    )
}

#' @importFrom BiocFileCache BiocFileCache bfcquery bfcneedsupdate bfcdownload
#'   bfcrpath
get_status_file_cache <- function(url) {
    cache <- tools::R_user_dir("BiocCheck", "cache")
    bfc <- BiocFileCache(cache, ask = FALSE)

    bquery <- bfcquery(bfc, url, "rname", exact = TRUE)
    if (identical(nrow(bquery), 1L) && bfcneedsupdate(bfc, bquery[["rid"]]))
        bfcdownload(x = bfc, rid = bquery[["rid"]], ask = FALSE)

    bfcrpath(
        bfc,
        rnames = url,
        exact = TRUE,
        download = TRUE,
        rtype = "web"
    )
}

.STATUS_FILE_FIELDS <- c(
    "Package",
    "Version",
    "Maintainer",
    "MaintainerEmail",
    "PackageStatus",
    "UnsupportedPlatforms"
)

.SENTINEL_PACKAGE_STATUS <- matrix(
    ncol = length(.STATUS_FILE_FIELDS),
    dimnames = list(NULL, .STATUS_FILE_FIELDS)
)

.try_read_dcf <- function(file) {
    pkg_status <- try(
        {
            read.dcf(
                file,
                all = TRUE,
                fields = .STATUS_FILE_FIELDS
            )
        },
        silent = TRUE
    )
    if (is(pkg_status, "try-error")) .SENTINEL_PACKAGE_STATUS else pkg_status
}

get_status_from_dcf <- function(status_file) {
    pkg_status <- .try_read_dcf(status_file)
    is_deprecated <- pkg_status[, "PackageStatus"] == "Deprecated" &
        !is.na(pkg_status[, "PackageStatus"])
    names(is_deprecated) <- pkg_status[, "Package"]
    is_deprecated
}

get_deprecated_status <- function(version) {
    if (version %in% c("release", "devel"))
        version <- BiocManager:::.version_bioc(version)
    status_file_url <- get_deprecated_status_db_url(version)
    status_file <- get_status_file_cache(status_file_url)
    get_status_from_dcf(status_file)
}

getAllDeprecatedPkgs <- function()
{
    ## use the more complete BiocPkgTools::biocBuildReport to identify
    ## deprecated packages rather than using the VIEWS files
    deps_release <- get_deprecated_status("release")
    deps_devel <- get_deprecated_status("devel")

    union(
        names(deps_release[deps_release]),
        names(deps_devel[deps_devel])
    )
}

.getDirFiles <- function(fpaths) {
    if (!BiocBaseUtils::isCharacter(fpaths, zchar = TRUE, na.ok = TRUE))
        stop("<internal> 'fpaths' input must be a character vector")
    vapply(
        fpaths,
        function(fpath) {
            if (nzchar(fpath) && !is.na(fpath))
                fpath <- file.path(basename(dirname(fpath)), basename(fpath))
            fpath
        },
        character(1L)
    )
}

.RdTags <- tools:::RdTags

docType <- function(rd, tags) {
    if (missing(tags))
        tags <- .RdTags(rd)
    .tagsExtract(rd, tags, "\\docType")
}

getVigEngine <- function(vignetteFile) {
    lines <- readLines(vignetteFile, n = 100L, warn = FALSE)
    vigEngine <- grep(lines, pattern = "VignetteEngine", value = TRUE)
    vigEngine <- trimws(vigEngine)
    gsub("%\\s*\\\\VignetteEngine\\{(.*)\\}", "\\1", vigEngine)
}

getVigEnginePkg <- function(vignetteFile) {
    vigEngineField <- getVigEngine(vignetteFile)
    if (length(vigEngineField))
        head(strsplit(vigEngineField, "::", fixed = TRUE)[[1L]], 1L)
    else
        NA_character_
}

isEngineInBuilder <- function(vignetteFile, builder) {
    eng <- getVigEnginePkg(vignetteFile)
    !is.na(eng) && eng %in% builder
}

.load_data <- function(dataname, package) {
    env <- new.env(parent = emptyenv())
    data(list = dataname, package = package, envir = env)
    env[[dataname]]
}

getParent <- function(view, biocViewsVocab)
{
    topLevel <- c("Software", "ExperimentData", "AnnotationData", "Workflow")
    if (view %in% topLevel)
        return(view)
    parent <- ""
    for (level in topLevel) {
        if (view %in% names(acc(biocViewsVocab, level)[[level]])) {
            parent <- level
            break
        }
    }
    parent
}

.FUNCTION_LENGTHS_SENTINEL <- list(
    data.frame(
        length = integer(0L),
        startLine = integer(0L),
        endLine = integer(0L),
        codingLines = integer(0L)
    )
)

getFunctionLengths <- function(df) {
    df <- df[df$terminal & df$parent > -1, ]

    # Identify comment-only lines
    is_comment_only_line <- df$token == "COMMENT" &
        !(duplicated(df$line1) | duplicated(df$line1, fromLast = TRUE))

    # Create a lookup table for comment-only lines
    comment_lines <- unique(df$line1[is_comment_only_line])

    all_lines <- unique(df$line1)

    rownames(df) <- NULL
    max <- nrow(df)
    res <- list()
    funcRows <- df[df$token %in% c("FUNCTION", "'\\\\'"), ]
    lst <- lapply(split(df, rownames(df)), as.list)

    if (!nrow(funcRows))
        return(.FUNCTION_LENGTHS_SENTINEL)

    for (i in seq_len(nrow(funcRows))) {
        funcRowId <- as.integer(rownames(funcRows)[i])
        funcRow <- funcRows[as.character(funcRowId), ]
        funcStartLine <- funcRow$line1 # this might get updated later
        funcLines <- NULL
        funcName <- "_anonymous_"

        # attempt to get function name
        if (funcRowId >= 3) {
            up1 <- lst[[as.character(funcRowId - 1)]]
            up2 <- lst[[as.character(funcRowId - 2)]]
            if (
                up1$token %in%
                    c("EQ_ASSIGN", "LEFT_ASSIGN", "EQ_SUB") &&
                    up2$token %in% c("SYMBOL", "SYMBOL_SUB")
            ) {
                funcName <- up2$text
                funcStartLine <- up2$line1
            }
        }

        findFunctionEnd <- function() {
            parent_level <- funcRow$parent
            last_valid_row <- NULL

            for (j in seq((funcRowId + 1), max)) {
                curr_row <- lst[[as.character(j)]]
                if (curr_row$parent > parent_level) {
                    return(j - 1)
                }
                if (curr_row$parent > 0) {
                    last_valid_row <- j
                }
                if (j == max) {
                    return(max)
                }
            }
            return(last_valid_row)
        }

        # Get end line and calculate metrics
        end_row_id <- findFunctionEnd()
        end_row <- lst[[as.character(end_row_id)]]
        endLine <- end_row$line2
        funcLines <- endLine - (funcStartLine - 1)

        # Count coding lines
        function_lines <-
            all_lines[all_lines >= funcStartLine & all_lines <= endLine]
        function_comment_lines <- comment_lines[
            comment_lines >= funcStartLine & comment_lines <= endLine
        ]
        coding_line_count <- length(
            setdiff(function_lines, function_comment_lines)
        )

        # Store results
        if (funcName == "_anonymous_")
            funcName <- paste0(funcName, ".", funcStartLine)

        res[[funcName]] <- c(
            length = funcLines,
            startLine = funcStartLine,
            endLine = endLine,
            codingLines = coding_line_count
        )
    }
    res
}

doesManPageHaveRunnableExample <- function(rd)
{
    hasExamples <-
        lapply(rd, function(x) attr(x, "Rd_tag") == "\\examples") |>
        unlist() |>
        any()

    if (!hasExamples)
        return(FALSE)

    ex <- character()
    tc <- textConnection("ex", "w", local = TRUE)
    tools::Rd2ex(rd, commentDontrun = TRUE, commentDonttest = TRUE, out = tc)
    close(tc)

    if (!length(ex))
        return(FALSE)

    parsed <- try(parse(text = ex), silent = TRUE)

    # if code contains only comments the length with be 0
    length(parsed) && !inherits(parsed, "try-error")
}

.getYAMLfront <- function(lines) {
    fm_idx <- grep("^---\\s*$", lines)
    if (length(fm_idx) && length(fm_idx) >= 2L)
        lines[seq(fm_idx[1L], fm_idx[2L])]
}

.isNULLorFALSE <- function(x) {
    is.null(x) || isFALSE(x)
}

is_valid_author_tree <- function(x) {
    if (is.null(x) || is.atomic(x))
        return(TRUE)

    if (is.symbol(x) && !nzchar(as.character(x)))
        return(TRUE)

    if (is.symbol(x))
        return(as.character(x) %in% c("c", "person"))

    if (is.call(x)) {
        func_name <-
            if (is.call(x[[1L]])) deparse(x[[1L]]) else as.character(x[[1L]])

        if (!func_name %in% c("c", "person"))
            return(FALSE)

        args <- as.list(x[-1L])
        return(
            all(
                vapply(args, is_valid_author_tree, logical(1L))
            )
        )
    }
    FALSE
}

#' Report context of events to user with a data.frame of events and locations
#'
#' Report context of events to user with a data.frame of events and locations
#'
#'
#' @param file character(1) full path (including package name) of file being
#'   summarized.
#'
#' @param lines character() vector of text lines in file
#'
#' @param idx logical() same length as `lines` indicating lines in which
#'   event occurs
#'
#' @param offset `integer(1)` The number of lines to add to the 'Line' column
#'   calculation. It is mainly used to account for the number of lines that the
#'   YAML header occupies.
#'
#' @return Context: a data.frame() with columns File, Line, and Context
#' @keywords internal
Context <- function(file="", lines=character(), idx=logical(), offset = 0L) {
    stopifnot(
        BiocBaseUtils::isScalarCharacter(file, zchar = TRUE),
        BiocBaseUtils::isScalarInteger(offset)
    )
    data.frame(
        File = rep(.getDirFiles(file), sum(idx)),
        Line = which(idx) + offset,
        Context = lines[idx],
        stringsAsFactors=FALSE
    )
}

if (FALSE)
{
    library(testpkg0)
    require(testpkg0)
    library("testpkg0")
    require("testpkg0")
    library(package="testpkg0")
    library(package=testpkg0)
    require(package="testpkg0")
    require(package=testpkg0)
    require(package = teskpkg0)
    require('testpkg0')
    library('testpkg0')
    require(lib.loc=NULL, 
        package=testpkg0)
    #bad:
    require(help=testpkg0)
    require(lib.loc=NULL, help = 
    testpkg0)
}

## should not trigger T / F check
test1 <- function() {
    mat1 <- matrix(seq_len(20), nrow=5)
    x <- list(orig = mat1, T = t(mat1))
    x$T
}

## should trigger T / F check
test2 <- function() {
    x <- T
    x
}

test3 <- function(){
    T <- "whatsinaname"
    myX <- seq_len(2)
    names(myX) <- c(T , "rose")
    myX[ T ]
}

#' Check a package's adherence with the Bioconductor Package Guidelines
#'
#' Analyzes an R package for adherence with Bioconductor package guidelines and
#' best practices. The check outputs are categorized into ERROR, WARNING, and
#' NOTE. See the vignette for more details. `BiocCheck` is complementary
#' to `R CMD check`, which should always be run first.
#'
#' `BiocCheck()` reviews R packages for adherence with Bioconductor
#' package guidelines and best practices. See
#' <https://contributions.bioconductor.org> for the latest guidance for
#' writing Bioconductor software. Some rationale behind these best practices
#' can be seen in the vignette and pages in the `references` section. The
#' vignette also provides detailed explanations of all the checks performed by
#' `BiocCheck`.
#'
#' `BiocCheck` is called within R with `BiocCheck("package")`
#' where `package` points to the source directory or the `.tar.gz`
#' tarball that was created using `R CMD build`.
#'
#' **Note** that `BiocCheck` is complementary to `R CMD check`.
#' `R CMD check` should always be run first for best results.
#'
#' To skip installation of the package during the check, set the
#' `install` option to `FALSE` or `NULL`:
#' ```r
#' BiocCheck(package, install=FALSE)
#' ## OR
#' BiocCheck(package, install=NULL)
#' ```
#' To re-use an existing installation log file, set the `install` option
#' to the name of the installation log file.
#' For example, the following will put the `install_out.txt` log file in the
#' `<package_name>.BiocCheck` directory:
#' `BiocCheck(package, install="check:install_out.txt")`
#'
#' @section dot-options:
#' To use the dot-options, `BiocCheck` can be called with named arguments
#' corresponding to the options below. Typically, these options are set to
#' `TRUE` to disable specific checks, e.g.,
#' `BiocCheck(package, 'no-check-vignettes'=TRUE)`. Unless
#' otherwise stated, these options can be left unset (i.e., `NULL`) to enable
#' checks but `FALSE` can also be used to explicitly enable them. The available
#' options are:
#'
#'   * `build-output-file`: file containing `R CMD build` output, for
#'     additional analysis
#'   * `new-package`:  enable checks specific to new packages
#'   * `no-check-bbs`: disable BBS-specific checks (for non-BioC packages).
#'     Valid DESCRIPTION
#'   * `no-check-bioc-help`: disable check for registration on Bioconductor
#'   * `no-check-bioc-views`: disable biocViews-specific checks (for non-BioC
#'     packages)
#'     mailing list and support site
#'   * `no-check-coding-practices`: disable check for some common best coding
#'     practices
#'   * `no-check-CRAN`:  disable check for if package exists in CRAN
#'   * `no-check-dependencies`:  disable check for bad dependencies
#'   * `no-check-deprecated`:  disable check for usage of deprecated packages
#'   * `no-check-description`:  disable DESCRIPTION file checks
#'   * `no-check-file-size`:  disable check for individual file size
#'   * `no-check-formatting`:  disable checks for file formatting
#'   * `no-check-function-len`:  disable check for function length
#'   * `no-check-install-self`: disable check for require or library of
#'     itself
#'   * `no-check-library-calls`: disable check usage of functions that
#'     install or update packages
#'   * `no-check-man-doc`:  disable checks for man page documentation
#'   * `no-check-namespace`:  disable NAMESPACE file checks
#'   * `no-check-news`:  disable checks for NEWS file
#'   * `no-check-pkg-size`:  disable check for package tarball size
#'   * `no-check-R-ver`:  disable check for valid R version
#'   * `no-check-remotes`: disable check for usage of remote packages other
#'     than those hosted on CRAN or Bioconductor
#'   * `no-check-skip-bioc-tests`: disable check for tests that skip when on
#'     bioc
#'   * `no-check-unit-tests`:  disable checks for unit tests
#'   * `no-check-version-num`:  disable check for valid version number
#'   * `no-check-vignettes`:  disable vignette checks
#'   * `quit-with-status`:  enable exit code option when performing check
#'   * `install`: if `FALSE`, the package is not installed; otherwise, if not
#'     specified, the package is installed by default. Optionally, a
#'     `check:<file>` key-value pair is provided to identify the name of the
#'     installation output file which will be copied to the
#'     `<package_name>.BiocCheck` directory.
#'   * `libloc`: when `install` is specified, the library location where the
#'     package is installed. By default, this is `.libPaths()[1]`.
#'
#' @param package The path to an R package directory or tarball (`.tar.gz`).
#'   The `BiocCheck` function is intended to be run from the package
#'   directory; therefore, the current working directory (given by `getwd()`)
#'   is the default.
#'
#' @param checkDir The directory where the `BiocCheck` output directory will be
#'   stored. By default, it will be placed in the same directory as the package
#'   directory i.e., `dirname(pkg_dir)`.
#'
#' @param debug Whether to append the names of functions that correspond to
#' each condition raised by `BiocCheck` in the written log (i.e., in the
#' `'<package_name>.BiocCheck'` folder). This option is only relevant to
#' developers and contributors to `BiocCheck`.
#'
#' @param callr logical(1) Whether to use the `callr` package to run `BiocCheck`
#'   in an isolated R session to prevent namespace collisions.
#'
#' @param \dots See the `dot-options` details section for available options.
#'
#' @return `BiocCheck()` is chiefly called for the side effect of the check
#'   reporting. The function also creates a `<package_name>.BiocCheck` folder
#'   and returns a `BiocCheck` reference class with three main list elements:
#'
#' * **error**: Items to address before the package can be accepted
#'
#' * **warning**: Strongly suggested items that may require attention
#'
#' * **note**: Items to consider, though not required, before acceptance
#'
#' @author Dan Tenenbaum, Lori Shepherd, and Marcel Ramos
#'
#' @references <https://contributions.bioconductor.org>
#' @seealso [BiocCheck-class], [Message-class]
#'
#' @examples
#'
#' packageDir <- system.file("testpackages", "testpkg0", package="BiocCheck")
#' BiocCheck(packageDir, `quit-with-status`=FALSE)
#'
#' @export BiocCheck
BiocCheck <- function(
    package = getwd(),
    checkDir = dirname(package),
    debug = FALSE,
    callr = FALSE,
    ...
) {
    if (callr) {
        callr::r(
            function(...) { BiocCheck:::BiocCheckRun(...) },
            args = list(
                package = package, checkDir = checkDir, debug = debug, ...
            ),
            cmdargs = c("--no-echo", "--no-save", "--no-restore"),
            show = TRUE
        )
    } else {
        BiocCheckRun(
            package = package, checkDir = checkDir, debug = debug, ...
        )
    }
}

#' @importFrom BiocBaseUtils isScalarCharacter
BiocCheckRun <-
    function(package, checkDir, debug, ...)
{
    .BiocCheck$zero()
    package <- normalizePath(package)
    if (!file.exists(package) || !isScalarCharacter(package))
        .stop("Package directory or tarball provided does not exist.")
    # be careful here:
    if (identical(.Platform$OS.type, "windows"))
        package <- gsub("\\\\", "/", package)

    dots <- list(...)
    if (length(dots) == 1L && is.list(dots[[1]]))
        dots <- dots[[1]]               # command line args come as list

    oldwarn <- getOption("warn")
    oldwidth <- getOption("cli.width")
    on.exit({
        options(warn = oldwarn, cli.width = oldwidth)
    })
    options(warn = 1, cli.width = 80)

    .BiocPackage <- .BiocPackage$initialize(
        packageDir = package, checkDir = checkDir
    )

    ## consider merging these operations into one
    cli::cli_div(theme = list(.pkg = list(color = "orange")))
    cli::cli_rule("Installing {.pkg { .BiocPackage$packageName }}")

    install_param <- dots[["install"]]
    should_install <- is.null(install_param) || isTRUE(install_param)

    if (should_install) {
        package_install_dir <- .tryInstallwLoad(.BiocPackage)
        cli::cli_alert_success("Package installed successfully")
        libloc <- file.path(package_install_dir, "lib")
    } else {
        if (is.character(install_param)) {
            split_log <- strsplit(install_param, ":")[[1L]]
            inst_log <- utils::tail(split_log, n = 1L)
            on.exit({
                if (file.exists(inst_log))
                    file.copy(
                        from = inst_log,
                        to = file.path(
                            .BiocPackage$BiocCheckDir, basename(inst_log)
                        )
                    )
            }, add = TRUE)
        }
        libloc <- dots[["libloc"]] %||% .libPaths()[1L]
        package_install_dir <- .libPaths()[1L]
    }

    isBBS <- Sys.getenv("IS_BIOC_BUILD_MACHINE")
    onBBS <- nzchar(isBBS) && identical(tolower(isBBS), "true")
    hasAdmin <- nzchar(Sys.getenv("BIOC_DEVEL_PASSWORD"))

    .BiocCheck$addMetadata(
        BiocPackage = .BiocPackage, installDir = package_install_dir
    )
    cli::cli_rule("{.pkg { .BiocPackage$packageName }} session metadata")
    .BiocCheck$show_meta()
    cli::cli_rule("Running BiocCheck on {.pkg { .BiocPackage$packageName }}")

    # BiocCheck checks --------------------------------------------------------
    if (.isNULLorFALSE(dots[["no-check-deprecated"]])) {
        handleCheck("Checking for deprecated package usage...")
        checkDeprecatedPackages(.BiocPackage)
    }

    if (.isNULLorFALSE(dots[["no-check-remotes"]])){
        handleCheck("Checking for remote package usage...")
        checkRemotesUsage(.BiocPackage)
    }

    handleCheck("Checking for 'LazyData: true' usage...")
    checkLazyDataUsage(.BiocPackage)

    if (.isNULLorFALSE(dots[["no-check-version-num"]])){
        handleCheck("Checking version number...")
        if (!.BiocPackage$isSourceDir) {
            handleCheck("Checking for version number mismatch...")
            checkForVersionNumberMismatch(.BiocPackage)
        }

        if (isTRUE(dots[["new-package"]])) {
            handleCheck("Checking new package version number...")
            checkNewPackageVersionNumber(.BiocPackage)
        } else if (.isNULLorFALSE(dots[["new-package"]])) {
            handleCheck("Checking version number validity...")
            checkVersionNumber(.BiocPackage)
        }
    }

    if (.isNULLorFALSE(dots[["no-check-R-ver"]])) {
        handleCheck("Checking R version dependency...")
        checkRVersionDependency(.BiocPackage)
    }

    if (.isNULLorFALSE(dots[["no-check-pkg-size"]])){
        handleCheck("Checking package size...")
        if (.BiocPackage$isTar){
            checkPackageSize(.BiocPackage)
        } else {
            handleMessage("Skipped... only checked on source tarball", indent=4)
        }
    }

    if (.isNULLorFALSE(dots[["no-check-file-size"]])){
        handleCheck("Checking individual file sizes...")
        checkIndivFileSizes(.BiocPackage)
        checkDataFileSizes(.BiocPackage)
    }

    if (.isNULLorFALSE(dots[["no-check-bioc-views"]]))
    {
        handleCheck("Checking biocViews...")
        result <- checkBiocViews(.BiocPackage)
        if(result)
        {
            cli::cli_alert_info(
                "Search 'biocViews' at https://contributions.bioconductor.org"
            )
        }
    }

    if (.isNULLorFALSE(dots[["no-check-bbs"]])){
        handleCheck("Checking build system compatibility...")
        checkBBScompatibility(.BiocPackage)
    }

    if (.isNULLorFALSE(dots[["no-check-description"]])) {
        checkDESCRIPTIONFile(.BiocPackage)
    }

    if (.isNULLorFALSE(dots[["no-check-namespace"]]))
        checkNAMESPACE(.BiocPackage)

    handleCheck("Checking .Rbuildignore...")
    checkRbuildignore(.BiocPackage)

    handleCheck("Checking for stray BiocCheck output folders...")
    checkBiocCheckOutputFolder(.BiocPackage)

    if (!.BiocPackage$isTar) {
        handleCheck("Checking for inst/doc folders...")
        checkInstDocFolder(.BiocPackage)
    }

    if (.isNULLorFALSE(dots[["no-check-vignettes"]])) {
        handleCheck("Checking vignette directory...")
        checkVignetteDir(.BiocPackage)
        if ("build-output-file" %in% names(dots)) {
            handleCheck(
                "Checking whether vignette is built with 'R CMD build'..."
            )
            checkIsVignetteBuilt(dots[["build-output-file"]])
        }
    }

    if (.isNULLorFALSE(dots[["no-check-library-calls"]])){
        handleCheck("Checking package installation calls in R code...")
        checkPkgInstallCalls(.BiocPackage)
    }

    package_dir <- .BiocPackage$sourceDir
    package_name <- .BiocPackage$packageName
    parsedCode <- parseFiles(.BiocPackage)

    if (.isNULLorFALSE(dots[["no-check-install-self"]])){
        handleCheck(sprintf("Checking for library/require of %s...",
                            package_name))
        checkForLibraryRequire(.BiocPackage)
    }

    if (.isNULLorFALSE(dots[["no-check-coding-practices"]])){
        handleCheck("Checking coding practice...")
        checkCodingPractice(.BiocPackage, parsedCode)
    }

    if (.isNULLorFALSE(dots[["no-check-function-len"]])){
        handleCheck("Checking function lengths...")
        checkFunctionLengths(parsedCode, package_name)
    }

    if (.isNULLorFALSE(dots[["no-check-man-doc"]])){
        handleCheck("Checking man page documentation...")
        checkManDocumentation(.BiocPackage, libloc)
    }

    if (.isNULLorFALSE(dots[["no-check-news"]])){
        handleCheck("Checking package NEWS...")
        checkNEWS(package_dir)
    }

    if (.isNULLorFALSE(dots[["no-check-unit-tests"]])){
        handleCheck("Checking unit tests...")
        checkUnitTests(package_dir)
    }

    if (.isNULLorFALSE(dots[["no-check-skip-bioc-tests"]])){
        handleCheck("Checking skip_on_bioc() in tests...")
        checkSkipOnBioc(package_dir)
    }

    if (.isNULLorFALSE(dots[["no-check-formatting"]])){
        handleCheck(
            "Checking formatting of DESCRIPTION, NAMESPACE, ",
            "man pages, R source, and vignette source...")
        checkFormatting(.BiocPackage)
    }

    if (.isNULLorFALSE(dots[["no-check-CRAN"]]))
    {
        handleCheck("Checking if package already exists in CRAN...")
        checkIsPackageNameAlreadyInUse(package_name, "CRAN")
    }

    if (isTRUE(dots[["new-package"]]))
    {
        handleCheck("Checking if new package already exists in Bioconductor...")
        checkIsPackageNameAlreadyInUse(package_name, "BioCsoft")
        checkIsPackageNameAlreadyInUse(package_name, "BioCann")
        checkIsPackageNameAlreadyInUse(package_name, "BioCexp")
        checkIsPackageNameAlreadyInUse(package_name, "BioCworkflows")
        # TODO: add VIEWS files for books
        # checkIsPackageNameAlreadyInUse(package_name, "BioCbooks")
    }

    if (.isNULLorFALSE(dots[["no-check-bioc-help"]])) {
        handleCheck("Checking for bioc-devel mailing list subscription...")
        if (hasAdmin) {
            checkForBiocDevelSubscription(.BiocPackage)
        } else {
            handleNote(
                "Cannot determine whether maintainer is subscribed to the ",
                "Bioc-Devel mailing list (requires admin credentials). ",
                "Subscribe here: ",
                "https://stat.ethz.ch/mailman/listinfo/bioc-devel"
            )
        }

        handleCheck("Checking for support site registration...")
        checkForSupportSiteRegistration(.BiocPackage)
    }

    cli::cli_rule(
        left = paste0("BiocCheck v", packageVersion("BiocCheck"), " results")
    )
    cli::cli_text(
        paste0(
            "{symbol$cross} { .BiocCheck$getNum('error') } ERRORS | ",
            "{symbol$warning} { .BiocCheck$getNum('warning') } WARNINGS | ",
            "{symbol$info} { .BiocCheck$getNum('note') } NOTES\n"
        )
    )
    cli::cli_alert_info(
        paste0(
            "\nSee the { .BiocPackage$packageName }.BiocCheck folder and run\n",
            "  browseVignettes(package = 'BiocCheck')\n",
            "  for details."
        )
    )

    .BiocCheck$report(debug, onBBS)

    if (isTRUE(dots[["quit-with-status"]])) {
        errcode <- as.integer(.BiocCheck$getNum("error") > 0)
        q("no", errcode)
    }

    return(.BiocCheck)

}

checkDESCRIPTION <- function(.BiocPackage) {
    handleCheck("Checking if DESCRIPTION is well formatted...")
    if (!.BiocPackage$isValid) {
        handleError("DESCRIPTION is malformed.")
        handleMessage(.BiocPackage$readError)
    }
}

validMaintainer <- function(.BiocPackage) {
    if (.BiocPackage$isTar)
        return()
    handleCheck("Checking for valid maintainer...")
    dcf <- .BiocPackage$DESCRIPTION
    authr <- "Authors@R" %in% colnames(dcf)
    autmain <- c("Author","Maintainer") %in% colnames(dcf)
    if (authr && any(autmain))
        handleError(
            "Use Authors@R field not Author/Maintainer fields. Do not use both."
        )
    else if (any(autmain))
        handleError("Do not use Author/Maintainer fields. Use Authors@R.")
}

checkDESCRIPTIONFile <- function(.BiocPackage) {
    dcf <- .BiocPackage$DESCRIPTION

    checkLicenseForRestrictiveUse(dcf[, "License"])
    checkDESCfields(dcf)
    checkBiocDepsDESC(dcf)
    checkPinnedDeps(dcf)
    checkFndPerson(dcf)
}

checkRemotesUsage <- function(.BiocPackage)
{
    dcf <- .BiocPackage$DESCRIPTION
    if ("Remotes" %in% colnames(dcf))
        handleError(
            "Package dependencies must be on CRAN or Bioconductor.",
            " Remove 'Remotes:' from DESCRIPTION"
        )
}

checkNewPackageVersionNumber <- function(.BiocPackage)
{
    dcf <- .BiocPackage$DESCRIPTION
    version <- dcf[, "Version"]
    if (!grepl("^0+[-.][0-9]+[-.][0-9]+$", version))
        handleWarning(
            "New package x version starting with non-zero value ",
            "(e.g., 1.y.z, 2.y.z); got ", sQuote(version), ".")
    if (!grepl("^[0-9]+[-.]99[-.][0-9]+$", version))
        handleError(
            "New package 'y' version not 99 (i.e., x.99.z)",
            "; Package version: ", version
        )
}

checkForVersionNumberMismatch <- function(.BiocPackage)
{
    if (!.BiocPackage$isTar)
        return()
    tarfilename <- .BiocPackage$tarFilename
    ver <- tail(unlist(strsplit(tarfilename, "_|\\.tar\\.[xg]z")), 1L)
    dcf <- .BiocPackage$DESCRIPTION
    dcfVer <- unname(dcf[, "Version"])
    if (!identical(ver, dcfVer))
    {
        handleError(
            "Version number in tarball filename must match Version field ",
            "in DESCRIPTION. (Tip: create tarball with R CMD build)")
    }
}

checkLazyDataUsage <- function(.BiocPackage)
{
    dcf <- .BiocPackage$DESCRIPTION
    if ("LazyData" %in% colnames(dcf) &&
        tools:::str_parse_logic(dcf[, "LazyData"]))
        handleNote(
            "'LazyData:' in the 'DESCRIPTION' should be set to false or removed"
        )
}

checkVersionNumber <- function(.BiocPackage)
{
    version <- .BiocPackage$packageVersion
    regex <- "^[0-9]+[-\\.]([0-9]+)[-\\.][0-9]+$"
    if(!grepl(regex, version))
    {
        handleError(
            "Invalid package Version, see ",
            "https://contributions.bioconductor.org/versionnum.html"
        )
        return()
    }
    tryCatch({
        pv <- package_version(version)
    }, error = function(e) {
        handleError(conditionMessage(e))
    })
    x <- pv$major
    y <- pv$minor
    mod <- y %% 2
    isDevel <- identical(
        BiocManager:::.version_bioc("devel"), BiocManager::version()
    )
    bioc.mod <- as.numeric(isDevel)
    if (identical(x, 0L)) {
        handleMessage("Package version ", as.character(pv), "; pre-release")
    } else if (mod != bioc.mod) {
        shouldBe <- ifelse(isDevel, "odd", "even")
        vers <- ifelse(isDevel, "devel", "release")
        handleWarning(
            "y of x.y.z version should be ", shouldBe, " in ", vers
        )
    }
}

.PersonsFromDCF <- function(
    dcf,
    field = c("Authors@R", "Author"),
    .dreturn = NULL
) {
    field <- match.arg(field)
    if (identical(field, "Author"))
        return(dcf[, field])
    env <- new.env(parent = emptyenv())
    env[["c"]] <- c
    env[["person"]] <- utils::person
    pp <- parse(text = dcf[, field], keep.source = FALSE)
    if (is_valid_author_tree(pp[[1L]])) {
        eval(pp, env)
    } else {
        handleError("Malformed 'Authors@R' field in DESCRIPTION")
        return(.dreturn)
    }
}

.MainEmailAuthorsAtR <- function(dcf) {
    email <- NULL
    people <-
        .PersonsFromDCF(dcf, "Authors@R", .dreturn = NULL)
    for (person in people) {
        if ("cre" %in% person$role) {
            email <- person$email
            break
        }
    }
    email
}

.MainEmailMaintainer <- function(dcf) {
    res <- unname(
        gsub(".*<(.*)>", "\\1", dcf[, "Maintainer"])
    )
    if (!nzchar(res)) NULL else res
}

pullMaintainerEmail <- function(pkgpath) {
    desc <- file.path(pkgpath, "DESCRIPTION")
    stopifnot(file.exists(desc))
    dcf <- read.dcf(desc)
    if ("Maintainer" %in% colnames(dcf))
        .MainEmailMaintainer(dcf)
    else if ("Authors@R" %in% colnames(dcf))
        .MainEmailAuthorsAtR(dcf)
}

getMaintainerEmail <- function(.BiocPackage)
{
    # Eventually update this to just look at Authors@R
    # Since the intention is to possible start running
    # this on the daily builder, leave Maintainer field
    # check. This is used to check for mailing list registration
    dcf <- .BiocPackage$DESCRIPTION
    if ("Maintainer" %in% colnames(dcf))
        .MainEmailMaintainer(dcf)
    else if ("Authors@R" %in% colnames(dcf))
        .MainEmailAuthorsAtR(dcf)
}

checkRVersionDependency <- function(.BiocPackage) {
    dcf <- .BiocPackage$DESCRIPTION
    if ("Depends" %in% colnames(dcf)) {
        res <- cleanupDependency(dcf[, "Depends"], FALSE)
        verStr <- names(res)[res == "R"]
        if (isScalarCharacter(verStr)) {
            pkgVer <- package_version(verStr)
            RVer <- package_version(
                paste0(BiocManager:::.version_field("R"), ".0")
            )
            if (pkgVer < RVer)
                handleNote(
                    "Update R version dependency from ", pkgVer, " to ", RVer
                )
        }
    }
}

.LICENSE_DB_LOCATION <- "$R_HOME/share/licenses/license.db"

checkLicenseForRestrictiveUse <- function(license) {
    handleCheck("Checking License: for restrictive use...")

    if (!identical(length(license), 1L) || is.na(license)) {
        handleNote("malformed 'License:' field '", license, "'")
        return(invisible())
    }
    ldb_file <- file.path(R.home("share"), "licenses", "license.db")
    if (!file.exists(ldb_file)) {
        handleNote(
            "license database not found. ",
            "Expected location: '", ldb_file, "'. ",
            "License: '", license, "'"
        )
        return(invisible())
    }
    licenses <- read.dcf(ldb_file)
    result <- tools:::analyze_licenses(license, licenses)
    test <- result[["restricts_use"]]
    if (isTRUE(test))
        handleError("License '", license, "' restricts use")
    else if (is.na(test) || !result[, "is_verified"]) {
        handleNote(
            "License '", license, "' unknown; refer to ", .LICENSE_DB_LOCATION
        )
        handleMessage(
            "and https://choosealicense.com/appendix/ for more info.",
            indent = 6L
        )
    }
}

checkDESCfields <- function(dcf) {
    handleCheck("Checking for recommended DESCRIPTION fields...")
    fields <- c("URL", "BugReports")
    if ("Date" %in% colnames(dcf)) {
        date <- dcf[, "Date"]
        if (!grepl("^\\d{4}-\\d{2}-\\d{2}$", date))
            handleNote("'Date:' field format is not 'YYYY-MM-DD': ", date)
    }
    present <- fields %in% colnames(dcf)
    res <- fields[!present]
    if (length(res)) {
        notFields <- paste(shQuote(res), collapse = ", ")
        handleNote("Provide ", notFields, " field(s) in DESCRIPTION")
    }
}

checkBiocDepsDESC <- function(dcf, which = c("Depends", "Imports")) {
    handleCheck("Checking for Bioconductor software dependencies...")
    which_fields <- dcf[, colnames(dcf) %in% which]
    all_deps <- unlist(
        lapply(which_fields, function(x) strsplit(x, ",\\s*")[[1L]]),
        use.names = FALSE
    )
    all_deps <- gsub("(\\w+)\\s+\\(.*\\)$", "\\1", all_deps)
    all_deps <- all_deps[all_deps != "R"]
    repo <- BiocManager:::.repositories_bioc(BiocManager::version())["BioCsoft"]
    biocdb <- utils::available.packages(repos = repo)
    bioc_deps <- all_deps %in% rownames(biocdb)
    percent <- unname(round(prop.table(table(bioc_deps))["TRUE"], 2L) * 100)

    if (!any(bioc_deps)) {
        views <- .BiocPackage$getBiocViews()
        handleFUN <-
            if ("Infrastructure" %in% views) handleNote else handleWarning
        msg <- "No Bioconductor dependencies detected. Note that some
            infrastructure packages may not have Bioconductor dependencies.
            For more information, reach out to the Bioconductor community
            and/or consider a CRAN submission."
        handleFUN(msg)
    } else {
        handleMessage(
            "Bioconductor dependencies found in Imports & Depends (",
            percent,
            "%)."
        )
    }
}

checkPinnedDeps <- function(dcf) {
    handleCheck("Checking for pinned package versions in DESCRIPTION...")
    deps <- c("Depends", "Imports", "Suggests", "Enhances", "LinkingTo")
    validdeps <- deps[deps %in% colnames(dcf)]
    doubleeq <- grepl("==", dcf[, validdeps], fixed = TRUE)
    if (any(doubleeq))
        handleError("Dependencies in the DESCRIPTION file contain '=='")
}

checkFndPerson <- function(dcf) {
    handleCheck("Checking for 'fnd' role in Authors@R...")
    field <- if ("Authors@R" %in% colnames(dcf)) "Authors@R" else "Author"
    people <- .PersonsFromDCF(dcf, field, .dreturn = "")
    msg <- "No 'fnd' role found in Authors@R. If the work is supported
        by a grant, consider adding the 'fnd' role to the list of authors."
    if (!any(grepl("fnd", people, fixed = TRUE)))
        handleNote(msg)
}

source("helpers.R")

library(devtools)
library(tinytest)

.bioctest <- read_test_package("testpkg1")
dcf <- .bioctest$DESCRIPTION
BiocCheck:::checkFndPerson(dcf)
checkCounter(
    "No 'fnd' role", "note"
)


temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(pkgdir) {
        badfile <- file.path(pkgdir, "DESCRIPTION")
        writeLines(c(
            "Package: foo",
            "Version: 0.99.0",
            "Authors@R: person('Foo', 'Bar', email = 'foo.bar@email.com')",
            "License: GPL-2",
            "Depends: R (>= 4.0.0)"
        ), badfile)
    }
)
dcf <- .bioctest$DESCRIPTION
expect_identical(
    BiocCheck:::.PersonsFromDCF(dcf),
    person('Foo', 'Bar', email = 'foo.bar@email.com')
)
BiocCheck:::checkFndPerson(dcf)
checkCounter(
    "No 'fnd' role", "note"
)

.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(pkgdir) {
        badfile <- file.path(pkgdir, "DESCRIPTION")
        writeLines(c(
            "Package: foo",
            "Version: 0.99.0",
            paste0(
                "Authors@R: person(",
                "'Foo', 'Bar', email = 'foo.bar@email.com', ",
                "role = c('aut', 'cre', 'fnd'))"
            ),
            "License: GPL-2",
            "Depends: R (>= 4.0.0)"
        ), badfile)
    }
)
dcf <- .bioctest$DESCRIPTION
BiocCheck:::checkFndPerson(dcf)
expect_true(
    stillZero()
)

unlink(temp_dir, recursive = TRUE)

.filter_lookback <- function(index, parsedDF, lookback, text) {
    vapply(index, function(idx) {
        rangeLookback <- seq(idx - length(lookback), idx)
        setequal(
            parsedDF$text[rangeLookback], c(lookback, text)
        )
    }, logical(1L))
}

.getTokenTextCode <- function(
    parsedf, token, text, notLookback = character(0), hasLookback = character(0)
) {
    cond <- parsedf$token %in% token & parsedf$text %in% text
    if (length(notLookback) && any(cond)) {
        cond[cond] <- !.filter_lookback(which(cond), parsedf, notLookback, text)
    }
    if (length(hasLookback) && any(cond)) {
        cond[cond] <- .filter_lookback(which(cond), parsedf, hasLookback, text)
    }
    parsedf[
        cond,
        c("line1", "col1", "token", "text"),
        drop = FALSE
    ]
}

.grepTokenTextCode <- function(parsedf, token, text) {
    parsedf[
        parsedf$token %in% token & grepl(text, parsedf$text),
        c("line1", "col1", "token", "text"),
        drop = FALSE
    ]
}

findSymbolInParsedCode <-
    function(parsedCode, pkgname, symbolName, token, silent=FALSE)
{
    matches <- list()
    for (filename in names(parsedCode))
    {
        df <- parsedCode[[filename]]
        matchedrows <- df[which(df$token == token & df$text == symbolName),]
        if (nrow(matchedrows) > 0)
        {
            matches[[filename]] <- matchedrows[, c(1,2)]
        }
    }
    if (token == "SYMBOL_FUNCTION_CALL")
        parens <- "()"
    else
        parens <- ""
    for (name in names(matches))
    {
        x <- matches[[name]]
        for (i in nrow(x))
        {
            if (!silent)
            {
                if (grepl("\\.R$", name, ignore.case=TRUE))
                    handleMessage(sprintf(
                        "Found %s%s in %s (line %s, column %s)", symbolName,
                        parens, .getDirFiles(name), x[i,1], x[i,2]))
                else
                    handleMessage(sprintf(
                        "Found %s%s in %s", symbolName, parens,
                        .getDirFiles(name))) # FIXME test this
            }
        }
    }
    length(matches) # for tests
}

findSymbolsInParsedCode <-
    function(
        parsedCodeList, symbolNames, tokenTypes,
        FUN = .getTokenTextCode, fun = TRUE, ...
    )
{
    matches <- structure(vector("list", length(parsedCodeList)),
        .Names = names(parsedCodeList))
    allcombos <- expand.grid(
        tokenTypes = tokenTypes,
        symbolNames = symbolNames,
        stringsAsFactors = FALSE
    )
    tokenTypes <- allcombos[["tokenTypes"]]
    symbolNames <- allcombos[["symbolNames"]]

    for (filename in names(parsedCodeList)) {
        df <- parsedCodeList[[filename]]
        res <- Map(
            function(x, y) {
                FUN(parsedf = df, token = x, text = y, ...)
            },
            x= tokenTypes, y = symbolNames
        )
        res <- do.call(rbind.data.frame, res)
        matches[[filename]] <- res
    }

    matches <- Filter(nrow, matches)
    if (!length(matches))
        return(character(0L))

    matches <- lapply(names(matches), function(nm) {
        dframe <- matches[[nm]]
        dframe[["text"]] <- paste0(dframe$text,
            ifelse(dframe$token == "SYMBOL_FUNCTION_CALL", "()", ""))
        dframe[["filename"]] <- nm
        dframe
    })

    matches <- do.call(
        function(...) rbind.data.frame(..., make.row.names = FALSE),
        matches
    )
    matches[] <- lapply(matches, as.character)
    apply(matches, 1L, function(rowdf) {
        fmttxt <- "%s (line %s, column %s)"
        formt <- if (fun) paste0(rowdf["text"], " in ", fmttxt) else fmttxt
        sprintf(formt, .getDirFiles(rowdf["filename"]),
            rowdf["line1"], rowdf["col1"]
        )
    })
}

findSymbolsInRFiles <-
    function(.BiocPackage, Symbols, tokenType, fun = TRUE, ...)
{
    rfiles <- .BiocPackage$RSources
    parsedCodes <- lapply(
        structure(rfiles, .Names = rfiles), parseFile,
        .BiocPackage = .BiocPackage
    )
    msg_res <- findSymbolsInParsedCode(
        parsedCodeList = parsedCodes,
        symbolNames = Symbols,
        tokenTypes = tokenType,
        fun = fun, ...
    )
    unlist(msg_res)
}

.VigCodeChunkNo <- function(parsedf, tokens) {
    if (!nrow(tokens))
        return(integer(0L))
    sChunksInd <- .grepTokenTextCode(
        parsedf, "COMMENT", "^## -|^### code chunk"
    )[["line1"]]
    chunkNo <- vector("integer", nrow(tokens))
    for (i in seq_len(nrow(tokens))) {
        numrow <- tokens[["line1"]][i]
        chunkInd <- max(sChunksInd[sChunksInd < numrow])
        chunkNo[[i]] <- match(chunkInd, sChunksInd, nomatch = 0L)
    }
    chunkNo
}

findSymbolsInVignettes <-
    function(.BiocPackage, Symbols, tokenTypes, FUN = .getTokenTextCode, ...)
{
    vigfiles <- .BiocPackage$VigSources
    shortnames <- .getDirFiles(vigfiles)
    viglist <- structure(vector("list", length(vigfiles)), .Names = shortnames)
    for (i in seq_along(vigfiles)) {
        shortName <- shortnames[i]
        tempR <- tempfile(fileext=".R")
        try_purl_or_tangle(
            input = vigfiles[i],
            output = tempR,
            quiet = TRUE,
            documentation = 2L
        )
        pfile <- parseFile(.BiocPackage, tempR)
        tokens <- FUN(pfile, tokenTypes, Symbols, ...)
        chunkNos <- .VigCodeChunkNo(pfile, tokens)
        viglist[[shortName]] <- sprintf(
            "%s (chunk no. %d, line %d, column %d)",
            shortName, chunkNos, tokens[,"line1"], tokens[,"col1"]
        )
    }
    Filter(length, viglist)
}

.onLoad <- function(libname, pkgname) {
    ## download.file should not be used here
    if (FALSE) {
        download.file("https://httpbin.org/get", destfile = tempfile())
    }
}

.onAttach <- function(libname, pkgname) {
    if (FALSE) {
        downloader::download("https://httpbin.org/get", destfile = tempfile())
    }
}

function() {
}
fa = function() TRUE

# a bracketless function with <-
f2 <- function() TRUE

# a bracketed function with =
f3 = function()
{
    TRUE

}

# a bracketed function with <-
f4 <- function()
{
    TRUE
}

# an lapply with an anonymous function
lapply(LETTERS,
    function(x) {
    print(x)



})

# a function with arguments
f5 <- function(a, b, c) {}

f6 <- function(a=1, b, c) {}

f7 <- function(x, ...) {




}

# function with comments and blank lines
## DO NOT move without modifying unit test
f8 <- function(a) {
    # this is a comment
    b <- a + 1
    # blank space below

    return(b)
}

# Vignette Checks ---------------------------------------------------------

checkVignetteDir <- function(.BiocPackage)
{
    pkgdir <- .BiocPackage$sourceDir
    vigdir <- .BiocPackage$vignettesDir

    if (!dir.exists(vigdir)) {
        handleError("No 'vignettes' directory.")
        return()
    }

    vigdircontents <- .BiocPackage$VigSources
    if (!length(vigdircontents)) {
        handleError("No vignette sources in vignettes/ directory.")
        return()
    }

    checkInstContents(.BiocPackage)

    checkVigFiles(.BiocPackage)

    checkVigBuilder(.BiocPackage)

    checkVigMetadata(vigdircontents)

    checkVigTypeRNW(.BiocPackage)

    checkVigTypeQMD(.BiocPackage)

    checkVigEngine(.BiocPackage)

    checkVigSuggests(.BiocPackage)

    checkVigTemplate(vigdircontents)

    checkVigChunkEval(vigdircontents)

    checkDupChunkLabels(vigdircontents)

    checkChunkLabels(vigdircontents)

    checkVigBiocInst(.BiocPackage)

    checkVigInstalls(.BiocPackage)

    checkVigClassUsage(.BiocPackage)

    checkTFSymbolUsage(.BiocPackage)

    checkVigSessionInfo(.BiocPackage)

    checkVigEvalAllFalse(.BiocPackage)
}

checkInstContents <- function(.BiocPackage)
{
    instdocdir <- file.path(.BiocPackage$sourceDir, "inst", "doc")
    contents <- list.files(
        instdocdir,
        pattern = "\\.Rmd$|\\.Rnw$|\\.Rrst$|\\.Rhtml$|\\.Rtex$",
        ignore.case = TRUE, full.names = TRUE
    )
    if (length(contents) && .BiocPackage$isSourceDir)
        handleWarning(
            "Remove vignette sources from inst/doc; ",
            "they belong in vignettes/."
        )
}

checkVigFiles <- function(.BiocPackage) {
    vigdir <- .BiocPackage$vignettesDir
    vigdircontents <- .BiocPackage$VigSources
    vigs <- tolower(basename(vigdircontents))
    allvigfiles <- setdiff(
        tolower(
            list.files(
                vigdir, all.files = TRUE, ignore.case = TRUE, recursive = TRUE
            )
        ),
        vigs
    )

    if (length(allvigfiles) != 0) {
        badFiles <- unlist(lapply(vigs,
                           FUN = function(x, allvigfiles){
                               vl <- tools::file_path_sans_ext(x)
                               badext <- c(".tex", ".html", ".pdf",
                                           ".aux", ".log")
                               ext <- paste0(vl, badext)
                               fnd <- intersect(allvigfiles, ext)
                               fnd
                           },
                           allvigfiles = allvigfiles))
        if (length(badFiles) != 0){
            handleNote(
                "Potential intermediate files found:",
                messages = paste0("vignettes/", badFiles)
            )
        }
    }
}

checkVigBuilder <- function(.BiocPackage)
{
    builders <- .BiocPackage$VigBuilder
    builders <- builders[builders != "Sweave"]
    if (!length(builders))
        return()
    vigdircontents <- .BiocPackage$VigSources
    # check DESCRIPTION is in at least one vignette
    vigExt <- tolower(tools::file_ext(vigdircontents))
    vigdircontents <- vigdircontents[vigExt != "rnw"]

    badBuilder <- character(0)
    for (builder in builders) {
        res <- vapply(
            vigdircontents, isEngineInBuilder, logical(1), builder = builder
        )
        if (any(!res, na.rm=TRUE)) {
            badBuilder <- c(badBuilder, builder)
        }
    }
    # check if a listed builder is not found in any vignette
    if (length(badBuilder)) {
        handleError(
            "'VignetteBuilder' listed in DESCRIPTION but not ",
            "found as 'VignetteEngine' in any vignettes:",
            messages = badBuilder
        )
    }
}

checkVigTypeRNW <- function(.BiocPackage) {
    vigdircontents <- .BiocPackage$VigSources
    vigExt <- tolower(tools::file_ext(vigdircontents))
    isRNW <- vigExt == "rnw"
    vigNames <- basename(vigdircontents[isRNW])
    if (length(vigNames))
        handleWarning(
            "Use RMarkdown instead of Sweave 'Rnw' vignettes.",
            help_text = "Rnw vignette(s) found:",
            messages = vigNames
        )
}

checkVigTypeQMD <- function(.BiocPackage) {
    vigdircontents <- .BiocPackage$VigSources
    vigExt <- tolower(tools::file_ext(vigdircontents))
    isQMD <- vigExt == "qmd"
    vigNames <- basename(vigdircontents[isQMD])
    desc <- .BiocPackage$DESCRIPTION
    if (length(vigNames)) {
        if (!"SystemRequirements" %in% colnames(desc))
            handleWarning(
                "Quarto vignette found but 'SystemRequirements'",
                " field not in DESCRIPTION."
            )
        else if (!grepl("quarto", desc[, "SystemRequirements"]))
            handleWarning(
                "Quarto vignette found but 'SystemRequirements'",
                " does not list 'quarto'."
            )
    }
}

checkVigMetadata <- function(vigdircontents)
{
    badVig <- character(0)
    vigExt <- tolower(tools::file_ext(vigdircontents))
    dx <- which(!vigExt %in% c("rnw", "rhtml"))
    vigdircontents <- vigdircontents[dx]
    for (file in vigdircontents) {
        lines <- readLines(file, n=100L, warn=FALSE)
        idx <- grep(lines, pattern="vignette:")
        if (length(idx) == 0L)
            badVig <- c(badVig, basename(file))
    }
     if (length(badVig) != 0L){
        handleWarning(
            "Vignette(s) missing Vignette metadata. See ",
            "https://r-pkgs.org/vignettes.html",
            help_text = "Update the following files:",
            messages = badVig
        )
    }
}

checkVigEngine <- function(.BiocPackage)
{
    builder <- .BiocPackage$VigBuilder
    vigdircontents <- .BiocPackage$VigSources
    # check Engines are in DESCRIPTION
    vigExt <- tolower(tools::file_ext(vigdircontents))
    vigdircontents <- vigdircontents[vigExt != "rnw"]

    # check for very rare case that multiple build
    # engines specified in vignette
    res <- lapply(vigdircontents, getVigEngine)
    if (any(lengths(res) > 1L)) {
        handleErrorFiles(
            "More than one VignetteEngine specified.",
            messages = names(which(lengths(res) > 1L))
        )
    }
    # check for missing engine
    if (any(!lengths(res))) {
        handleError(
            "No 'VignetteEngine' specified in vignette.",
            help_text = "Add 'VignetteEngine' to the following files:",
            messages = names(res[!lengths(res)])
        )
    }
    vigdircontents <- vigdircontents[lengths(res) == 1L]
    if (length(vigdircontents)) {
        res <- vapply(
            vigdircontents, isEngineInBuilder, logical(1), builder = builder
        )
        # check for missing engine in DESCRIPTION
        if (any(!res)) {
            handleError(
                "'VignetteEngine' specified but not in the DESCRIPTION.",
                help_text =
                    "Add 'VignetteEngine' to DESCRIPTION from the following:",
                messages = names(res[!res])
            )
        }
        # check for missing engine in vignette
        if (anyNA(res)) {
            nadx <- which(is.na(res))
            files <- names(res[nadx])
            if (is.null(builder))
                files <- c(files, "DESCRIPTION")
            handleError(
                "No 'VignetteEngine' specified in vignette or DESCRIPTION. ",
                help_text = paste(
                    "Add a 'VignetteEngine' to the following files or",
                    "a default 'VignetteBuilder' in DESCRIPTION: "
                ),
                messages = files
            )
        }
    }
}

checkVigSuggests <- function(.BiocPackage)
{
    builder <- .BiocPackage$VigBuilder
    vigdircontents <- .BiocPackage$VigSources
    vigExt <- tolower(tools::file_ext(vigdircontents))
    res <- lapply(vigdircontents, getVigEnginePkg)
    lst <- unique(c(unlist(unname(res)), builder))
    if (any(is.na(lst)))
        lst <- lst[!is.na(lst)]
    dep <- .BiocPackage$dependencies
    if (!all(lst %in% dep)){
        handleWarning(
            "Package listed as VignetteEngine or VignetteBuilder ",
            "but not currently Suggested. ",
            help_text = "Add the following to Suggests in DESCRIPTION:",
            messages = lst[!(lst %in% dep)]
        )
    }
}

checkVigTemplate <- function(vigdircontents)
{
    badVig <- character(0)
    badVig2 <- character(0)
    for (file in vigdircontents) {
        lines <- readLines(file, warn=FALSE)
        if (tolower(tools::file_ext(file)) %in% c("rmd", "qmd"))
            lines <- .getYAMLfront(lines)
        idx <- grep(lines, pattern="VignetteIndexEntry", fixed = TRUE)
        if (length(idx)) {
            title <- tolower(gsub(".*\\{|\\}.*", "", lines[idx]))
            if (identical(title, "vignette title"))
                badVig <- c(badVig, basename(file))
        }
        if (!length(idx))
            badVig2 <- c(badVig2, basename(file))
    }
    if (length(badVig))
        handleWarning(
            "Vignette(s) still using 'VignetteIndexEntry{{Vignette Title}}' ",
            help_text = "The following files use template defaults:",
            messages = badVig
        )
    if (length(badVig2))
        handleWarning(
            "Vignette(s) missing '\\%VignetteIndexEntry{{Vignette Title}}'. ",
            help_text = "Update the following files:",
            messages = badVig2
        )
}

detect_non_eval_chunks <- function(lines, vignetteType) {
    non_eval_pattern <- switch(
        vignetteType,
        qmd = "^[\t >]*```+\\{\\{r\\s*\\w*\\}\\}$",
        rmd = "^[\t >]*```+\\s*$",
        rnw = "\\\\begin\\{verbatim\\}",
        rhtml = "$.^"
    )
    non_eval_chunk_lines <- grep(non_eval_pattern, lines)
    chunk_patterns_end <- switch(
        vignetteType,
        qmd = ,
        rmd = knitr::all_patterns[["md"]]$chunk.end,
        rnw = knitr::all_patterns[["rnw"]]$chunk.end,
        rhtml = knitr::all_patterns[["html"]]$chunk.end
    )
    chunk_ends <- grep(chunk_patterns_end, lines)

    if (!identical(vignetteType, "rmd")) {
        for (i in seq_along(non_eval_chunk_lines)) {
            next_end_index <-
                which(chunk_ends > non_eval_chunk_lines[i])[1L]
            if (!is.na(next_end_index))
                chunk_ends <- chunk_ends[-next_end_index]
        }
    }

    chunk_patterns_start <- switch(
        vignetteType,
        qmd =  "^[\t >]*```+\\s*\\{r",
        rmd = knitr::all_patterns[["md"]]$chunk.begin,
        rnw = knitr::all_patterns[["rnw"]]$chunk.begin,
        rhtml = knitr::all_patterns[["html"]]$chunk.begin
    )
    chunk_starts <- setdiff(
        grep(chunk_patterns_start, lines), non_eval_chunk_lines
    )

    for (i in seq_along(chunk_starts)) {
        next_end_index <- which(chunk_ends > chunk_starts[i])[1L]
        if (!is.na(next_end_index)) {
            if (identical(vignetteType, "rmd"))
                non_eval_chunk_lines <- non_eval_chunk_lines[
                    non_eval_chunk_lines != chunk_ends[next_end_index]
                ]
            chunk_ends <- chunk_ends[-next_end_index]
        }
    }
    if (length(chunk_ends) && identical(vignetteType, "rmd"))
        non_eval_chunk_lines <- chunk_ends[c(TRUE, FALSE)]

    eval_false_lines <- 0L
    if (identical(vignetteType, "qmd"))
        eval_false_lines <- grep("#\\|\\s*eval\\s*:\\s*F(ALSE)?", lines, TRUE)
    else
        eval_false_lines <- grep(
            "eval\\s*=\\s*F(ALSE)?", lines[chunk_starts], TRUE
        )

    list(
        total = c(length(chunk_starts), length(non_eval_chunk_lines)),
        eval_false = length(eval_false_lines),
        non_eval = length(non_eval_chunk_lines)
    ) |>
        lapply(
            function(values)
                as.integer(sum(values))
        )
}

.CHUNKS_SENTINEL <- list(
    total = 0L,
    eval_false = 0L,
    non_eval = 0L
)

checkVigChunkEval <- function(vigdircontents)
{
    results <- lapply(
        vigdircontents,
        function(file) {
            lines <- readLines(file, warn=FALSE)
            vigExt <- tolower(tools::file_ext(file))
            if (!vigExt %in% c("rmd", "qmd", "rnw", "rhtml"))
                .CHUNKS_SENTINEL
            else
                detect_non_eval_chunks(lines, vigExt)
        }
    )

    combined <- Reduce(
        function(x, y) {
            list(
                total = x$total + y$total,
                eval_false = x$eval_false + y$eval_false,
                non_eval = x$non_eval + y$non_eval
            )
        },
        results,
        init = .CHUNKS_SENTINEL
    )

    totnon <- combined$eval_false + combined$non_eval
    percent <-
        if (!combined$total && !totnon)
            0L
        else
            as.integer((totnon * 100 / combined$total))

    if (percent >= 50) {
        handleWarning("Evaluate more vignette chunks.")
        msg <- sprintf(
            "%s out of %s code chunks = %i%% unevaluated",
            totnon,
            combined$total,
            percent
        )
        handleMessage(msg, indent = 8)
        handleMessage(
            sprintf(
                "%s non-exec code chunk(s) (e.g., '```r')",
                combined$noneval
            ),
            indent = 8
        )
    }
}

checkVigEvalAllFalse <- function(.BiocPackage) {
    vigfiles <- .BiocPackage$VigSources
    shortnames <- .getDirFiles(vigfiles)
    viglist <- structure(
        vector("logical", length(vigfiles)), .Names = shortnames
    )
    for (i in seq_along(vigfiles)) {
        shortName <- shortnames[i]
        tempR <- tempfile(fileext=".R")
        try_purl_or_tangle(input = vigfiles[i], output = tempR, quiet = TRUE)
        pfile <- parseFile(.BiocPackage, tempR)
        symbolOK <- .getTokenTextCode(
            parsedf = pfile,
            token = "SYMBOL_FUNCTION_CALL",
            text = "set",
            hasLookback = c("opts_chunk", "$")
        )
        if (nrow(symbolOK)) {
            setRange <- .findSymbolRanges(pfile, "set", "SYMBOL_FUNCTION_CALL")
            if (length(setRange) > 1L)
                warning("More than one `opts_chunk$set()` in ", vigfiles[i])
            datarange <- pfile[unlist(setRange), ]
            viglist[[shortName]] <-
                grepl("eval=F", paste(datarange$text, collapse = ""))
        }
    }
    if (any(viglist)) {
        handleWarningFiles(
            " Vignette set global option 'eval=FALSE'",
            messages = names(viglist[viglist])
        )
    }
}

checkDupChunkLabels <- function(vigfiles) {
    viglist <- structure(
        vector("logical", length(vigfiles)),
        .Names = vigfiles
    )
    for (vfile in vigfiles) {
        tempR <- tempfile(fileext=".R")
        tryCatch({
            quiet_knitr_purl(input = vfile, output = tempR, quiet = TRUE)
        }, error = function(e) {
            viglist[[vfile]] <<- grepl(
                "Duplicate chunk label", conditionMessage(e), fixed = TRUE
            )
            if (viglist[[vfile]])
                invisible(NULL)
            else
                warning(e)
        })
    }
    if (any(viglist))
        handleErrorFiles(
            " Vignette(s) found with duplicate chunk labels",
            messages = basename(vigfiles[viglist])
        )
}

.hasAllChunkLabels <- function(
    viglines, type = c("rmd", "rnw", "qmd", "rhtml")
) {
    type <- match.arg(type)
    pattern <- switch(
        type,
        qmd = ,
        rmd = "^```\\{r",
        rnw = "^<<([^,>\\s]+)",
        rhtml = "^<!--\\s*begin.rcode"
    )
    sub <- switch(
        type,
        rmd = "```\\{r\\s([^,\\}]+).*\\}",
        rnw = "^<<\\s*([\\w-]+)\\s*(?:,.*)?>>=$",
        qmd = "#\\| label:",
        rhtml = "^<!--\\s*begin\\.rcode\\s+(?![^,]*=)([a-zA-Z0-9_-]+),?\\s*"
    )
    matches <- grep(pattern, viglines, value = TRUE)
    if (!length(matches))
        return(TRUE)
    if (identical(type, "qmd")) {
        labelIdx <- grep(sub, viglines)
        length(labelIdx) >= length(matches)
    } else {
        all(
            grepl(sub, matches, perl = TRUE)
        )
    }
}

checkChunkLabels <- function(vigfiles) {
    viglist <- structure(
        vector("logical", length(vigfiles)),
        .Names = vigfiles
    )
    for (vfile in vigfiles) {
        viglines <- readLines(vfile, warn = FALSE)
        vigext <- tolower(tools::file_ext(vfile))
        viglist[[vfile]] <- .hasAllChunkLabels(viglines, type = vigext)
    }
    if (!all(viglist))
        handleNoteFiles(
            " Vignette(s) found with missing chunk labels",
            messages = basename(vigfiles[!viglist])
        )
}

.OLD_INSTALL_CALLS <-
    c("BiocInstaller", "biocLite", "useDevel", "biocinstallRepos")

checkVigBiocInst <- function(.BiocPackage) {
    msg_return <- findSymbolsInVignettes(
        .BiocPackage,
        Symbols = .OLD_INSTALL_CALLS,
        tokenTypes = c("COMMENT", "SYMBOL_FUNCTION_CALL")
    )
    if (length(msg_return)) {
        handleWarningFiles(
            " BiocInstaller code found in vignette(s)",
            messages = msg_return
        )
    }
}

checkVigInstalls <- function(.BiocPackage) {
    match_return <- findSymbolsInVignettes(
        .BiocPackage,
        Symbols = .BAD_INSTALL_CALLS,
        tokenTypes = "SYMBOL_FUNCTION_CALL"
    )
    if (length(match_return))
        handleErrorFiles(
            "Package installation calls found in vignette(s)",
            messages = unlist(match_return, use.names = FALSE)
        )
    grep_return <- findSymbolsInVignettes(
        .BiocPackage,
        Symbols = ".*install[^ed].*",
        tokenTypes = "SYMBOL_FUNCTION_CALL",
        FUN = .grepTokenTextCode
    )
    if (length(grep_return))
        handleWarningFiles(
            "Potential package installation calls found in vignette(s)",
            messages = unlist(grep_return, use.names = FALSE)
        )
}

checkTFSymbolUsage <- function(.BiocPackage) {
    viglist <- findSymbolsInVignettes(.BiocPackage, c("T", "F"), "SYMBOL")
    if (length(viglist)) {
        handleWarningFiles(
            " Avoid T/F variables; If logical, use TRUE/FALSE",
            messages = unlist(viglist, use.names = FALSE)
        )
    }
}

## Completely suppress spurious knitr:::remind_sweave() warning that shows up
## in TclTk popup window in addition to the usual text-only warning.
quiet_knitr_purl <- function(...)
{
    args <- list(...)
    callr::r(
        function(...) suppressWarnings(knitr::purl(...)),
        args = args,
        env = c(CI = "true")
    )
}

purl_or_tangle <- function(input, output, quiet, ...) {
    vigEng <- getVigEnginePkg(input)
    vigExt <- tolower(tools::file_ext(input))
    if (!identical(vigExt, "rnw") || vigEng %in% c("knitr", "quarto"))
        quiet_knitr_purl(input = input, output = output, quiet = quiet, ...)
    else
        utils::Stangle(file = input, output = output, quiet = quiet)
}

try_purl_or_tangle <- function(input, output, quiet, ...) {
    tryCatch({
        purl_or_tangle(input = input, output = output, quiet = quiet, ...)
    }, error = function(e) {
        hasDups <- grepl(
            "Duplicate chunk label", conditionMessage(e), fixed = TRUE
        )
        if (hasDups) {
            file.create(output)
            invisible(NULL)
        } else {
            stop(e)
        }
    })
}

checkVigClassUsage <- function(.BiocPackage) {
    vigfiles <- .BiocPackage$VigSources
    viglist <- structure(
        vector("list", length(vigfiles)), .Names = basename(vigfiles)
    )
    for (vfile in vigfiles) {
        tempR <- tempfile(fileext=".R")
        try_purl_or_tangle(input = vfile, output = tempR, quiet = TRUE)
        tokens <- getClassNEEQLookup(tempR)
        viglist[[basename(vfile)]] <- sprintf(
            "%s (code line %d, column %d)",
            basename(vfile), tokens[,"line1"], tokens[,"col1"]
        )
    }
    viglist <- Filter(length, viglist)
    if (length(viglist)) {
        handleWarningFiles(
            " Avoid class membership checks with class() / is() and == / !=",
            "; Use is(x, 'class') for S4 classes",
            messages = unlist(viglist, use.names = FALSE)
        )
    }
}

checkVigSessionInfo <- function(.BiocPackage) {
    vigfiles <- .BiocPackage$VigSources
    notFoundVig <- structure(
        vector("logical", length(vigfiles)), .Names = vigfiles
    )
    for (vfile in vigfiles) {
        pc <- structure(
            list(parseFile(.BiocPackage, vfile)), .Names = vfile
        )
        if (nrow(pc[[vfile]])) {
            res <- findSymbolsInParsedCode(
                parsedCodeList = pc,
                symbolNames = c("sessionInfo", "session_info"),
                tokenTypes = "SYMBOL_FUNCTION_CALL"
            )
            if (!length(res))
                notFoundVig[[vfile]] <- TRUE
        }
    }
    if (any(notFoundVig)) {
        handleNote(
            " 'sessionInfo' not found in vignette(s)",
            help_text = "Missing from file(s):",
            messages = .getDirFiles(vigfiles[notFoundVig])
        )
    }
}

source("helpers.R")

library(devtools)
library(tinytest)

# vignettes0 --------------------------------------------------------------
.BiocCheck$zero()
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(path) {
        vigdir <- file.path(path, "vignettes")
        dir.create(vigdir, recursive = TRUE)
    }
)
BiocCheck:::checkVignetteDir(.bioctest)
checkCounter("No vignette sources in vignettes/ directory.", "error")
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir, description = list(Title = "unitTestTempDir"),
    extraActions = function(path) {
        vigdir <- file.path(path, "vignettes")
        dir.create(vigdir, recursive = TRUE)
        cat(
            "<<echo=FALSE, results=tex>>=\n## some code\n@\n",
            file = file.path(vigdir, "test.Rnw")
        )
    }
)
BiocCheck:::checkVignetteDir(.bioctest)
expect_true(
    any(
        grepl(
            pattern="VignetteIndexEntry",
            .BiocCheck$get("warning")[["checkVigTemplate"]]
        )
    )
)
expect_true(
    any(
        grepl(
            pattern="RMarkdown instead of Sweave",
            .BiocCheck$get("warning")[["checkVigTypeRNW"]]
        )
    )
)
expect_true(
    any(
        grepl(
            pattern="'sessionInfo' not found",
            .BiocCheck$get("note")[["checkVigSessionInfo"]]
        )
    )
)
expect_true(
    any(
        grepl(
            pattern="missing chunk labels",
            .BiocCheck$get("note")[["checkChunkLabels"]]
        )
    )
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(path) {
        instdoc <- file.path(path, "inst", "doc")
        dir.create(instdoc, recursive = TRUE)
        cat("nothing", file = file.path(instdoc, "test.rnw"))
    }
)
## check rnw file in inst/doc  WARNING
BiocCheck:::checkInstContents(.bioctest)
checkCounter(
    "Remove vignette sources from inst/doc", "warning"
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(path) {
        instdoc <- file.path(path, "inst", "doc")
        dir.create(instdoc, recursive = TRUE)
        cat("nothing", file = file.path(instdoc, "test.Rmd"))
    }
)
## check rmd file in inst/doc  WARNING
BiocCheck:::checkInstContents(.bioctest)
checkCounter(
    "Rmd file in inst/doc not seen as valid vignette source", "warning"
)
.BiocCheck$zero()

## check for Rnw vignettes, warn if any
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkVigTypeRNW(.bioctest)
expect_equivalent(
    .BiocCheck$getNum("warning"), 1L,
    info = "check for Rnw vignettes, warn if any"
)
.BiocCheck$zero()

## check for duplicate chunk labels
BiocCheck:::checkDupChunkLabels(
    .bioctest$VigSources["vignettes/dupChunks.Rmd"]
)
expect_true(
    any(
        grepl(
        pattern="duplicate chunk labels",
        .BiocCheck$get("error")[["checkDupChunkLabels"]]
        )
    )
)
.BiocCheck$zero()

## check for missing chunk labels in Rmd
BiocCheck:::checkChunkLabels(
    .bioctest$VigSources["vignettes/testpkg0.Rmd"]
)
expect_true(
    any(
        grepl(
            pattern="missing chunk labels",
            .BiocCheck$get("note")[["checkChunkLabels"]]
        )
    )
)
.BiocCheck$zero()

## check for missing chunk labels in qmd
BiocCheck:::checkChunkLabels(
    .bioctest$VigSources["vignettes/testpkg0.qmd"]
)
expect_true(
    any(
        grepl(
            pattern="missing chunk labels",
            .BiocCheck$get("note")[["checkChunkLabels"]]
        )
    )
)
.BiocCheck$zero()

## check for missing chunk labels in Rnw
BiocCheck:::checkChunkLabels(
    .bioctest$VigSources["vignettes/testpkg0.Rnw"]
)
expect_true(
    any(
        grepl(
            pattern="missing chunk labels",
            .BiocCheck$get("note")[["checkChunkLabels"]]
        )
    )
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir, description = list(VignetteBuilder = "knitr"),
    extraActions = function(path) {
        vigdir <- file.path(path, "vignettes")
        dir.create(vigdir, recursive = TRUE)
        cat(
            "% \\VignetteIndexEntry{header} \nnnothing",
            file = file.path(vigdir, "test.Rnw")
        )
    }
)
expect_silent(
    BiocCheck:::checkVigBuilder(.bioctest)
)
BiocCheck:::checkVigTypeRNW(.bioctest)
expect_equivalent(
    .BiocCheck$getNum("warning"), 1L
)
.BiocCheck$zero()

## check 'SystemRequirements' in DESCRIPTION for qmd
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkVigTypeQMD(.bioctest)
expect_true(
    grepl(
        pattern = "'SystemRequirements' field not in DESCRIPTION",
        .BiocCheck$get("warning")[["checkVigTypeQMD"]]
    )
)
.BiocCheck$zero()

## check for quarto in 'SystemRequirements' in DESCRIPTION
.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        VignetteBuilder = "quarto",
        SystemRequirements = "azcopy"
    ),
    extraActions = function(path) {
        vigdir <- file.path(path, "vignettes")
        dir.create(vigdir, recursive = TRUE)
        cat(
            "---\n",
            "%\\VignetteIndexEntry{A Quarto Vignette}\n",
            "%\\VignetteEngine{quarto}\n",
            "%\\VignetteEncoding{UTF-8}\n",
            "---\n\n",
            "# Quarto Vignette\n\n",
            "```{r}\n",
            "print('This is a Quarto vignette')\n",
            "```\n",
            sep = "",
            file = file.path(vigdir, "test.qmd")
        )
    }
)
BiocCheck:::checkVigTypeQMD(.bioctest)
expect_true(
    grepl(
        pattern = "'SystemRequirements' does not list 'quarto'",
        .BiocCheck$get("warning")[["checkVigTypeQMD"]]
    )
)

BiocCheck:::checkVigSessionInfo(.bioctest)
expect_true(
    any(
        grepl(
            pattern = "'sessionInfo' not found",
            .BiocCheck$get("note")[["checkVigSessionInfo"]]
        )
    )
)
.BiocCheck$zero()

.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkVigTemplate(.bioctest$VigSources["vignettes/testpkg0.Rmd"])
expect_true(
    any(
        grepl(
            pattern="VignetteIndex",
            .BiocCheck$get("warning")[["checkVigTemplate"]]
        )
    )
)
.BiocCheck$zero()

BiocCheck:::checkVigEvalAllFalse(.bioctest)
expect_true(
    any(
        grepl(
            "evalfalse.Rmd",
            .BiocCheck$get("warning")[["checkVigEvalAllFalse"]]
        )
    )
)
.BiocCheck$zero()

.bioctest <- read_test_package("testpkg2")
BiocCheck:::checkVigSuggests(.bioctest)
expect_true(
    any(
        grepl(
            pattern="VignetteBuilder",
            .BiocCheck$get("warning")[["checkVigSuggests"]]
        )
    )
)
.BiocCheck$zero()

BiocCheck:::checkVigEngine(.bioctest)
expect_true(
    any(
        grepl(
            pattern="VignetteEngine",
            .BiocCheck$get("error")[["checkVigEngine"]]
        )
    )
)
.BiocCheck$zero()

BiocCheck:::checkVigMetadata(.bioctest$VigSources["vignettes/testpkg0.Rmd"])
expect_true(
    any(
        grepl(
            pattern="missing vignette metadata", ignore.case = TRUE,
            .BiocCheck$get("warning")[["checkVigMetadata"]]
        )
    )
)
.BiocCheck$zero()

BiocCheck:::checkVigSuggests(.bioctest)
expect_true(
    any(
        grepl(
            pattern="not currently Suggested",
            .BiocCheck$get("warning")[["checkVigSuggests"]]
        )
    )
)
.BiocCheck$zero()

BiocCheck:::checkVigChunkEval(.bioctest$VigSources["vignettes/testpkg0.Rmd"])
expect_true(
    grepl(
        pattern="Evaluate more vignette chunks",
        .BiocCheck$get("warning")[["checkVigChunkEval"]]
    )
)
.BiocCheck$zero()

.bioctest <- read_test_package("testpkg2")
BiocCheck:::checkVigFiles(.bioctest)
expect_true(
    any(
        grepl(
            pattern="intermediate files found",
            .BiocCheck$get("note")[["checkVigFiles"]]
        )
    )
)
.BiocCheck$zero()

BiocCheck:::checkVigEvalAllFalse(.bioctest)
expect_true(
    any(
        grepl(
            "vignettes/testpkg0.Rmd",
            .BiocCheck$get("warning")[["checkVigEvalAllFalse"]],
            fixed = TRUE,
        )
    )
)
.BiocCheck$zero()

unlink(temp_dir, recursive = TRUE)

checkNAMESPACE <- function(.BiocPackage) {
    handleCheck("Checking NAMESPACE...")
    namespace <- file.path(.BiocPackage$sourceDir, "NAMESPACE")
    ns_lines <- readLines(namespace, warn = FALSE)
    hasEP <- grepl(
        'exportPattern.*\\[\\[:alpha:\\]\\]', ns_lines
    )
    if (any(hasEP)) {
        handleError(
            "'NAMESPACE' contains exportPattern with '[[:alpha:]]'; ",
            "use explicit exports instead."
        )
    }
}

source("helpers.R")

.BiocCheck$zero()
temp_dir <- tempfile()

## exportPattern with [[:alpha:]]
.BiocPackage <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(pkgdir) {
        cat("exportPattern('[[:alpha:]]')",
            file=file.path(pkgdir, "NAMESPACE"))
    }
)
BiocCheck:::checkNAMESPACE(.BiocPackage)
checkCounter("has exportPattern", "error")

## valid NAMESPACE
.BiocPackage <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(pkgdir) {
        cat("export(a, b, c)",
            file=file.path(pkgdir, "NAMESPACE"))
    }
)
BiocCheck:::checkNAMESPACE(.BiocPackage)
expect_true(stillZero())

unlink(temp_dir, recursive = TRUE)

bad_fun <- function(){

    update.packages("base")

    sapply(letters, function(x) x)
}

pasteTest <- function() {

    message(paste0("A", "B"))
    message ( paste("A", "B"))

    warning(paste("A", "B"), "C")
    warning(paste0("A", "B"), "C")

    stop("A", paste0("B", "C"))
    stop("A", paste("B", "C"))
}

invalid_ref <- function() {

    bcheck <- BiocCheck:BiocCheck
    red <- 1
    xbluex <- 3
    bcheck <- xbluex:red

}

bad_dl <- function() {

    dataurl <- "https://raw.githubusercontent.com/file.csv"
    githurl <- "https://github.com/user/package/"
    githurl <- "https://dropbox.com/data?dl=1"
    laburl <- "https://gitlab.com/raw/master/data.Rda"
    bucketurl <- "https://bitbucket.org/test/raw/file.sav"
    download.file(dataurl, destfile = tempfile())

}

bad_install <- function(pkg) {
    BiocManager::install(pkg)
}

bad_cat <- function() {
    cat("There is a cat here")
    ## except in show methods
    setMethod("show", signature = "character", function(obj) {
        cat("Cat is allowed here")
    })
}

bad_print <- function() {
    for (i in 1:10) {
        print("test")
    }
    print("Using print instead of message")
    lapply(c("A", "B"), print)
}

bad_assignment <- function() {
    # using = assignment
    value = "there is a equals assignment operator"
}

## This should not trigger
check_install <- function(pkg) {
    instPkgs <- installed.packages()
    pkg %in% rownames(instPkgs)
}

running_system <- function() {
    system("whoami")
}

check_inst_pkg <- function(pkg = "getPass") {
    check_install(pkg = pkg)
}

check_Dep_Defunct <- function() {
    .Deprecated("This function is deprecated")
    .Defunct("This function is defunct")
}

## test functions > 50 lines are reported
really_long_function <- function() {
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  return(TRUE)
}

## ----biocstyle_load, include=FALSE,results="hide",message=FALSE,warning=FALSE----
library(BiocStyle)

## ----libs, include=TRUE,results="hide",message=FALSE,warning=FALSE------------
library(BiocCheck)

## ----usage, eval=FALSE--------------------------------------------------------
# BiocCheck("<packageDirOrTarball>")

## ----install, eval = FALSE----------------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("BiocCheck")

## ----reformat_code, eval = FALSE----------------------------------------------
# ## Install styler if necessary
# if (!requireNamespace("styler", quietly = TRUE)) {
#     install.packages("styler")
# }
# ## Automatically re-format the R code in your package
# styler::style_pkg(transformers = styler::tidyverse_style(indent_by = 4))

## ----BiocCheckGitClone_usage, eval=FALSE--------------------------------------
# BiocCheckGitClone("packageDir")

## ----hidden_files_exts--------------------------------------------------------
BiocCheck:::.HIDDEN_FILE_EXTS

## ----citation_example---------------------------------------------------------
library(utils)
readCitationFile(
    system.file("CITATION", package = "GenomicRanges")
)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

parseFile <- function(.BiocPackage, infile) {
    dir.create(parse_dir <- tempfile())
    outfile <- file.path(parse_dir, "parseFile.tmp")
    if (grepl("\\.R$", infile, TRUE))
        outfile <- infile
    if (grepl("\\.Rnw$|\\.Rmd|\\.qmd|\\.Rrst|\\.Rhtml$|\\.Rtex", infile, TRUE))
    {
        vigBuilder <- .BiocPackage$VigBuilder
        if ("knitr" %in% vigBuilder)
            checkInstalled("knitr")
        suppressWarnings(suppressMessages(
            capture.output({
                try_purl_or_tangle(
                    input=infile, output=outfile, quiet = TRUE, documentation=0L
                )
            })
        ))
    } else if (grepl("\\.Rd$", infile, TRUE)) {
        rd <- .parse_Rd_pack(infile, usesRdpack = .BiocPackage$usesRdpack)
        code <- capture.output(tools::Rd2ex(rd))
        writeLines(code, con=outfile, sep="\n")
    }
    p <- parse(outfile, keep.source=TRUE)
    getParseData(p)
}

parseFiles <- function(.BiocPackage)
{
    rfiles <- .BiocPackage$RSources
    manfiles <- .BiocPackage$manSources
    vigfiles <- .BiocPackage$VigSources
    files <- c(rfiles, manfiles, vigfiles)
    parsedCode <- structure(vector("list", length(files)), .Names = files)
    for (file in files)
    {
        df <- parseFile(.BiocPackage, file)
        if (nrow(df))
            parsedCode[[file]] <- df
    }
    Filter(Negate(is.null), parsedCode)
}

#' @importFrom tools file_path_sans_ext file_ext parse_Rd Rd2ex
#' @importFrom utils capture.output data getParseData head packageDescription
#'   packageVersion globalVariables readCitationFile
#' @importFrom stringdist stringdistmatrix
#' @importFrom knitr purl
#' @importFrom BiocManager available install repositories version
#' @import biocViews methods

# Checks for BiocCheck ----------------------------------------------------

checkDeprecatedPackages <- function(.BiocPackage)
{
    allDepends <- .BiocPackage$dependencies
    allDeprecated <- getAllDeprecatedPkgs()
    if ("multicore" %in% allDepends)
    {
        handleError("Use 'BiocParallel' instead of 'multicore'. ",
            "'multicore' is deprecated and does not work on Windows."
        )
    }
    logVec <- allDeprecated %in% allDepends
    if (any(logVec)){
        handleError(
            "Package dependency in the DESCRIPTION is 'Deprecated'.",
            help_text = "Do not use the following package(s):",
            messages =  allDeprecated[logVec]
        )
    }
}

checkPackageSize <- function(.BiocPackage, size = 10) {
    pkg <- .BiocPackage$sourceDir
    pkgType <- .BiocPackage$packageType
    if (is.na(pkgType) ||  pkgType == "Software") {
        maxSize <- size*10^6 ## in MB
        pkgSize <- file.size(pkg)
        if (pkgSize > maxSize) {
            msgs <- c(
                paste0("Package Size: ",
                       as.character(round(pkgSize/(10^6),2)), " MB"),
                paste0("Size Requirement: ",
                       sprintf("%.2f", round(maxSize/(10^6),2)), " MB")
            )
            handleError(
                "Package tarball exceeds the Bioconductor size requirement.",
                messages = msgs
            )
        }
    }
}

.MAX_FILE_SIZE <- 5*10^6 ## 5MB
.DATA_DIRS <- c("data", "inst/extdata", "data-raw")

.filter_data <- function(filedf, for_data = FALSE) {
    files <- filedf[["path"]]
    data_dirs <- paste0(.DATA_DIRS, "/")
    hitmat <- vapply(
        data_dirs,
        grepl,
        logical(length(files)),
        x = files,
        fixed = TRUE
    )
    hits <- as.logical(rowSums(hitmat))
    decision <- if (for_data) force else `!`
    filedf[decision(hits), , drop = FALSE]
}

.in_data <- function(f) { f %in% .DATA_DIRS }

.hasPkg <- function(pkg) {
    suppressWarnings({
        nzchar(system.file(package = pkg))
    })
}

.findLargeFiles <- function(.BiocPackage, data_only) {
    pkgdir <- .BiocPackage$sourceDir
    gitignore <- file.exists(file.path(pkgdir, ".gitignore"))
    sourceDir <- .BiocPackage$isSourceDir && !.BiocPackage$isTar
    if (.hasPkg("gert") && gitignore && sourceDir) {
        fileinfo <- gert::git_ls(repo = pkgdir)
        fileinfo <- .filter_data(fileinfo, for_data = data_only)
        files <- unlist(
            fileinfo[fileinfo[["filesize"]] > .MAX_FILE_SIZE, "path"]
        )
        file.path(pkgdir, files)
    } else if (sourceDir) {
        folders <- list.dirs(pkgdir, full.names = FALSE, recursive = TRUE)
        decision <- if (data_only) force else Negate
        folders <- Filter(decision(.in_data), folders)
        files <- list.files(
            file.path(pkgdir, folders), full.names = TRUE, recursive = TRUE
        )
        filesizes <- file.size(files)
        files[filesizes > .MAX_FILE_SIZE]
    }
}

checkIndivFileSizes <- function(.BiocPackage)
{
    largefiles <- .findLargeFiles(.BiocPackage, data_only = FALSE)
    if (length(largefiles))
        handleWarning(
            "Package files exceed the 5MB size limit.",
            help_text = "Files over the limit: ",
            messages = largefiles
        )
}

checkDataFileSizes <- function(.BiocPackage) {
    largedata <- .findLargeFiles(.BiocPackage, data_only = TRUE)
    if (length(largedata))
        handleWarning(
            "Data files exceed the 5MB size limit.",
            help_text =
                "Use 'ExperimentHub' or 'AnnotationHub' for the files: ",
            messages = largedata
        )
}

.testRbuildignore <- function(text) {
    entries <- Filter(nchar,
        grep("^#", trimws(text), value = TRUE, invert = TRUE)
    )
    grepl("^\\^?(long)?tests[\\$\\/]?$", entries)
}

checkRbuildignore <- function(.BiocPackage) {
    pkgdir <- .BiocPackage$sourceDir
    rbuildfile <- file.path(pkgdir, ".Rbuildignore")
    if (file.exists(rbuildfile)) {
        rbuild <- readLines(rbuildfile)
        testIgnore <- .testRbuildignore(rbuild)
        if (any(testIgnore))
            handleError(
                ".Rbuildignore includes 'tests' or 'longtests' folder."
            )
    }
}

checkBiocCheckOutputFolder <- function(.BiocPackage) {
    pkgdir <- .BiocPackage$sourceDir
    pkg_name <- .BiocPackage$packageName
    alldirs <- list.dirs(pkgdir, full.names = FALSE)
    bioccheck_out_dir <- paste(pkg_name, "BiocCheck", sep = ".")
    if (bioccheck_out_dir %in% alldirs)
        handleError(
            "Remove '", bioccheck_out_dir, "' from the package directory"
        )
}

checkInstDocFolder <- function(.BiocPackage) {
    pkgdir <- .BiocPackage$sourceDir
    alldirs <- list.dirs(pkgdir, full.names = FALSE)
    instdocfiles <- list.files(file.path(pkgdir, "inst/doc"))
    if ("inst/doc" %in% alldirs && length(instdocfiles))
        handleError(
            "Remove 'inst/doc' folder from the package source"
        )
}

checkBiocViews <- function(.BiocPackage)
{
    invalid <- FALSE
    handleCheck("Checking that biocViews are present...")
    views <- .BiocPackage$getBiocViews()
    if (identical(length(views), 1L) && !nzchar(views)) {
        handleError("No biocViews terms found.")
        return(TRUE)
    }

    biocViewsVocab <- .load_data("biocViewsVocab", "biocViews")

    handleCheck("Checking package type based on biocViews...")
    type <- guessPackageType(views)
    cli::cli_alert(type)
    handleCheck("Checking for non-trivial biocViews...")
    toplevel <- c("Software", "AnnotationData", "ExperimentData", "Workflow")
    if (all(views %in% toplevel)) {
        handleError(
            "Add biocViews other than ",
            paste(unique(views), collapse = ", ")
        )
        return(TRUE)
    }

    parents <- vapply(views, getParent, character(1L), biocViewsVocab)
    parents <- Filter(nzchar, parents)

    handleCheck("Checking that biocViews come from the same category...")
    if (length(unique(parents)) > 1)
    {
        handleWarning("Use biocViews from one category only ",
            "(one of Software, ExperimentData, AnnotationData, Workflow)")
        return(TRUE)
    }
    branch <- unique(parents)
    # TODO: Fix this
    if (interactive())
        env <- environment()
    else
        env <- .GlobalEnv

    handleCheck("Checking biocViews validity...")
    if (!all(views %in% nodes(biocViewsVocab)))
    {
        badViews <- views[!(views %in% nodes(biocViewsVocab))]
        badViewsVec <- paste(badViews, collapse=", ")

        terms <- c(badViews, nodes(biocViewsVocab))
        distmat <- stringdistmatrix(terms, useNames="strings", method="lv")
        distmat <- as.matrix(distmat)
        distmat <- distmat > 0 & distmat < 3
        distmat[badViews, badViews] <- FALSE

        suggestedViews <- vapply(badViews, function(view) {
            alt <- colnames(distmat)[distmat[view,]]
            msg <- shQuote(view)
            if (length(alt)) {
                alt <- shQuote(alt)
                oneof <- if (length(alt) > 1L) "one of" else ""
                alt <- paste(oneof, paste(alt, collapse = ", "))
                msg <- paste0(msg, ": Did you mean", alt, "?")
            }
            msg
        }, character(1))

        handleWarning(
            "Invalid BiocViews term(s):", messages = unlist(suggestedViews)
        )
        invalid <- TRUE
    }

    if (packageVersion("biocViews") < package_version("1.33.9")) {
        ## conditional to keep the logic the same
        if (branch %in% c("Software", "AnnotationData", "ExperimentData"))
            branch <- gsub("data", "", tolower(branch))
    }

    handleCheck("Checking for recommended biocViews...")
    pkgdir <- .BiocPackage$sourceDir
    recommended <- try({
        recommendBiocViews(pkgdir, branch)[["recommended"]]
    }, silent = TRUE)

    if (!inherits(recommended, "try-error") && nzchar(recommended))
    {
        handleNote(
            "Consider adding these automatically suggested biocViews: ",
            recommended)
        invalid <- TRUE
    }
    return(invalid)
}

.conciseDescription <- function(.BiocPackage) {
    dcf <- .BiocPackage$DESCRIPTION
    if ("Description" %in% colnames(dcf)) {
        desc_field <- dcf[, "Description"]
        desc_words <- lengths(strsplit(desc_field, split = "[[:space:]]+"))
        desc_sentences <- length(
            strsplit(desc_field, split = "[.!?][[:space:]]+")[[1L]]
        )
        msg <- "The Description field in the DESCRIPTION is made up of less
            than 3 sentences. Provide a more detailed description of the
            package."

        # values chosen sensibly in a data-driven manner
        if (nchar(desc_field) < 50 || desc_words < 20)
            handleWarning(
                "Description field in the DESCRIPTION file is too concise"
            )
        else if (desc_sentences < 3)
            handleNote(paste(strwrap(msg), collapse="\n"))
    }
}

.checkORCID <- function(orcid)
{
    re <- "^[0-9]{4}-[0-9]{4}-[0-9]{4}-[0-9]{3}[0-9X]$"
    grepl(re, orcid)
}


checkBBScompatibility <- function(.BiocPackage)
{
    dcf <- .BiocPackage$DESCRIPTION
    pkgdir <- .BiocPackage$sourceDir

    handleCheck("Checking for proper Description: field...")
    checkDESCRIPTION(.BiocPackage)

    handleCheck("Checking for whitespace in DESCRIPTION field names...")
    if (any(grepl("\\s", colnames(dcf))))
    {
        handleError("Remove whitespace from DESCRIPTION field names.")
        return()
    }
    pkgNameFromDir <- basename(pkgdir)
    handleCheck("Checking that Package field matches directory/tarball name...")
    if (dcf[, "Package"] != pkgNameFromDir)
    {
        handleError(
            "Package directory '", pkgNameFromDir, "' must match Package: ",
            "field (got '", dcf[, "Package"], "')."
        )
        return()
    }
    handleCheck("Checking for Version: field...")
    if (!"Version" %in% colnames(dcf))
    {
        handleError("No 'Version:' field in DESCRIPTION.")
        return()
    }
    validMaintainer(.BiocPackage)

    maintainer <- NULL
    if ("Authors@R" %in% colnames(dcf)) {
        people <- .PersonsFromDCF(dcf)
        if (is.null(people) || !inherits(people, "person")) {
            handleError("Authors@R field must be valid 'person' object.")
            return()
        }
        maint <- vapply(
            people, function(person) { "cre" %in% person$role }, logical(1)
        )
        if (sum(maint) > 1) {
            handleError("Designate only one maintainer with Authors@R [cre].")
        }
        if (!any(maint)) {
            handleError("No Authors@R maintainer [cre] field in DESCRIPTION.")
            return()
        }
        for (person in people) {
            if ("cre" %in% person$role) {
                if ("ORCID" %in% names(person$comment)) {
                    orcid <- person$comment[["ORCID"]]
                    validID <- .checkORCID(orcid)
                    if (!validID)
                        handleNote(
                            "Invalid ORCID iD for ",
                            person$given, " ", person$family
                        )
                } else {
                    handleNote(
                        "Consider adding the maintainer's ORCID iD in",
                        " 'Authors@R' with 'comment=c(ORCID=\"...\")'"
                    )
                }
                email <- person$email
                if (is.null(email)) {
                    handleError(
                        "No email address for Authors@R maintainer [cre] field."
                    )
                    return()
                }
                fullname <- paste(person$given, person$family, collapse=" ")
                if (!nzchar(fullname))
                    return()
                maintainer <- sprintf("%s <%s>", trimws(fullname), email)
                break
            }
        }
    } else if ("Maintainer" %in% colnames(dcf)) {
        handleError("Remove Maintainer field. Use Authors@R [cre] designation.")
        return()
    } else {
        handleError(
            "No Authors@R [cre] or Maintainer field in DESCRIPTION file."
        )
        return()
    }
}

checkIsVignetteBuilt <- function(build_output_file)
{
    if (!file.exists(build_output_file))
    {
        stop("build output file '", build_output_file, "' does not exist.")
    }
    lines <- readLines(build_output_file)
    if (!any(grepl("^\\* creating vignettes \\.\\.\\.", lines)))
    {
        msg <- "Vignette must be built by
        'R CMD build'. Please see the `Vignette Checks` section of
        the BiocCheck vignette."
        handleError(msg)
    }
}

.BAD_INSTALL_CALLS <- c("biocLite", "install.packages", "install_packages",
    "update.packages", "install")

checkPkgInstallCalls <- function(.BiocPackage) {
    msg_installs <- findSymbolsInRFiles(
        .BiocPackage, .BAD_INSTALL_CALLS, "SYMBOL_FUNCTION_CALL"
    )
    if (length(msg_installs))
        handleErrorFiles(
            "Avoid using install, biocLite, install.packages,",
            " or update.packages",
            messages = msg_installs
        )
}

checkForLibraryRequire <- function(.BiocPackage) {
    msg_lib <- findSymbolsInRFiles(
        .BiocPackage,
        Symbols = c("library", "require"),
        tokenType = "SYMBOL_FUNCTION_CALL"
    )
    if (length(msg_lib)) {
        handleWarningFiles(
            " Avoid the use of 'library' or 'require' in R code",
            messages = msg_lib
        )
    }
    # for unit testing
    invisible(msg_lib)
}

.nline_report <- function(data) {
    fnoun <- "functions"
    plural <- !identical(nrow(data), 1L)
    mverb <- if (plural) "are" else "is"
    if (!plural)
        fnoun <- substr(fnoun, 1, nchar(fnoun) - 1)
    paste(
        "There", mverb, nrow(data), fnoun, "greater than 50 lines."
    )
}

checkFunctionLengths <- function(parsedCode, pkgname)
{
    parsedCode <- parsedCode[grepl("\\.[Rr]$", names(parsedCode))]
    if (!length(parsedCode))
        return(invisible())
    fileNames <- .getDirFiles(names(parsedCode))
    dflist <- structure(
        vector("list", length(names(parsedCode))),
        .Names = fileNames
    )
    names(parsedCode) <- fileNames
    for (filename in names(parsedCode)) {
        pc <- parsedCode[[filename]]
        res <- getFunctionLengths(pc)
        functionNames <- names(res)
        mt <- do.call(rbind, res)
        fname <- if (is.null(functionNames)) character(0L) else filename
        df <- cbind.data.frame(
            filename = fname, functionName = functionNames, mt,
            row.names = NULL
        )
        dflist[[filename]] <- df
    }
    dflist <- Filter(nrow, dflist)
    df <- do.call(rbind, dflist)
    if (length(df) && nrow(df)) {
        df <- df[order(-df[["length"]]),]
        h <- df[df[["length"]] > 50,]
        if (nrow(h)) {
            fn_msg <- apply(head(h, n=5), 1L, function(row) {
                sprintf(
                    "%s() (%s): %s lines",
                    row['functionName'], row['filename'], row['length']
                )
            })
            handleNote(
                "The recommended function length is 50 lines or less. ",
                .nline_report(h),
                help_text = "The longest 5 functions are:" ,
                messages = fn_msg
            )
        }
    }
}

checkNEWS <- function(pkgdir)
{
    newsFnd <- list.files(
        path = pkgdir, pattern = "NEWS[\\.Rd|\\.md]*$",
        recursive = TRUE, full.names = TRUE, include.dirs = FALSE
    )
    if (!length(newsFnd)) {
        handleNote(
            "Consider adding a NEWS file, so your package news will be ",
            "included in Bioconductor release announcements.")
        return()
    }
    newsPath <- file.path(basename(dirname(newsFnd)), basename(newsFnd))
    if (length(newsFnd) > 1L) {
        handleNote(
            "More than one NEWS file found.",
            "See ?news for recognition ordering.",
            help_text = "Please remove one of the following: ",
            messages = newsPath
        )
    }
    news <- head(newsFnd, 1L)
    newsext <- tools::file_ext(news)
    newsextract <- switch(
        newsext,
        Rd = tools:::.build_news_db_from_package_NEWS_Rd,
        md = tools:::.build_news_db_from_package_NEWS_md,
        tools:::.news_reader_default
    )
    tryCatch({
        res <- suppressWarnings(newsextract(news))
        if (is.null(res) || !inherits(res, "news_db"))
            stop("news() failed to parse news file: ", newsPath)
    }, error=function(e){
        handleWarning(
            "news(package='", basename(pkgdir), "') failed with news file: ",
            newsPath, ":", e$message,
            "\nRefer to https://contributions.bioconductor.org/news.html",
            " to be included in Bioconductor release announcements."
        )
    })
}

## This could maybe be more comprehensive, but
## it's what R CMD check does to decide whether
## to run tests.
## OOPS - R CMD check is looking at the INSTALLED directory
checkUnitTests <- function(pkgdir)
{
    tests_dir <- file.path(pkgdir, "tests")
    cond <- length(dir(tests_dir, pattern = "\\.(R|Rin)$"))
    if (dir.exists(tests_dir) && (!cond))
    {
        handleError(
            "Add a .R or .Rin file in tests/ directory or unit tests will ",
            "not be run by R CMD check. See ",
            "https://contributions.bioconductor.org/tests.html")
        return()
    }
    if (!(dir.exists(tests_dir) && cond))
    ## end stolen code
    {
        msg <- paste0(
            "Consider adding unit tests. We strongly encourage them. See",
            "\n  ",
            "https://contributions.bioconductor.org/tests.html"
        )
        handleNote(msg)
    }
}

## check if testthat contains skip_on_bioc() and throw note of it does
checkSkipOnBioc <- function(pkgdir)
{
    testdir <- file.path(pkgdir, "tests", "testthat")
    if (!file.exists(testdir))
        return()

    testfiles <- dir(testdir, pattern = "\\.[Rr]$", full.names = TRUE)
    msg <- vapply(testfiles, function(testfile){
        tokens <- getParseData(parse(testfile, keep.source=TRUE))
        if ("skip_on_bioc" %in% unlist(tokens)) {
            basename(testfile)
        } else NA_character_
    }, character(1))
    msg <- paste(msg[!is.na(msg)], collapse = " ")
    if (nzchar(msg)) {
        handleNote("skip_on_bioc() found in testthat files: ", msg)
    }
}

.lineReport <- function(linedf) {
    paste0(
        linedf[, "File"], "#L", linedf[, "Line"], " ",
        substr(linedf[, "Context"], 1, 40), " ..."
    )
}

.rmYAMLfm <- function(lines) {
    fm_idx <- grep("^---\\s*$", lines)
    offval <- 0L
    if (length(fm_idx)) {
        offval <- max(fm_idx)
        lines <- lines[-seq(min(fm_idx), offval)]
    }
    class(lines) <- c("readLines", class(lines))
    attributes(lines) <- list(offset = offval)
    lines
}

checkFormatting <- function(.BiocPackage, nlines=6)
{
    pkgname <- .BiocPackage$packageName
    rfiles <- .BiocPackage$RSources
    vigfiles <- .BiocPackage$VigSources
    manfiles <- if (!.BiocPackage$usesRoxygen) .BiocPackage$manSources
    namespace <- file.path(.BiocPackage$sourceDir, "NAMESPACE")
    files <- c(rfiles, namespace, manfiles, vigfiles)

    totallines <- 0L
    ok <- TRUE
    long <- tab <- indent <- Context()

    for (file in files)
    {
        if (file.exists(file) && file.info(file)$size == 0)
        {
            handleNote("Add content to the empty file ",
                .getDirFiles(file))
        }

        if (file.exists(file) && file.info(file)$size > 0)
        {
            lines <- readLines(file, warn=FALSE)
            offset <- 0L
            totallines <- totallines + length(lines)

            n <- nchar(lines, allowNA=TRUE)
            idx <- !is.na(n) & (n > 80L)
            long <- rbind(long, Context(file, lines, idx, offset))

            if (tolower(tools::file_ext(file)) %in% c("rmd", "qmd")) {
                lines <- .rmYAMLfm(lines)
                offset <- attr(lines, "offset")
            }

            idx <- grepl("\t", lines)
            tab <- rbind(tab, Context(file, lines, idx, offset))

            res <- regexpr("^([ ]+)", lines)
            match.length <- attr(res, "match.length")
            idx <- (match.length != -1L) & (match.length %% 4 != 0)
            indent <- rbind(indent, Context(file, lines, idx, offset))
        }
    }

    if (n <- nrow(long))
    {
        ok <- FALSE
        msg <- sprintf(
            "Consider shorter lines; %s lines (%i%%) are > 80 characters long.",
            n, round((n / totallines) * 100))
        msgs <- .lineReport(long)
        handleNote(
            msg,
            help_text = "First few lines:",
            messages = msgs
        )
    }

    if (n <- nrow(tab))
    {
        ok <- FALSE
        msg <- sprintf(
            "Consider 4 spaces instead of tabs; %s lines (%i%%) contain tabs.",
            n, round((n / totallines) * 100))
        msgs <- .lineReport(tab)
        handleNote(msg,
            help_text = "First few lines:",
            messages = msgs
        )
    }

    if (n <- nrow(indent))
    {
        ok <- FALSE
        msgs <- .lineReport(indent)
        handleNote(
            "Consider multiples of 4 spaces for line indents; ", n, " lines",
            " (", round((n / totallines) * 100), "%) are not.",
            help_text = "First few lines:",
            messages = msgs
        )
    }

    if (!ok)
    {
        handleMessage(
            "See https://contributions.bioconductor.org/r-code.html")
        handleMessage(
            "See styler package: https://cran.r-project.org/package=styler ",
            "as described in the BiocCheck vignette.")
    }
}

checkIsPackageNameAlreadyInUse <- function(
    pkgName,
    repo = c(
        "CRAN", "BioCsoft", "BioCann", "BioCexp", "BioCworkflows", "BioCbooks"
    )
) {
    repo <- match.arg(repo)
    msg <- paste0("'", pkgName, "' already exists in Bioconductor.")

    if (identical(repo, "CRAN"))
        msg <- paste(
            "The package already exists on CRAN. Packages submitted to",
            "Bioconductor must be removed from CRAN before the next",
            "Bioconductor release."
        )

    repo.url <- switch(
        repo,
        CRAN = sprintf(
            "%s/src/contrib/PACKAGES", BiocManager::repositories()[repo]
        ),
        BioCsoft = "https://bioconductor.org/packages/devel/bioc/VIEWS",
        BioCann =
            "https://bioconductor.org/packages/devel/data/annotation/VIEWS",
        BioCexp =
            "https://bioconductor.org/packages/devel/data/experiment/VIEWS",
        BioCworkflows =
            "https://bioconductor.org/packages/devel/workflows/VIEWS",
        BioCbooks =
            "https://bioconductor.org/packages/devel/books/VIEWS"
    )

    conn <- url(repo.url)
    on.exit({ close(conn) })
    dcf <- try(read.dcf(conn), silent = TRUE)
    if (is(dcf, "try-error"))
        return(
            handleMessage(
                "Unable to access repository ",
                BiocManager::repositories()[repo]
            )
        )

    isDuplicate <- tolower(pkgName) %in% tolower(dcf[,"Package"])
    if (isDuplicate && identical(repo, "CRAN"))
        handleWarning(msg)
    else if (isDuplicate)
        handleError(msg)
}

#' @importFrom httr2 req_body_form resp_status resp_body_html
checkForBiocDevelSubscription <- function(.BiocPackage)
{
    email <- getMaintainerEmail(.BiocPackage) |> tolower()
    if (is.null(email)) {
        handleError(
            "Unable to determine maintainer email from DESCRIPTION file.",
            nframe = 3L
        )
        return()
    }
    if (identical(email, "maintainer@bioconductor.org")) {
        handleMessage("Maintainer email is ok.")
        return()
    }
    response <- try({
        request("https://stat.ethz.ch/mailman/admin/bioc-devel") |>
            req_body_form(
                adminpw = Sys.getenv("BIOC_DEVEL_PASSWORD")
            ) |>
            req_perform()
    }, silent = TRUE)
    if (inherits(response, "try-error")) {
        handleMessage(
            "Unable to connect to the Bioc-devel mailing list:",
            "\n  ", conditionMessage(attr(response, "condition")))
        return()
    } else if (resp_status(response) >= 300) {
        handleMessage(
            "Unable to connect to the Bioc-devel mailing list:",
            "\n  status code ", resp_status(response))
        return()
    }
    response2 <- request(
        "https://stat.ethz.ch/mailman/admin/bioc-devel/members?letter=4") |>
        req_body_form(
            findmember = email, adminpw = Sys.getenv("BIOC_DEVEL_PASSWORD")
        ) |>
        req_perform()
    content <- resp_body_html(response2)
    result_email <- unlist(
        rvest::html_table(content)[[5L]][3L, 2L], use.names = FALSE
    )
    if (identical(tolower(result_email), tolower(email))) {
        handleMessage("Maintainer is subscribed to bioc-devel.")
    } else {
        handleError(
            "Subscribe to the Bioc-devel mailing list by going to ",
            "https://stat.ethz.ch/mailman/listinfo/bioc-devel",
            nframe = 3L
        )
    }
}

checkForSupportSiteRegistration <- function(.BiocPackage)
{
    email <- getMaintainerEmail(.BiocPackage) |> tolower()
    if (is.null(email)) {
        handleError(
            "Unable to determine maintainer email from DESCRIPTION file.",
            nframe = 3L
        )
        return()
    }
    if (identical(tolower(email), "maintainer@bioconductor.org")) {
        handleMessage("Maintainer email is ok.")
        return()
    }
    accountExists <- checkSupportReg(email)

    if (accountExists){
        pkgname <- tolower(.BiocPackage$packageName)
        checkWatchedTag(email, pkgname)
    }
}

#' @importFrom httr2 req_perform request resp_body_json
#' @importFrom utils URLencode
checkSupportReg <- function(email) {
    response <- paste0(
        "https://support.bioconductor.org/api/email/",
        URLencode(email, reserved = TRUE)
    ) |> request() |>
        req_perform() |>
        try(silent = TRUE)
    response_error <- inherits(response, "try-error")
    result <- !response_error && resp_body_json(response)
    if (response_error) {
        handleError(
            "Unable to find your email in the Support Site:",
            "\n  ", conditionMessage(attr(response, "condition"))
        )
    } else if (resp_body_json(response)) {
        handleMessage("Maintainer is registered at support site.")
    } else {
        handleError(
            "Register your email account in the Support Site; ",
            "visit https://support.bioconductor.org/accounts/signup/"
        )
    }
    result
}

checkWatchedTag <- function(email, pkgname){
    if (identical(email, "maintainer@bioconductor.org"))
        return()
    response <- paste0(
        "https://support.bioconductor.org/api/watched/tags/",
        URLencode(email, reserved = TRUE)
    ) |> request() |>
        req_perform() |>
        try(silent = TRUE)
    if (inherits(response, "try-error")) {
        handleMessage(
            "Unable to find your email in the Support Site:",
            "\n  ", conditionMessage(attr(response, "condition"))
        )
    } else {
        alltags <- resp_body_json(response)[["watched_tags"]]
        taglist <- unlist(strsplit(alltags, split = ","))
        tags <- tolower(taglist)
        if (tolower(pkgname) %in% tags)
            handleMessage("Package is in the Support Site Watched Tags.")
        else
            handleError(
                "Add package to Watched Tags in your Support Site profile; ",
                "visit https://support.bioconductor.org/accounts/edit/profile"
            )
    }
}

UNIT_TEST_PKG <- "unitTestTempDir"
UNIT_TEST_TEMPDIR <- file.path(tempdir(), UNIT_TEST_PKG)

library(devtools)

.zeroCounters <- BiocCheck:::.zeroCounters

parsedCode <- NULL

create_test_package <-
    function(
        test_dir = tempfile(),
        description=list(), extraActions=function(path=NULL){}
    )
{
    canned <- list(Author="Test Author",
        Maintainer="Test Maintainer <test@test.com>", "Authors@R"=NULL)
    for (name in names(description))
    {
        canned[[name]] <- description[[name]]
    }
    pkgpath <- tempfile(tmpdir = test_dir)
    if (!dir.exists(pkgpath))
        dir.create(pkgpath, recursive = TRUE)
    capture.output({
        suppressMessages(
            usethis::create_package(pkgpath, canned, rstudio=FALSE, open = FALSE)
        )
    })

    cat("#", file=file.path(pkgpath, "NAMESPACE"))
    extraActions(pkgpath)
    pkgpath
}

checkError <- function(msg)
{
    if (missing(msg)) msg = ""
    checkTrue(
        identical(
            .BiocCheck$getNum(c("note", "warning", "error")),
            c(note = 0L, warning = 0L, error = 1L)
        ),
        msg
    )
    .zeroCounters()
}

checkCounter <- function(msg, type = "error") {
    if (missing(msg))
        stop("<internal> Provide message input")
    conds <- c("note", "warning", "error")
    res <- as.integer(conds %in% type)
    names(res) <- conds
    checkTrue(
        all(
            mapply(
                all.equal,
                .BiocCheck$getNum(c("note", "warning", "error")), res
            )
        ),
        msg
    )
    .zeroCounters()
}

stillZero <- function()
{
    identical(
        .BiocCheck$getNum(c("note", "warning", "error")),
        c(note = 0L, warning = 0L, error = 0L)
    )
}

.setUp <- function()
{
    .zeroCounters()
    dir.create(UNIT_TEST_TEMPDIR)
}

.tearDown <- function()
{
    unlink(UNIT_TEST_TEMPDIR, TRUE)
}

setVersion <- function(version)
{
    cat(paste("Version:", version),
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
}


test_vignettes0 <- function()
{
    pkgdir <- UNIT_TEST_TEMPDIR
    vigdir <- file.path(pkgdir, "vignettes")
    if (!dir.exists(pkgdir))
        dir.create(pkgdir)

    ## no vignettes dir ERROR
    vde <- BiocCheck:::checkVigDirExists(vigdir)
    checkTrue(!vde)
    .zeroCounters()

    # empty vignette dir ERROR
    dir.create(vigdir, recursive=TRUE)
    BiocCheck:::checkVignetteDir(pkgdir, TRUE)
    checkCounter("No vignette sources in vignettes/ directory.", "error")
    .zeroCounters()

    # vig dir w/ source file  WARNING
    cat("nothing", file=file.path(vigdir, "test.Rnw"))
    cat("Title: unitTestTempDir", file=file.path(pkgdir, "DESCRIPTION"))
    BiocCheck:::checkVignetteDir(pkgdir, TRUE)
    checkIdentical(
        .BiocCheck$getNum(c("error", "warning", "note")),
        c(error = 0L, warning = 1L, note = 1L)
    )
    .zeroCounters()

    # test OK
    cat(
        "% \\VignetteIndexEntry{header} \n% \\VignetteEngine{knitr} \nnothing",
        file=file.path(vigdir, "test.Rnw")
    )
    cat(
        "Title: unitTestTempDir\nSuggests: knitr",
        file=file.path(pkgdir, "DESCRIPTION")
    )
    BiocCheck:::checkVignetteDir(pkgdir, TRUE)
    checkCounter(
        "'sessionInfo' not found in vignette", "note"
    )
    .zeroCounters()


    # check rnw file in inst/doc  WARNING
    instdoc <- file.path(pkgdir, "inst", "doc")
    dir.create(instdoc, recursive=TRUE)
    cat("nothing", file=file.path(instdoc, "test.rnw"))
    BiocCheck:::checkInstContents(pkgdir, TRUE)
    checkCounter(
        "Remove vignette sources from inst/doc", "warning"
    )
    .zeroCounters()

    # check rmd file in inst/doc  WARNING
    unlink(instdoc, TRUE)
    dir.create(instdoc, recursive=TRUE)
    cat("nothing", file=file.path(instdoc, "test.Rmd"))
    BiocCheck:::checkInstContents(pkgdir, TRUE)
    checkCounter(
        "Rmd file in inst/doc not seen as valid vignette source", "warning"
    )
    unlink(file.path(instdoc, "test.Rmd"))
    .zeroCounters()


    # check vigbuilder ERROR
    # in Description but not any vignette
    # also checks if builder listed but not in DESCRIPTION import,depend,suggest
    cat("VignetteBuilder: knitr", file=file.path(pkgdir, "DESCRIPTION"))
    cat(
        "% \\VignetteIndexEntry{header} \nnnothing",
        file=file.path(vigdir, "test.Rnw")
    )
    BiocCheck:::checkVignetteDir(pkgdir, TRUE)
    checkIdentical(
        .BiocCheck$getNum(c("error", "warning", "note")),
        c(error = 1L, warning = 1L, note = 1L)
    )
    .zeroCounters()

    # check vignette builder default
    # vignette directory currently contains rnw
    unlink(file.path(pkgdir, "DESCRIPTION"))
    cat("Title: something", file=file.path(pkgdir, "DESCRIPTION"))
    BiocCheck:::checkVignetteDir(pkgdir, TRUE)
    # no error if RNW
    checkCounter("'sessionInfo' not found in vignette", "note")

    # check defined in desc but default vig
    unlink(file.path(pkgdir, "DESCRIPTION"))
    cat("VignetteBuilder: Sweave", file=file.path(pkgdir, "DESCRIPTION"))
    BiocCheck:::checkVignetteDir(pkgdir, TRUE)
    checkIdentical(
        .BiocCheck$getNum(c("error", "warning", "note")),
        c(error = 0L, warning = 1L, note = 1L)
    )
    .zeroCounters()

    # check vignette style of example package
    # 2 WARNINGS - vignette template and evaluate more chunks
    BiocCheck:::checkVignetteDir(system.file("testpackages",
        "testpkg0", package="BiocCheck"), TRUE)
    checkEqualsNumeric(9, .BiocCheck$getNum("warning"))
    checkEquals("* WARNING: Evaluate more vignette chunks.",
        .BiocCheck$get("warning")[["checkVigChunkEval"]])
    checkTrue(
        any(grepl(
            pattern="VignetteIndex",
            .BiocCheck$get("warning")[["checkVigTemplate"]]
        ))
    )
    .zeroCounters()

    # check vignette style of example package
    BiocCheck:::checkVignetteDir(system.file("testpackages",
        "testpkg2", package="BiocCheck"), TRUE)
    checkEqualsNumeric(2, .BiocCheck$getNum("error"))
    checkTrue(
        any(grepl(
            pattern="VignetteBuilder",
            .BiocCheck$get("warning")[["checkVigSuggests"]]
        ))
    )
    checkTrue(
        any(grepl(pattern="VignetteEngine",
              .BiocCheck$get("error")[["checkVigEngine"]]
        ))
    )
    checkEqualsNumeric(4, .BiocCheck$getNum("warning"))
    checkTrue(
        any(grepl(
            pattern="missing vignette metadata", ignore.case = TRUE,
            .BiocCheck$get("warning")[["checkVigMetadata"]]
        ))
    )
    checkTrue(
        any(grepl(
            pattern="not currently Suggested",
            .BiocCheck$get("warning")[["checkVigSuggests"]]
        ))
    )
    checkTrue(
        grepl(
            pattern="Evaluate more vignette chunks",
            .BiocCheck$get("warning")[["checkVigChunkEval"]]
        )
    )
    .zeroCounters()

    # check vignette 'intermediate' files
    vigdir <- system.file("testpackages", "testpkg2", "vignettes",
                          package="BiocCheck")
    vigdircontents <- BiocCheck:::getVigSources(vigdir)
    BiocCheck:::checkVigFiles(vigdir, vigdircontents)
    checkEqualsNumeric(1, .BiocCheck$getNum("note"))
    .zeroCounters()

}

test_checkVersionNumber <- function()
{
    setVersion("lkjgfhfdlkgjhdflkgj")
    BiocCheck:::checkVersionNumber(UNIT_TEST_TEMPDIR)
    checkError("Garbage version doesn't cause error!")
    setVersion("1.2.3.4")
    BiocCheck:::checkVersionNumber(UNIT_TEST_TEMPDIR)
    checkError("Version 1.2.3.4 doesn't cause error!")
    isDevel <- (BiocManager:::.version_bioc("devel") == BiocManager::version())
    .zeroCounters()
    if (isDevel)
    {
        setVersion("1.2.3")
    } else {
        setVersion("1.3.3")
    }
    BiocCheck:::checkVersionNumber(UNIT_TEST_TEMPDIR)
    checkTrue(.BiocCheck$getNum("warning") ==1)
    .zeroCounters()
}

test_checkNewPackageVersionNumber <- function()
{
    setVersion("1.99.3")
    BiocCheck:::checkNewPackageVersionNumber(UNIT_TEST_TEMPDIR)
    checkCounter(
        "New package x version non-zero",
        "warning"
    )

    setVersion("00.99.3")
    BiocCheck:::checkNewPackageVersionNumber(UNIT_TEST_TEMPDIR)
    checkTrue(stillZero())

    setVersion("0.2.3")
    BiocCheck:::checkNewPackageVersionNumber(UNIT_TEST_TEMPDIR)
    checkCounter(
        "New package y version not 99",
        "error"
    )

    setVersion("0.99.1")
    BiocCheck:::checkNewPackageVersionNumber(UNIT_TEST_TEMPDIR)
    checkTrue(stillZero())
}

test_checkRbuildignore <- function()
{
    rbuildfile <- file.path(UNIT_TEST_TEMPDIR, ".Rbuildignore")
    cat("tests/", "tests", "^tests$", ".*/testthat",
        sep = "\n", file = rbuildfile
    )
    checkTrue(
        identical(
            sum(BiocCheck:::.testRbuildignore(readLines(rbuildfile))),
            3L
        )
    )
}

test_checkBiocCheckOutputFolder <- function()
{
    check_folder <- file.path(UNIT_TEST_TEMPDIR, "testpkg.BiocCheck")
    dir.create(check_folder, recursive = TRUE)
    BiocCheck:::checkBiocCheckOutputFolder(dirname(check_folder), "testpkg")
    checkEqualsNumeric(.BiocCheck$getNum("error"), 1L)
    unlink(check_folder)
    .zeroCounters()
}

test_checkInstDocFolder <- function() {
    pkg_folder <- file.path(UNIT_TEST_TEMPDIR, "testPkg")
    inst_dir <- file.path(pkg_folder, "inst", "doc")
    dir.create(inst_dir, recursive = TRUE)
    BiocCheck:::checkInstDocFolder(pkg_folder, "testpkg")
    checkEqualsNumeric(.BiocCheck$getNum("error"), 0L)

    file.create(file.path(inst_dir, "index.html"))
    BiocCheck:::checkInstDocFolder(pkg_folder, "testpkg")
    checkEqualsNumeric(.BiocCheck$getNum("error"), 1L)

    unlink(pkg_folder, recursive = TRUE)
    .zeroCounters()
}

test_checkBiocViews <- function()
{
    if (!dir.exists(UNIT_TEST_TEMPDIR))
        dir.create(UNIT_TEST_TEMPDIR)
    .zeroCounters()
    cat("Foo: bar", file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkBiocViews(UNIT_TEST_TEMPDIR)
    checkTrue(.BiocCheck$getNum("error") == 1,
        "missing biocViews doesn't produce error")

    .zeroCounters()
    cat(
        "biocViews: foo, Cancer, bar,\n    baz",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION")
    )
    BiocCheck:::checkBiocViews(UNIT_TEST_TEMPDIR)
    # Invalid views = 1 warning for 4 terms
    checkEqualsNumeric(.BiocCheck$getNum("warning"), 1)

    .zeroCounters()
    cat(
        "biocViews: GO, CellBasedAssays",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION")
    )
    BiocCheck:::checkBiocViews(UNIT_TEST_TEMPDIR)
    checkTrue(
        .BiocCheck$getNum("warning") == 0,
        "valid biocViews produce warning"
    )

    .zeroCounters()
    cat(
        "biocViews: aCGH, ChipName",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION")
    )
    BiocCheck:::checkBiocViews(UNIT_TEST_TEMPDIR)
    checkTrue(.BiocCheck$getNum("warning") == 1,
        "biocViews from multiple categories don't produce warning")
}

test_badFiles <- function(){
    pkgdir <- UNIT_TEST_TEMPDIR
    if (!dir.exists(pkgdir))
        dir.create(pkgdir)
    badfile <- file.path(pkgdir, "something.Rproj")
    file.create(badfile)
    BiocCheck:::checkBadFiles(pkgdir)
    checkEqualsNumeric(1, .BiocCheck$getNum("error"))
    .zeroCounters()
    unlink(pkgdir)
}

test_checkLicenseForRestrictiveUse <- function() {
    .zeroCounters()
    BiocCheck:::.checkLicenseForRestrictiveUse("GPL-3.0")
    stillZero()

    .zeroCounters()
    BiocCheck:::.checkLicenseForRestrictiveUse("CC BY-NC-ND 4.0")
    checkEqualsNumeric(1, .BiocCheck$getNum("error"))

    .zeroCounters()
    BiocCheck:::.checkLicenseForRestrictiveUse("CC BY-NC-ND 4.0 + file LICENSE")
    checkEqualsNumeric(1, .BiocCheck$getNum("error"))

    .zeroCounters()
    BiocCheck:::.checkLicenseForRestrictiveUse("UNKNOWN")
    checkEqualsNumeric(1, .BiocCheck$getNum("note"))

    .zeroCounters()
    BiocCheck:::.checkLicenseForRestrictiveUse(NA_character_)
    checkEqualsNumeric(1, .BiocCheck$getNum("note"))
}

test_checkIndivFileSizes <- function() {
    .zeroCounters()
    .findLargeFiles_org <- BiocCheck:::.findLargeFiles
    .findLargeFiles <- function(...) {
        c("fileA.rda", "fileB.rds")
    }
    assignInNamespace('.findLargeFiles', .findLargeFiles, "BiocCheck")
    on.exit({
        assignInNamespace('.findLargeFiles', .findLargeFiles_org, "BiocCheck")
    })

    BiocCheck:::checkIndivFileSizes(UNIT_TEST_TEMPDIR)
    checkEqualsNumeric(.BiocCheck$getNum("warning"), 1)
    .zeroCounters()

    BiocCheck:::checkDataFileSizes(UNIT_TEST_TEMPDIR)
    checkEqualsNumeric(.BiocCheck$getNum("warning"), 1)
    .zeroCounters()
}

test_checkBBScompatibility <- function()
{
    pkgdir <- UNIT_TEST_TEMPDIR
    if (!dir.exists(pkgdir))
        dir.create(pkgdir)


    cat("Package : foo",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION")
    )
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkError("Space in DESCRIPTION field name doesn't cause error")
    .zeroCounters()


    cat("Package: foo",
        "",
        "Imports: bar",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION")
    )
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkError("Blank line in DESCRIPTION doesn't cause error")
    .zeroCounters()

    desc <- system.file(
        "testpackages", "testpkg0", "DESCRIPTION", package="BiocCheck"
    )
    BiocCheck:::.checkDescription(desc)
    checkCounter(
        "Description field in the DESCRIPTION file is too concise",
        "warning"
    )


    cat("Package: Foo",
        "Description: This is a test description field in the Foo package.",
        "  The field should contain two sentences and it should trigger a",
        "  NOTE in the check.",
        "License: GPL-2",
        sep = "\n",
        file = file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION")
    )
    BiocCheck:::.checkDescription(file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    checkCounter(
        "The Description field in the DESCRIPTION is less than two sentences",
        "note"
    )

    cat("Package: Foo",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION")
    )
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkError(
        "Package name which doesn't match dir name does not cause error!"
    )

    cat(paste("Package:", UNIT_TEST_PKG),
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkError("Missing Version doesn't cause error!")


    cat(paste("Package: ", UNIT_TEST_PKG),
        "Version: 0.99.0",
        "Authors@R: 1",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    .zeroCounters()
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkError("Wrong class in Authors@R doesn't cause error!")


    cat(paste("Package:", UNIT_TEST_PKG),
        "Version: 0.99.0",
        paste(
            "Authors@R: c(person('Bioconductor', 'Package Maintainer',",
            "email='maintainer@bioconductor.org', role=c('aut')))"
        ),
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    .zeroCounters()
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkError("Missing cre role in Authors@R doesn't cause error!")


    cat(sprintf("Package: %s", UNIT_TEST_PKG),
        "Version: 0.99.0",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkError("Missing Maintainer and Authors@R doesn't cause error!")

    cat(paste("Package: %s", UNIT_TEST_PKG),
        "Version: 0.99.0",
        "Maintainer: Joe Blow",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkTrue(
        .BiocCheck$getNum("error") > 0L,
        "Missing email in Maintainer doesn't cause error!"
    )

    .zeroCounters()
    cat(paste("Package: ", UNIT_TEST_PKG),
        "Version: 0.99.0",
        "Maintainer: Joe Blow <joe@blow.com>",
        "Authors@R: c(person('Bioconductor Package Maintainer',",
        "    email='maintainer@bioconductor.org', role=c('aut', 'cre')))",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkDescription(UNIT_TEST_TEMPDIR)
    checkEqualsNumeric(
        .BiocCheck$getNum("error"), 1L,
        "Using Maintainer and Author@R causes error"
    )

    .zeroCounters()
    cat(paste("Package:", UNIT_TEST_PKG),
        "Version: 0.99.0",
        "Authors@R: c(person('Bioconductor', 'Package Maintainer',",
        "    email='maintainer@bioconductor.org',",
        "    comment = c(ORCID = '0000-0000-000-0000'),",
        "    role=c('aut', 'cre')))",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkTrue(
        .BiocCheck$getNum("note") == 1L,
        "An invalid ORCID iD causes a note!"
    )

    .zeroCounters()
    cat(paste("Package:", UNIT_TEST_PKG),
        "Version: 0.99.0",
        "Maintainer: Joe Blow <joe@blow.com>",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkTrue(
        .BiocCheck$getNum("error") > 0L,
        "Utilize Maintainer instead of Authors@R doesn't cause error!"
    )

    .zeroCounters()
    cat(paste("Package:", UNIT_TEST_PKG),
        "Version: 0.99.0",
        "Authors@R: c(",
        "  person('Bioconductor Package Maintainer',",
        "    email='maintainer@bioconductor.org',",
        "    role=c('aut', 'cre')),",
        "  person('Joe', 'Blow', email='joe@blow.com', role='cre'))",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    # ERROR: More than one maintainer & NOTE: Include ORCID iD
    checkIdentical(
        .BiocCheck$getNum(c("error", "warning", "note")),
        c(error = 1L, warning = 0L, note = 1L)
    )

    .zeroCounters()
    cat(paste("Package:", UNIT_TEST_PKG),
        "Version: 0.99.0",
        "Authors@R: c(",
        "  person('Bioconductor Package Maintainer',",
        "    email='maintainer@bioconductor.org',",
        "    role=c('aut', 'cre')))",
        "License: GPL-2",
        sep = "\n",
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkBBScompatibility(UNIT_TEST_TEMPDIR, FALSE)
    checkCounter("Include ORCID iD", "note")

    .zeroCounters()
    dir.create(file.path(UNIT_TEST_TEMPDIR,"inst"))
    cat(
        paste(
            "citEntry(entry='article', title='test',",
            "author=personList(as.person('Lori Kern')), year=2020,",
            "journal='Loris Best', volume='4', issue='12',",
            "textVersion='Shepherd, Lori (2020) test. Loris Best. 4(12)')"
        ),
        file=file.path(UNIT_TEST_TEMPDIR,"inst/CITATION")
    )
    BiocCheck:::checkForCitationFile(UNIT_TEST_TEMPDIR)
    checkTrue(stillZero())

    cat(
        paste(
            "citEntry(entry='', title='test',",
            "author=personList(as.person('Lori Kern')), year=2020,",
            "journal='Loris Best', volume='4', issue='12')"
        ),
        file=file.path(UNIT_TEST_TEMPDIR,"inst/CITATION"),
        append=FALSE
    )
    BiocCheck:::checkForCitationFile(UNIT_TEST_TEMPDIR)
    checkTrue(.BiocCheck$getNum("note")==1, "citation produces note")

    .zeroCounters()
}

test_checkUnitTests <- function()
{
    .zeroCounters()
    BiocCheck:::checkUnitTests(UNIT_TEST_TEMPDIR)
    checkTrue(.BiocCheck$getNum("note") == 1)
    dir.create(file.path(UNIT_TEST_TEMPDIR, "tests"),recursive=TRUE)
    cat("nothing", file=file.path(UNIT_TEST_TEMPDIR, "tests",
        "foo.R"))
    .zeroCounters()
    BiocCheck:::checkUnitTests(UNIT_TEST_TEMPDIR)
    checkTrue(stillZero())
    .zeroCounters()
    BiocCheck:::checkSkipOnBioc(system.file("testpackages",
        "testpkg0", package="BiocCheck"))
    checkTrue(.BiocCheck$getNum("note") == 1)
    .zeroCounters()

    # check coding practice
    pkgdir <- system.file("testpackages", "testpkg0", package="BiocCheck")
    Rdir <- file.path(pkgdir, "R")
    msg_sapply <- BiocCheck:::checkSapply(Rdir)
    checkEqualsNumeric(length(msg_sapply), 1)
    msg_seq <- BiocCheck:::check1toN(Rdir)
    checkEqualsNumeric(length(msg_seq), 1)
    msg_eda <- BiocCheck:::checkExternalData(Rdir)
    checkEqualsNumeric(length(msg_eda), 4)
    msg_dl <- BiocCheck:::checkOnAttachLoadCalls(Rdir)
    checkEqualsNumeric(length(msg_dl), 2)
    avail_pkgs <- BiocManager::available()
    msg_sc <- BiocCheck:::checkSingleColon(Rdir, avail_pkgs)
    testval <- ifelse("BiocCheck" %in% avail_pkgs, 1, 0)
    checkTrue(length(msg_sc) == testval)
    pkgdir <- system.file("testpackages", "testpkg2", package="BiocCheck")
    res <- BiocCheck:::findSymbolsInVignettes(pkgdir, c("T", "F"), "SYMBOL")
    checkEqualsNumeric(length(res), 1)
}

test_findPasteInSignaler <- function() {
    rfile <- tempfile()
    writeLines(c(
        "message(paste('foo', 'bar'))",
        "message(paste('foo', x))",
        "message(paste(x, collapse = '\t'))",
        "message('foo', paste(x, collapse = 't'))"
    ), rfile)
    checkTrue(
        length(BiocCheck:::.findPasteInSignaler(rfile)) == 2L
    )
}

test_findSignalerInSignaler <- function() {
    .SIGNALERS_TXT <- c("message", "warning", "stop")
    rfile <- tempfile()
    writeLines(c(
        "message('warning: see here')",
        "warning('error here')",
        "stop('ErrOR: see here')",
        "stop('message here')"
    ), rfile)
    checkTrue(
        length(BiocCheck:::.findSignalerInSignaler(rfile, .SIGNALERS_TXT)) == 4L
    )
}

test_installAndLoad <- function()
{
    pkgdir <- create_test_package()
    instdir <- dirname(pkgdir)
    temppkg <- BiocCheck:::installAndLoad(
        pkgpath = pkgdir, install_dir = instdir
    )
    liblocation <- file.path(temppkg, "lib")
    checkTrue(dir.exists(liblocation))
    checkTrue(
        identical(
            readLines(file.path(instdir, "install.stderr")),
            character(0L)
        )
    )
    testloadEnv <- try(loadNamespace(basename(pkgdir), lib.loc = liblocation))
    checkTrue(is.environment(testloadEnv))
    unloadNamespace(testloadEnv)
    unlink(instdir, recursive = TRUE)
}

test_findPackageName <- function()
{
    pkgdir <- create_test_package()
    dirrename <- file.path(dirname(pkgdir), "test_package")
    file.rename(pkgdir, dirrename)
    pkgname <- BiocCheck:::.getPackageName(dirrename)
    checkTrue(identical(pkgname, basename(pkgdir)))
    unlink(dirname(pkgdir), recursive = TRUE)

    ## test tarball rename
    pkgdir <- create_test_package(description = list(Version = "0.99.0"))
    cmd <- sprintf('"%s"/bin/R CMD build %s', R.home(), pkgdir)
    result <- system(cmd, intern=TRUE)

    tarname <- paste0(basename(pkgdir), "_0.99.0.tar.gz")
    file.copy(tarname, tempdir())
    file.remove(tarname)
    tarname <- file.path(tempdir(), tarname)
    stopifnot(file.exists(tarname))
    tarrename <- file.path(tempdir(), "test.package_0.99.0.tar.gz")
    file.rename(tarname, tarrename)
    checkException(BiocCheck:::.getPackageName(tarrename))
    unlink(tarrename)
}

test_checkDeprecatedPackages <- function()
{
    cat(sprintf("Depends: multicore, %s", UNIT_TEST_PKG),
        file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
    BiocCheck:::checkDeprecatedPackages(UNIT_TEST_TEMPDIR)
    checkError("Depending on multicore didn't cause error!")

}

test_parseFile <- function()
{
    testFile <- file.path(tempdir(), "testfile.R")
    cat("1 + 1", file=testFile)
    df <- BiocCheck:::parseFile(testFile, "BiocCheck")
    checkTrue(all(dim(df) == c(6,9)))
    ## test that  testpkg0_child.Rmd is read in using `child =` chunk
    ## in testpkg0.Rmd
    pkgdir <- system.file("testpackages", "testpkg0", package="BiocCheck")
    testFile <- file.path(pkgdir, "vignettes", "testpkg0.Rmd")
    incl <- BiocCheck:::parseFile(testFile, pkgdir)
    checkTrue(all(c("2", "+", "1") %in% incl[, "text"]))
}

test_checkForBrowser <- function()
{
    if (is.null(parsedCode))
        parsedCode <- BiocCheck:::parseFiles(system.file("testpackages",
            "testpkg0", package="BiocCheck"))
    res <- BiocCheck:::findSymbolsInParsedCode(
        parsedCodeList = parsedCode,
        symbolNames = "browser",
        tokenTypes = "SYMBOL_FUNCTION_CALL"
    )
    checkTrue(length(res) == 1)
}

test_checkVigSessionInfo <- function()
{
    pkgdir <- system.file("testpackages", "testpkg0", package="BiocCheck")
    checkVigSessionInfo(pkgdir)
    checkTrue(.BiocCheck$getNum("note") == 1)
}

test_findSymbolsInRFiles <- function()
{
    pkgdir <- system.file("testpackages", "testpkg0",
        package="BiocCheck", mustWork = TRUE)
    msg <- BiocCheck:::findSymbolsInRFiles(
        pkgdir, BiocCheck:::.BAD_INSTALL_CALLS, "SYMBOL_FUNCTION_CALL"
    )
    checkTrue(length(msg) == 2)
}

test_checkCatInRCode <- function()
{
    Rdir <- system.file("testpackages", "testpkg0", "R",
        package="BiocCheck", mustWork = TRUE)
    msg <- BiocCheck:::checkCatInRCode(
        Rdir, c("cat", "print")
    )
    checkTrue(length(msg) == 9)
}

test_checkEqInAssignment <- function()
{
    Rdir <- system.file("testpackages", "testpkg0", "R",
        package="BiocCheck", mustWork = TRUE)
    msg <- BiocCheck:::checkEqInAssignment(
        Rdir = Rdir, symbol = "=", tokenType = "EQ_ASSIGN"
    )
    checkTrue(length(msg) == 3)
}

test_checkVigInstalls <- function()
{
    BiocCheck:::checkVigInstalls(
        system.file(
            "testpackages", "testpkg0", package="BiocCheck", mustWork = TRUE
        )
    )
    checkEqualsNumeric(.BiocCheck$getNum("error"), 1)
    checkEqualsNumeric(length(.BiocCheck$get("error")[[1]]), 5)
    .zeroCounters()
}

test_checkTFSymbolUsage <- function()
{
    BiocCheck:::checkTFSymbolUsage(
        system.file("testpackages", "testpkg0", package = "BiocCheck",
            mustWork = TRUE)
    )
    checkEqualsNumeric(.BiocCheck$getNum("warning"), 1)
}

test_checkVigSessionInfo <- function()
{
    BiocCheck:::checkVigSessionInfo(
        system.file("testpackages", "testpkg0", package = "BiocCheck",
            mustWork = TRUE)
    )
    checkEqualsNumeric(.BiocCheck$getNum("note"), 1)
}

test_checkForInstall <- function()
{
    if (is.null(parsedCode))
        parsedCode <- BiocCheck:::parseFiles(system.file("testpackages",
            "testpkg0", package="BiocCheck"))
    res <- BiocCheck:::findSymbolInParsedCode(parsedCode, "testpkg0", "install",
        "SYMBOL_FUNCTION_CALL")
    checkTrue(res == 2)
}

test_checkVigBiocInst <- function()
{
    pkgdir <- system.file("testpackages", "testpkg0", package = "BiocCheck")
    BiocCheck:::checkVigBiocInst(pkgdir)
    checkTrue(.BiocCheck$getNum("warning") == 1)
}

test_checkClassNEEQLookup <- function()
{
    dir.create(dir <- tempfile())
    dir.create(Rdir <- file.path(dir, "R"))
    fl <- tempfile(tmpdir=Rdir, fileext = ".R")
    cat(
        paste(
            ## bad
            "class(a)=='foo'", "class(a)!='foo'",
            "if (is(a) == 'character')", "is( a ) != 'numeric'",
            ## ok
            "is(a, 'List')", "is.numeric(a)",
            sep="\n"),
        "\n", file = fl
    )
    match <- BiocCheck:::checkClassNEEQLookup(dir)
    checkIdentical(4L, length(match))
}

test_checkDESCRIPTIONfile <- function()
{
    dcf <- matrix("https://example.com", dimnames = list(NULL, "URL"))
    BiocCheck:::.checkDESCfields(dcf)
    checkEqualsNumeric(.BiocCheck$getNum("note"), 1)
    .zeroCounters()

    dcf <- matrix("https://example.com", dimnames = list(NULL, "BugReports"))
    BiocCheck:::.checkDESCfields(dcf)
    checkEqualsNumeric(.BiocCheck$getNum("note"), 1)
    .zeroCounters()

    dcf <- matrix(
        c("https://example.com", "https://example.com"), nrow = 1,
        dimnames = list(NULL, c("BugReports", "URL"))
    )
    BiocCheck:::.checkDESCfields(dcf)
    checkEqualsNumeric(.BiocCheck$getNum("note"), 0)
    .zeroCounters()
}

test_checkDescriptionNamespaceConsistency <- function()
{
    run_check <- function(pkg, instdir) {
        libloc <- file.path(instdir, "lib")
        suppressMessages({
            BiocCheck:::checkDescriptionNamespaceConsistency(
                pkg, lib.loc = libloc
            )
        })
    }
    test_dir <- tempfile()
    dir.create(test_dir)
    .zeroCounters()

    pkgpath <- create_test_package(
        test_dir = test_dir,
        description =list(Imports="devtools")
    )
    instdir <- BiocCheck:::installAndLoad(pkgpath, test_dir)
    run_check(basename(pkgpath), instdir)
    checkEqualsNumeric(.BiocCheck$getNum("warning"), 1)
    checkTrue(
        grepl("Import devtools", .BiocCheck$get("warning"), fixed = TRUE)
    )

    unlink(test_dir, recursive = TRUE)
    dir.create(test_dir)
    .zeroCounters()

    pkgpath <- create_test_package(
        test_dir = test_dir,
        description = list(Imports="devtools"),
        extraActions=function(path) {
            cat("import(devtools)\n", file=file.path(path, "NAMESPACE"))
        }
    )
    instdir <- BiocCheck:::installAndLoad(pkgpath, test_dir)
    pkgname <- basename(pkgpath)
    run_check(pkgname, instdir)
    checkTrue(.BiocCheck$getNum("warning") == 0L)

    unlink(test_dir, recursive = TRUE)
    dir.create(test_dir)
    .zeroCounters()

    pkgpath <- create_test_package(
        test_dir = test_dir,
        description = list(Imports="usethis"),
        extraActions = function(path) {
            cat("f = function() usethis::create_package()\n",
                file=file.path(path, "R", "f.R"))
        }
    )
    instdir <- BiocCheck:::installAndLoad(pkgpath, test_dir)
    pkgname <- basename(pkgpath)
    run_check(pkgname, instdir)
    checkTrue(.BiocCheck$getNum("warning") == 0L)

    unlink(test_dir, recursive = TRUE)
    dir.create(test_dir)
    .zeroCounters()

    pkgpath <- create_test_package(
        test_dir = test_dir,
        description = list(Imports="usethis, BiocCheck"),
        extraActions = function(path) {
            cat("f = function() usethis::create_package()\n",
                file=file.path(path, "R", "f.R"))
        }
    )
    instdir <- BiocCheck:::installAndLoad(pkgpath, test_dir)
    pkgname <- basename(pkgpath)
    run_check(pkgname, instdir)
    checkTrue(.BiocCheck$getNum("warning") == 1L)
    checkTrue(
        grepl("Import BiocCheck", .BiocCheck$get("warning"), fixed = TRUE)
    )

    unlink(test_dir, recursive = TRUE)
    dir.create(test_dir)
    .zeroCounters()

    pkgpath <- create_test_package(
        test_dir = test_dir,
        extraActions = function(path) {
            cat("import(devtools)\n", file=file.path(path, "NAMESPACE"))
        }
    )
    instdir <- BiocCheck:::installAndLoad(pkgpath, test_dir)
    pkgname <- basename(pkgpath)
    pkg_ns <- loadNamespace(pkgname, lib.loc = file.path(instdir, "lib"))
    checkTrue(
        "devtools" %in% names(getNamespaceImports(pkg_ns))
    )
    try(unloadNamespace(pkg_ns), silent = TRUE)

    run_check(pkgname, instdir)
    checkTrue(.BiocCheck$getNum("warning") == 1)
    checkTrue(
        grepl("Import devtools", .BiocCheck$get("warning"), fixed = TRUE)
    )
}

test_remotesUsage <- function()
{
    pkg <- system.file("testpackages", "testpkg0", package="BiocCheck")
    .zeroCounters()
    BiocCheck:::checkRemotesUsage(pkg)
    checkEqualsNumeric(1, BiocCheck:::.BiocCheck$getNum("error"))
    checkTrue(grepl("Remotes:", BiocCheck:::.BiocCheck$get("error")[1]))
    .zeroCounters()
    pkg <- system.file("testpackages", "testpkg1", package="BiocCheck")
    BiocCheck:::checkRemotesUsage(pkg)
    checkEqualsNumeric(0, BiocCheck:::.BiocCheck$getNum("error"))
}

test_LazyDataUsage <- function()
{
    pkg <- system.file("testpackages", "testpkg0", package="BiocCheck")
    .zeroCounters()
    BiocCheck:::checkLazyDataUsage(pkg)
    checkEqualsNumeric(1, BiocCheck:::.BiocCheck$getNum("note"))
}

test_checkForLibraryRequire <- function()
{
    pkg_dir <- system.file(
        "testpackages", "testpkg0", package="BiocCheck", mustWork = TRUE
    )
    msg <- BiocCheck:::checkForLibraryRequire(pkg_dir)
    checkEqualsNumeric(1L, .BiocCheck$getNum("warning"))
    checkEqualsNumeric(length(msg), 14L)
    .zeroCounters()
}

test_getFunctionLengths <- function()
{
    file <- system.file("testpackages", "testpkg0", "R",
        "parseme.R", package="BiocCheck")
    df <- getParseData(parse(file, keep.source=TRUE))
    res <- BiocCheck:::getFunctionLengths(df)
    lsnames <- c("length", "startLine", "endLine")
    values <- c(2, 1, 2, 1, 3, 3, 1, 6, 6, 5, 9, 13, 4, 16,
        19, 6, 23, 28, 1, 31, 31, 1, 33, 33, 6, 35, 40)
    names(values) <- rep(lsnames, 9)
    expected <- split(values, rep(1:9, each = 3))
    names(expected) <- c("_anonymous_.1", "fa", "f2", "f3", "f4",
        "_anonymous_.23", "f5", "f6", "f7")

    checkTrue(all.equal(expected, res))
}

test_getFunctionLengths2 <- function()
{
    load(system.file("unitTests", "IRangesParsedCode.rda", package="BiocCheck"))
    BiocCheck:::checkFunctionLengths(IRangesParsedCode, "IRanges")
    .zeroCounters()

    ## we should find 1 function that is greater than 50 lines long
    parsedCode <- BiocCheck:::parseFiles(system.file("testpackages", "testpkg0",
                                                     package="BiocCheck"))
    res <- BiocCheck:::checkFunctionLengths(parsedCode, "testpkg0")
    checkEqualsNumeric(BiocCheck:::.BiocCheck$getNum("note"), 1)
    checkTrue(grepl(pattern = "There is 1 function greater than 50 lines",
                    x = BiocCheck:::.BiocCheck$note$checkFunctionLengths[[1]]),
              msg = "Checking we report functions > 50 lines long.")
    .zeroCounters()
}

test_checkExportsAreDocumented <- function()
{
    pkgdir <- system.file("testpackages", "testpkg0", package="BiocCheck")
    instdir <- BiocCheck:::installAndLoad(pkgdir)
    res <- BiocCheck:::checkExportsAreDocumented(
        pkgdir, "testpkg0", lib.loc = file.path(instdir, "lib")
    )
    checkEqualsNumeric(1, .BiocCheck$getNum("error"))
    .zeroCounters()
    res <- BiocCheck:::checkUsageOfDont(pkgdir)
    checkEqualsNumeric(2, .BiocCheck$getNum("note"))
    .zeroCounters()
}

test_checkNEWS <- function()
{
    BiocCheck:::checkNEWS(system.file("testpackages", "testpkg0",
        package="BiocCheck"))
    checkEqualsNumeric(1, .BiocCheck$getNum("note"))
    .zeroCounters()
    if (!dir.exists(UNIT_TEST_TEMPDIR))
        dir.create(UNIT_TEST_TEMPDIR)
    cat("lalala", file=file.path(UNIT_TEST_TEMPDIR, "NEWS"))
    BiocCheck:::checkNEWS(UNIT_TEST_TEMPDIR)
    stillZero()
    unlink(file.path(UNIT_TEST_TEMPDIR, "NEWS"))
    dir.create(file.path(UNIT_TEST_TEMPDIR, "inst"), FALSE)
    cat("lalala", file=file.path(UNIT_TEST_TEMPDIR, "inst", "NEWS.Rd"))
    BiocCheck:::checkNEWS(UNIT_TEST_TEMPDIR)
    checkEqualsNumeric(1, .BiocCheck$getNum("warning"))
    .zeroCounters()
    cat("lalala", file=file.path(UNIT_TEST_TEMPDIR, "NEWS.md"))
    BiocCheck:::checkNEWS(UNIT_TEST_TEMPDIR)
    checkEqualsNumeric(1, .BiocCheck$getNum("note"))
    checkEqualsNumeric(1, .BiocCheck$getNum("warning"))
    .zeroCounters()
}

test_checkFormatting <- function()
{
    BiocCheck:::checkFormatting(system.file("testpackages", "testpkg0",
        package="BiocCheck"))
    checkEqualsNumeric(3, .BiocCheck$getNum("note"))
}

test_checkForPromptComments <- function()
{
    BiocCheck:::checkForPromptComments(system.file("testpackages", "testpkg0",
        package="BiocCheck"))
    checkEqualsNumeric(1, .BiocCheck$getNum("note"))

}

test_getPkgType <- function()
{
   cat("Foo: bar", file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
   checkEquals(NA, BiocCheck:::getPkgType(UNIT_TEST_TEMPDIR))

   cat("biocViews: bad, Software",
       file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
   checkEquals(NA, BiocCheck:::getPkgType(UNIT_TEST_TEMPDIR))

   cat("biocViews: DifferentialExpression, CellBiology",
       file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
   checkEquals("Software", BiocCheck:::getPkgType(UNIT_TEST_TEMPDIR))

   cat("biocViews: DifferentialExpression, ChipManufacturer",
       file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
   checkEquals(NA, BiocCheck:::getPkgType(UNIT_TEST_TEMPDIR))

   cat("biocViews: GeneCardsCustomSchema, ChipManufacturer",
       file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
   checkEquals("AnnotationData", BiocCheck:::getPkgType(UNIT_TEST_TEMPDIR))

   # Cancer is not a valid biocView, so return NA
   cat("biocViews: Cancer, HapMap",
       file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
   checkEquals(NA, BiocCheck:::getPkgType(UNIT_TEST_TEMPDIR))
}

test_checkForBiocDevelSubscription <- function()
{
    if (nchar(Sys.getenv("BIOC_DEVEL_PASSWORD"))) {

        if (!dir.exists(UNIT_TEST_TEMPDIR))
            dir.create(UNIT_TEST_TEMPDIR)
        cat("Maintainer: Joe Blow <foo@bar.com>",
                file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
        BiocCheck:::checkForBiocDevelSubscription(UNIT_TEST_TEMPDIR)
        checkEqualsNumeric(.BiocCheck$getNum("error"), 1)
        .zeroCounters()

        cat("Maintainer: Bioconductor Maintainer <maintainer@bioconductor.org>",
                file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
        BiocCheck:::checkForBiocDevelSubscription(UNIT_TEST_TEMPDIR)
        checkTrue(stillZero())
        .zeroCounters()

        cat("Maintainer: Bioconductor Maintainer <MAINTAINER@bioconductor.ORG>",
                file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
        BiocCheck:::checkForBiocDevelSubscription(UNIT_TEST_TEMPDIR)
        checkTrue(stillZero())
        .zeroCounters()

        cat(sprintf(paste(
            "Package: %s\nVersion: 0.99.0\nAuthors@R:",
            "c(person('Joe', \n  'Blow', email='joe@blow.org',",
            "role=c('aut', 'cre')))"
        ), UNIT_TEST_PKG), file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
        BiocCheck:::checkForBiocDevelSubscription(UNIT_TEST_TEMPDIR)
        checkEqualsNumeric(.BiocCheck$getNum("error"), 1)
        .zeroCounters()

        cat(sprintf(paste(
            "Package: %s\nVersion: 0.99.0\nAuthors@R:",
            "c(person('BioC', \n  'Maintainer',",
            "email='maintainer@bioconductor.org',",
            "role=c('aut', 'cre')))"
        ), UNIT_TEST_PKG), file=file.path(UNIT_TEST_TEMPDIR, "DESCRIPTION"))
        BiocCheck:::checkForBiocDevelSubscription(UNIT_TEST_TEMPDIR)
        checkTrue(stillZero())
        .zeroCounters()

    }
}

test_checkForSupportSiteRegistration <- function()
{
    connect <- suppressWarnings(
        tryCatch({
            readBin("https://support.bioconductor.org", n=1L, what="raw")
            TRUE
        }, error = function(...) {
            FALSE
        })
    )

    if (connect) {

        # Email registration
        .zeroCounters()
        BiocCheck:::checkSupportReg("lori.shepherd@roswellpark.org")
        checkTrue(stillZero())
        BiocCheck:::checkSupportReg("foo@bar.com")
        checkEqualsNumeric(.BiocCheck$getNum("error"), 1)
        .zeroCounters()
        ## api is case insensitivy
        BiocCheck:::checkSupportReg("lori.shePhErd@roswellpark.org")
        checkTrue(stillZero())


        # tags
        BiocCheck:::checkWatchedTag(
            "lori.shepherd@roswellpark.org", "biocfilecache"
        )
        checkTrue(stillZero())
        BiocCheck:::checkWatchedTag(
            "lori.shepherd@roswellpark.org", "unwatchedpackage"
        )
        checkEqualsNumeric(.BiocCheck$getNum("error"), 1)
        .zeroCounters()
        ## email is case insensitive
        BiocCheck:::checkWatchedTag(
            "lori.shePherd@rosWellpark.org", "biocfilecache"
        )
        checkTrue(stillZero())
        ## check tag is case insenstive
        BiocCheck:::checkWatchedTag(
            "lori.shepherd@rosWellpark.org", "bioCfiLecache"
        )
        checkTrue(stillZero())

    }
}

test_checkForVersionNumberMismatch <- function()
{
    pkgpath <- create_test_package(description = list(Version="0.0.1"))
    pkgname <- basename(pkgpath)

    cmd <- sprintf('"%s"/bin/R CMD build %s', R.home(), pkgpath)
    result <- system(cmd, intern=TRUE)

    oldname <- paste0(pkgname, "_0.0.1.tar.gz")
    file.copy(oldname, tempdir())
    file.remove(oldname)
    oldname <- file.path(tempdir(), oldname)
    newname <- file.path(tempdir(), paste0(pkgname, "_9.9.9.tar.gz"))
    if (!file.rename(oldname, newname))
        stop("'file.rename()' failed to rename badkpgk",
             "\n  oldname: ", oldname, " newname: ", newname,
             "\n  cmd: ", cmd,
             "\n  result:",
             "\n    ", paste(result, collapse="\n    "),
             "\n")
    on.exit({
        file.remove(newname)
    })
    inst_dir <- BiocCheck:::installAndLoad(newname)

    BiocCheck:::checkForVersionNumberMismatch(
        newname,
        BiocCheck:::.tempPackageDirTarball(newname))
    checkEqualsNumeric(.BiocCheck$getNum("error"), 1)
    .zeroCounters()
}

test_checkForDirectSlotAccess <- function()
{
    pkgpath <- create_test_package(description = list(VignetteBuilder="knitr"))
    parsedCode <- list(FooBar=BiocCheck:::parseFile(
        system.file("testfiles", "directSlotAccess.Rmd",
        package="BiocCheck"), pkgpath))
    res <- BiocCheck:::checkForDirectSlotAccess(parsedCode, pkgpath)
    checkEqualsNumeric(BiocCheck:::.BiocCheck$getNum("note"), 1)
    .zeroCounters()
    parsedCode <- list(FooBar=BiocCheck:::parseFile(
        system.file("testfiles", "noDirectSlotAccess.Rmd",
        package="BiocCheck"), pkgpath))
    res <- BiocCheck:::checkForDirectSlotAccess(parsedCode, pkgpath)
    checkEqualsNumeric(.BiocCheck$getNum("note"), 0)
    .zeroCounters()
}

test_checkRVersionDependency <- function()
{
    .zeroCounters()
    desc <- file.path(tempdir(), "DESCRIPTION")
    cat("Depends: R (>= 1.0.0)", file=desc)
    BiocCheck:::checkRVersionDependency(dirname(desc))
    checkEqualsNumeric(.BiocCheck$getNum("note"), 1)
    .zeroCounters()

    cat("Depends: R", file=desc)
    BiocCheck:::checkRVersionDependency(dirname(desc))
    checkEqualsNumeric(.BiocCheck$getNum("note"), 0)
    .zeroCounters()

    cat("Imports: foobar)", file=desc)
    BiocCheck:::checkRVersionDependency(dirname(desc))
    checkEqualsNumeric(.BiocCheck$getNum("warning"), 0)
    .zeroCounters()

    cat("Depends: R (>= 10000.0.0)", file=desc) # this test might fail some day!
    BiocCheck:::checkRVersionDependency(dirname(desc))
    checkEqualsNumeric(.BiocCheck$getNum("note"), 0)
    .zeroCounters()

    unlink(desc)
}

test_doesManPageHaveRunnableExample <- function()
{
    good <- tools::parse_Rd(system.file("testpackages", "testpkg0", "man",
            "has-devel.Rd", package = "BiocCheck"))

    bad <- tools::parse_Rd(system.file("testpackages", "testpkg0", "man",
            "baddep.Rd", package = "BiocCheck"))

    checkEquals(BiocCheck:::doesManPageHaveRunnableExample(good), TRUE)

    checkEquals(BiocCheck:::doesManPageHaveRunnableExample(bad), FALSE)
}

test_checkForValueSection <- function() {
    pkgdir <- system.file(
        "testpackages", "testpkg0", package = "BiocCheck"
    )
    mans <- BiocCheck:::.read_all_rds(pkgdir)
    tags <- lapply(mans, tools:::RdTags)
    checkTrue(!BiocCheck:::.valueInParsedRd(mans[[1]], tags[[1]]))
    checkTrue(!BiocCheck:::.valueInParsedRd(mans[[2]], tags[[2]]))
    checkTrue(BiocCheck:::.valueInParsedRd(mans[[3]], tags[[3]]))
    pkgdir <- system.file(
        "testpackages", "testpkg1", package = "BiocCheck"
    )
    mans <- BiocCheck:::.read_all_rds(pkgdir)
    tags <- lapply(mans, tools:::RdTags)
    checkTrue(!BiocCheck:::.valueInParsedRd(mans[[1]], tags[[1]]))
    checkTrue(!BiocCheck:::.valueInParsedRd(mans[[2]], tags[[2]]))
}

test_packageAlreadyExists <- function()
{
    .zeroCounters()
    nerrors <- 0L
    BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "CRAN")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("devtools", "CRAN")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "BioCsoft")
    nerrors <- nerrors + 1L
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("gwascatData", "BioCann")
    nerrors <- nerrors + 1L
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("TENxBrainData", "BioCexp")
    nerrors <- nerrors + 1L
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("annotation", "BioCworkflows")
    nerrors <- nerrors + 1L
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "BioCexp")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "BioCann")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "BioCworkflows")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "BioCexp")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "BioCann")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "BioCworkflows")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "CRAN")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "BioCsoft")
    checkEqualsNumeric(.BiocCheck$getNum("error"), nerrors)
    .zeroCounters()
}

test_BiocCheckReporters <- function()
{
    pkgdir <- system.file("testpackages", package="BiocCheck")
    hypo_checkdir <- file.path(pkgdir, "hypoPkg.BiocCheck")
    oldCheckDir <- .BiocCheck$metadata$BiocCheckDir
    on.exit({
        .BiocCheck$metadata$BiocCheckDir <- oldCheckDir
    })
    .BiocCheck$metadata$BiocCheckDir <- hypo_checkdir
    .BiocCheck$report(debug = FALSE, isOnBBS = TRUE)
    checkTrue(
        !dir.exists(hypo_checkdir)
    )
    checkTrue(
        !dir.exists(hypo_checkdir)
    )
}

test_checkUsageOfDont <- function()
{
    ## testpkg0 should trigger this note for 2 out of 3 man pages
    pkgdir <- system.file("testpackages", "testpkg0", package="BiocCheck")
    BiocCheck:::installAndLoad(pkgdir)
    notemsg <- capture.output(BiocCheck:::checkUsageOfDont(pkgdir),
                              type = "message")
    checkEqualsNumeric(2, .BiocCheck$getNum("note"))
    # here we verify the correct number of pages were detected
    checkTrue( any(grepl("67%", notemsg)) )
    .zeroCounters()

    ## testpkg1 contains a man page with keyword 'internal'
    ## this shouldn't trigger the note
    pkgdir <- system.file("testpackages", "testpkg1", package="BiocCheck")
    BiocCheck:::installAndLoad(pkgdir)
    BiocCheck:::checkUsageOfDont(pkgdir)
    checkEqualsNumeric(0, .BiocCheck$getNum("note"))
    .zeroCounters()
}

test_IsOrcidIdValid <- function()
{
    orcid <- c(
        "0000-0001-6197-3471",
        "0000-0001-6197-347X",
        "0000-0001-6197-34XX",
        "0000-0001-6197-3471-0000",
        "",
        NA_character_
    )
    valid <- c(TRUE, TRUE, FALSE, FALSE, FALSE, FALSE)
    checkIdentical(valid, BiocCheck:::.checkORCID(orcid))
}

test_getBiocCheckDir <- function() {
    getBiocCheckDir <- BiocCheck:::.getBiocCheckDir
    pkg <- system.file(
        "testpackages", "testpkg0", package="BiocCheck"
    )
    checkIdentical(
        getBiocCheckDir(basename(pkg), dirname(pkg)),
        file.path(dirname(pkg), paste(basename(pkg), "BiocCheck", sep = "."))
    )
}

test_getDirFiles <- function() {
    vigfiles <- list.files(
        system.file(
            "testpackages", "testpkg0", "vignettes", package="BiocCheck"
        ),
        full.names = TRUE
    )
    targets <- file.path(basename(dirname(vigfiles)), basename(vigfiles))
    checkIdentical(
        targets[1], unname(BiocCheck:::.getDirFiles(vigfiles[1]))
    )
    checkIdentical(targets, unname(BiocCheck:::.getDirFiles(vigfiles)))
}


test_checkEnv <- function() {
    # Simple function in empty environment:
    env <- new.env(parent = emptyenv())
    env$f <- function() BiocCheck::BiocCheck
    dcolon <- BiocCheck:::.checkEnv(env, BiocCheck:::.colonWalker())$done()
    checkIdentical(dcolon, "BiocCheck")

    # Function inside environment inside environment
    # This happens on pkg ns environments with S4 methods
    env <- new.env(parent = emptyenv())
    env$another <- new.env(parent = emptyenv())
    env$another$f <- function() BiocCheck::BiocCheck
    dcolon <- BiocCheck:::.checkEnv(env, BiocCheck:::.colonWalker())$done()
    checkIdentical(dcolon, "BiocCheck")

    # Environments can contain themselves. Check that this does not
    # lead to an infinite loop
    env <- new.env(parent = emptyenv())
    env$another <- env
    env$another$f <- function() BiocCheck::BiocCheck
    dcolon <- BiocCheck:::.checkEnv(env, BiocCheck:::.colonWalker())$done()
    checkIdentical(dcolon, "BiocCheck")

    # Environments can contain other envs that can contain the first env.
    # Check that this does not lead to an infinite loop
    env <- new.env(parent = emptyenv())
    env$another <- new.env(parent = emptyenv())
    env$another$env2 <- env
    env$another$env2$f <- function() BiocCheck::BiocCheck
    dcolon <- BiocCheck:::.checkEnv(env, BiocCheck:::.colonWalker())$done()
    checkIdentical(dcolon, "BiocCheck")
}

source("helpers.R")

library(devtools)
library(tinytest)

# checkVersionNumber ------------------------------------------------------
temp_dir <- tempdir()
.bioctest <- create_test_package(
    test_dir = temp_dir, description = list(Version = "lkjgfhfdlkgjhdflkgj")
)
BiocCheck:::checkVersionNumber(.bioctest)
checkCounter("Garbage version doesn't cause error!")

.bioctest <- create_test_package(
    test_dir = temp_dir, description = list(Version = "1.2.3.4")
)
BiocCheck:::checkVersionNumber(.bioctest)
checkCounter("Version 1.2.3.4 doesn't cause error!")

isDevel <- (BiocManager:::.version_bioc("devel") == BiocManager::version())
testversion <- if (isDevel) "1.2.3" else "1.3.3"
.bioctest <- create_test_package(
    test_dir = temp_dir, description = list(Version = testversion)
)
BiocCheck:::checkVersionNumber(.bioctest)
expect_equivalent(.BiocCheck$getNum("warning"), 1)
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)


# checkNewPackageVersionNumber --------------------------------------------

temppkgdir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temppkgdir, description = list(Version = "1.99.3")
)
BiocCheck:::checkNewPackageVersionNumber(.bioctest)
checkCounter(
    "New package x version non-zero",
    "warning"
)

.bioctest <- create_test_package(
    test_dir = temppkgdir, description = list(Version = "0.99.3")
)
BiocCheck:::checkNewPackageVersionNumber(.bioctest)
expect_true(stillZero())

.bioctest <- create_test_package(
    test_dir = temppkgdir, description = list(Version = "0.2.3")
)
BiocCheck:::checkNewPackageVersionNumber(.bioctest)
checkCounter(
    "New package y version not 99",
    "error"
)

.bioctest <- create_test_package(
    test_dir = temppkgdir, description = list(Version = "0.99.1")
)
BiocCheck:::checkNewPackageVersionNumber(.bioctest)
expect_true(stillZero())


# checkRbuildIgnore -------------------------------------------------------

rbuildfile <- file.path(UNIT_TEST_TEMPDIR, ".Rbuildignore")
if (!dir.exists(UNIT_TEST_TEMPDIR))
    dir.create(UNIT_TEST_TEMPDIR, recursive = TRUE)

cat(
    "tests", "tests/", "^tests$", "^tests/", "^tests/$",
    ".*/testthat", "^tests/testthat/cache$", "^longtests/testthat/cache$",
    "longtests", "longtests/", "^longtests/", "^longtests$", "^longtests/$",
    "^nnntests$",
    sep = "\n", file = rbuildfile
)
expect_identical(
    BiocCheck:::.testRbuildignore(readLines(rbuildfile)),
    c(
        TRUE, TRUE, TRUE, TRUE, FALSE,
        FALSE, FALSE, FALSE,
        TRUE, TRUE, TRUE, TRUE, FALSE,
        FALSE
    )
)

# checkBiocCheckOutputFolder ----------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(test_dir = temp_dir)
check_folder <- file.path(
    .bioctest$sourceDir, paste0(.bioctest$packageName, ".BiocCheck")
)
dir.create(check_folder, recursive = TRUE)
BiocCheck:::checkBiocCheckOutputFolder(.bioctest)
expect_equivalent(.BiocCheck$getNum("error"), 1L)
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)

# checkInstDocFolder ------------------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(test_dir = temp_dir)
inst_dir <- file.path(.bioctest$sourceDir, "inst", "doc")
dir.create(inst_dir, recursive = TRUE)
BiocCheck:::checkInstDocFolder(.bioctest)
expect_equivalent(.BiocCheck$getNum("error"), 0L)

file.create(file.path(inst_dir, "index.html"))
BiocCheck:::checkInstDocFolder(.bioctest)
expect_equivalent(.BiocCheck$getNum("error"), 1L)
.BiocCheck$zero()

unlink(temp_dir, recursive = TRUE)

# checkBiocViews ----------------------------------------------------------
.BiocCheck$zero()
temp_dir <- tempfile()

.bioctest <- create_test_package(
    test_dir = temp_dir, description = list(Foo = "bar")
)
BiocCheck:::checkBiocViews(.bioctest)
checkCounter("missing biocViews doesn't produce error")


.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(biocViews = "foo, Cancer, bar,\n    baz")
)
BiocCheck:::checkBiocViews(.bioctest)
expect_equivalent(
    .BiocCheck$getNum("warning"), 1L,
    info = "invalid biocViews does not produce warning"
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(biocViews = "GO, CellBasedAssays")
)
BiocCheck:::checkBiocViews(.bioctest)
expect_equivalent(
    .BiocCheck$getNum("warning"), 0L,
    info = "valid biocViews produce warning"
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(biocViews = "aCGH, ChipName")
)
BiocCheck:::checkBiocViews(.bioctest)
expect_equivalent(
    .BiocCheck$getNum("warning"), 1L,
    info = "biocViews from multiple categories don't produce warning"
)
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)

# checkBadFiles -----------------------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(pkgdir){
        badfile <- file.path(pkgdir, "something.Rproj")
        file.create(badfile)
    }
)
BiocCheck:::checkBadFiles(.bioctest)
expect_equivalent(1, .BiocCheck$getNum("error"))
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)

# checkSystemCalls --------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
msg <- BiocCheck:::findSymbolsInRFiles(
    .bioctest, "system", "SYMBOL_FUNCTION_CALL"
)
## use tinytest:: until fixed in
## https://github.com/markvanderloo/tinytest/issues/124
tinytest::expect_match(msg, "system\\(\\) in R/bad_coding\\.R.*")
.BiocCheck$zero()

# check T / F usage -------------------------------------------------------
msg <- BiocCheck:::findSymbolsInRFiles(
    .bioctest, c("T", "F"), "SYMBOL", notLookback = "$"
)
expect_equivalent(
    sum(grepl("R/TFindex.R", msg)), 4L
)
expect_equivalent(
    sum(grepl("R/morecode.R", msg)), 2L
)
.BiocCheck$zero()

# checkLicenseForRestrictiveUse -------------------------------------------
BiocCheck:::checkLicenseForRestrictiveUse("GPL-3.0")
stillZero()
.BiocCheck$zero()

BiocCheck:::checkLicenseForRestrictiveUse("GPL (>= 3)")
stillZero()
.BiocCheck$zero()

BiocCheck:::checkLicenseForRestrictiveUse("CC BY-NC-ND 4.0")
expect_equivalent(1, .BiocCheck$getNum("error"))
.BiocCheck$zero()

BiocCheck:::checkLicenseForRestrictiveUse("CC BY-NC-ND 4.0 + file LICENSE")
expect_equivalent(1, .BiocCheck$getNum("error"))
.BiocCheck$zero()

BiocCheck:::checkLicenseForRestrictiveUse("UNKNOWN")
expect_equivalent(1, .BiocCheck$getNum("note"))
.BiocCheck$zero()

BiocCheck:::checkLicenseForRestrictiveUse(NA_character_)
expect_equivalent(1, .BiocCheck$getNum("note"))
.BiocCheck$zero()

# analyze_licenses --------------------------------------------------------
licensedb <- gsub(
    "$R_HOME", Sys.getenv("R_HOME"),
    BiocCheck:::.LICENSE_DB_LOCATION, fixed = TRUE
)
result <- tools:::analyze_licenses("GPL-3.0", licensedb)
expect_true(!result$is_verified)
BiocCheck:::checkLicenseForRestrictiveUse("GPL-3.0")
expect_equivalent(1, .BiocCheck$getNum("note"))
.BiocCheck$zero()

result <- tools:::analyze_licenses("GPL-3", licensedb)
expect_true(result$is_verified)
BiocCheck:::checkLicenseForRestrictiveUse("GPL-3")
expect_equivalent(0, .BiocCheck$getNum("note"))
.BiocCheck$zero()

# checkIndivFileSizes -----------------------------------------------------

.findLargeFiles_org <- BiocCheck:::.findLargeFiles
.findLargeFiles <- function(...) {
    c("fileA.rda", "fileB.rds")
}
assignInNamespace('.findLargeFiles', .findLargeFiles, "BiocCheck")

temp_dir <- tempfile()
.bioctest <- create_test_package(test_dir = temp_dir)
BiocCheck:::checkIndivFileSizes(.bioctest)
expect_equivalent(.BiocCheck$getNum("warning"), 1)
.BiocCheck$zero()

BiocCheck:::checkDataFileSizes(.bioctest)
expect_equivalent(.BiocCheck$getNum("warning"), 1)
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)
assignInNamespace('.findLargeFiles', .findLargeFiles_org, "BiocCheck")

# checkBBScompatibility ---------------------------------------------------

temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(`Package ` = " foo", License = "GPL-2")
)
BiocCheck:::checkBBScompatibility(.bioctest)
checkCounter("Space in DESCRIPTION field name doesn't cause error")
.BiocCheck$zero()

expect_error({
    create_test_package(
        test_dir = temp_dir,
        extraActions = function(pkgdir) {
            badfile <- file.path(pkgdir, "DESCRIPTION")
            writeLines(c(
                "Package: foo",
                "Version: 0.99.0",
                ## blank line causes error
                "",
                "License: GPL-2",
                "Depends: R (>= 4.0.0)"
            ), badfile)
        }
    )
}, info = "Blank line in DESCRIPTION doesn't cause error")

.bioctest <- read_test_package("testpkg0")
BiocCheck:::.conciseDescription(.bioctest)
checkCounter(
    "Description field in the DESCRIPTION file is too concise",
    "warning"
)

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        Package = "Foo",
        Description = c(
            "This is a test description field in the Foo package.",
            " The field should contain three sentences; otherwise, ",
            " it triggers a NOTE in the check."
        ),
        License = "GPL-2"
    )
)
BiocCheck:::.conciseDescription(.bioctest)
checkCounter(
    "The Description field in the DESCRIPTION is less than two sentences",
    "note"
)

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(Package = "Foo", License = "GPL-2")
)
BiocCheck:::checkBBScompatibility(.bioctest)
checkCounter(
    "Package name which doesn't match dir name does not cause error!"
)

expect_error({
    create_test_package(
        test_dir = temp_dir,
        ## override usethis::create_package Version
        extraActions = function(path) {
            badfile <- file.path(path, "DESCRIPTION")
            writeLines(c(
                "Package: foo",
                "License: GPL-2",
                "Depends: R (>= 4.0.0)"
            ), badfile)
        }
    )
}, info = "Missing Version doesn't cause error!")

.bioctest <- create_test_package(
    test_dir = temp_dir,
    pkgpath = file.path(temp_dir, "Foo"),
    extraActions = function(path) {
        badfile <- file.path(path, "DESCRIPTION")
        writeLines(c(
            "Package: Foo",
            "Version: 0.99.0",
            "Authors@R: 1",
            "License: GPL-2",
            "Depends: R (>= 4.0.0)"
        ), badfile)
    }
)
BiocCheck:::checkBBScompatibility(.bioctest)
checkCounter("Wrong class in Authors@R doesn't cause error!")

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        Version = "0.99.0",
        `Authors@R` = c(
            "c(person('Bioconductor', 'Package Maintainer',",
            "email='maintainer@bioconductor.org', role=c('aut')))"
        ),
        License = "GPL-2"
    ),
    use.canned = FALSE
)
BiocCheck:::checkBBScompatibility(.bioctest)
checkCounter("Missing cre role in Authors@R doesn't cause error!")
.BiocCheck$zero()


.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(Version = "0.99.0", License = "GPL-2"),
    use.canned = FALSE
)
.desc <- .bioctest$DESCRIPTION
.bioctest$DESCRIPTION <-
    .desc[, colnames(.desc) != "Authors@R", drop = FALSE]
BiocCheck:::checkBBScompatibility(.bioctest)
checkCounter("Missing Maintainer and Authors@R doesn't cause error!")

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        `Authors@R` = "person('Joe', 'Blow', role = c('aut', 'cre'))",
        License = "GPL-2"
    ),
    use.canned = FALSE
)
BiocCheck:::checkBBScompatibility(.bioctest)
expect_true(
    .BiocCheck$getNum("error") > 0L,
    "Missing email in Maintainer doesn't cause error!"
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        Version = "0.99.0",
        `Authors@R` = c(
            "person('Bioconductor Package Maintainer',",
            "email='maintainer@bioconductor.org', role=c('aut', 'cre'))"
        ),
        License = "GPL-2"
    )
)
BiocCheck:::checkBBScompatibility(.bioctest)
expect_true(
    any(
        grepl(
            pattern = "Authors@R field not Author",
            .BiocCheck$get("error")[["validMaintainer"]]
        )
    )
)
expect_true(
    any(
        grepl(
            pattern = "adding .* ORCID iD",
            .BiocCheck$get("note")[["checkBBScompatibility"]]
        )
    )
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        Version = "0.99.0",
        `Authors@R` = c(
            "person('Bioconductor Package Maintainer',",
            "email='maintainer@bioconductor.org', role=c('aut', 'cre'),",
            "comment = c(ORCID = '0000-000-0000-0000'))"
        ),
        License = "GPL-2"
    )
)
BiocCheck:::checkBBScompatibility(.bioctest)
expect_true(
    grepl(
        pattern = "Invalid ORCID iD",
        .BiocCheck$get("note")[["checkBBScompatibility"]]
    )
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        Version = "0.99.0",
        Maintainer = "Joe Blow <joe@blow.com>",
        License = "GPL-2"
    )
)
BiocCheck:::checkBBScompatibility(.bioctest)
expect_true(
    grepl(
        pattern = "Remove Maintainer field",
        .BiocCheck$get("error")[["checkBBScompatibility"]]
    )
)
expect_true(
    grepl(
        pattern = "Use Authors@R",
        .BiocCheck$get("error")[["validMaintainer"]]
    )
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        Version = "0.99.0",
        `Authors@R` = c(
            "c(person('Bioconductor Package Maintainer',",
            "email='maintainer@bioconductor.org', role=c('aut', 'cre'),",
            "comment = c(ORCID = '0000-0000-000-0000')),",
            "person('Joe', 'Blow', email='joe@blow.com', role='cre'))"
        ),
        License = "GPL-2"
    )
)
BiocCheck:::checkBBScompatibility(.bioctest)
## ERROR: More than one maintainer & NOTE: Include ORCID iD
expect_identical(
    .BiocCheck$getNum(c("error", "warning", "note")),
    c(error = 2L, warning = 0L, note = 1L)
)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(path) {
        dir.create(file.path(path, "inst"))
        cat(
            paste(
                "citEntry(entry='article', title='test',",
                "author=personList(as.person('Lori Kern')), year=2020,",
                "journal='Loris Best', volume='4', issue='12',",
                "textVersion='Shepherd, Lori (2020) test. ",
                "Loris Best. 4(12)')"
            ),
            file = file.path(path,"inst", "CITATION")
        )
    }
)
BiocCheck:::checkForCitationFile(.bioctest)
expect_equivalent(.BiocCheck$getNum("warning"), 1)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(path) {
        dir.create(file.path(path, "inst"))
        cat(
            paste(
                "citEntry(entry='', title='test',",
                "author=personList(as.person('Lori Kern')), year=2020,",
                "journal='Loris Best', volume='4', issue='12')"
            ),
            file = file.path(path,"inst", "CITATION")
        )
    }
)
BiocCheck:::checkForCitationFile(.bioctest)
expect_equivalent(.BiocCheck$getNum("warning"), 1)
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)

# checkUnitTests ----------------------------------------------------------
BiocCheck:::checkUnitTests(UNIT_TEST_TEMPDIR)
expect_equivalent(.BiocCheck$getNum("note"), 1)
.BiocCheck$zero()

.bioctest <- create_test_package(
    extraActions = function(path) {
        dir.create(file.path(path, "tests"), recursive = TRUE)
        cat("nothing", file = file.path(path, "tests", "foo.R"))
    }
)
BiocCheck:::checkUnitTests(.bioctest$sourceDir)
expect_true(stillZero())
.BiocCheck$zero()

BiocCheck:::checkSkipOnBioc(
    system.file("testpackages", "testpkg0", package="BiocCheck")
)
expect_equivalent(.BiocCheck$getNum("note"), 1)
.BiocCheck$zero()

# check coding practice ---------------------------------------------------
.bioctest <- read_test_package("testpkg0")
msg_sapply <- BiocCheck:::checkSapply(.bioctest)
expect_equivalent(length(msg_sapply), 1)

msg_seq <- BiocCheck:::check1toN(.bioctest)
expect_equivalent(length(msg_seq), 1)

msg_eda <- BiocCheck:::checkExternalData(.bioctest)
expect_equivalent(length(msg_eda), 4)

msg_dl <- BiocCheck:::checkOnAttachLoadCalls(.bioctest)
expect_equivalent(length(msg_dl), 2)

avail_pkgs <- BiocManager::available()
msg_sc <- BiocCheck:::checkSingleColon(.bioctest, avail_pkgs)
testval <- ifelse("BiocCheck" %in% avail_pkgs, 1, 0)
expect_equivalent(length(msg_sc), testval)

.bioctest <- read_test_package("testpkg2")
res <- BiocCheck:::findSymbolsInVignettes(.bioctest, c("T", "F"), "SYMBOL")
expect_equivalent(length(res), 1)

# findPasteInSignaler -----------------------------------------------------
rfile <- tempfile()
writeLines(c(
    "message(paste('foo', 'bar'))",
    "message(paste('foo', x))",
    "message(paste(x, collapse = '\t'))",
    "message('foo', paste(x, collapse = 't'))"
), rfile)
expect_true(
    length(BiocCheck:::.findPasteInSignaler(rfile)) == 2L
)

# findSignalerInSignaler --------------------------------------------------
.SIGNALERS_TXT <- c("message", "warning", "stop")
rfile <- tempfile()
writeLines(c(
    "message('warning: see here')",
    "warning('error here')",
    "stop('ErrOR: see here')",
    "stop('message here')"
), rfile)
expect_true(
    length(BiocCheck:::.findSignalerInSignaler(rfile, .SIGNALERS_TXT)) == 4L
)

# .tryInstallwLoad --------------------------------------------------------
.bioctest <- create_test_package()
temppkg <- BiocCheck:::.tryInstallwLoad(.bioctest)
liblocation <- file.path(temppkg, "lib")
expect_true(dir.exists(liblocation))
expect_true(
    identical(
        readLines(file.path(temppkg, "install.stderr")),
        character(0L)
    )
)
testloadEnv <- try(
    loadNamespace(.bioctest$packageName, lib.loc = liblocation)
)
expect_true(is.environment(testloadEnv))
unloadNamespace(testloadEnv)
unlink(temppkg, recursive = TRUE)

# packageName -------------------------------------------------------------
## test tarball rename
.bioctest <- create_test_package(description = list(Version = "0.99.0"))
oldname <- devtools::build(.bioctest$sourceDir)
newname <- file.path(tempdir(), "test.package_0.99.0.tar.gz")

if (!file.rename(oldname, newname)) {
    file.remove(oldname)
    stop("'file.rename()' failed to rename package",
         "\n  oldname: ", oldname, " newname: ", newname,
         "\n  cmd: ", cmd,
         "\n  result:",
         "\n    ", paste(result, collapse="\n    "),
         "\n")
}
expect_identical(
    .BiocPackage$initialize(newname)[["packageName"]],
    .bioctest$packageName
)
file.remove(newname)

# checkDeprecatedPackages -------------------------------------------------
temp_dir <- tempfile()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(Depends = "multicore, unitTestTempDir")
)
BiocCheck:::checkDeprecatedPackages(.bioctest)
checkCounter("Depending on multicore didn't cause error!")
unlink(temp_dir, recursive = TRUE)

# parseFile ---------------------------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(path) {
        testFile <- file.path(path, "R", "testfile.R")
        cat("1 + 1", file = testFile)
    }
)
df <- BiocCheck:::parseFile(.bioctest, .bioctest$RSources)
expect_identical(dim(df), c(6L,9L))
## test that  testpkg0_child.Rmd is read in using `child =` chunk
## in testpkg0.Rmd
.bioctest <- read_test_package("testpkg0")
incl <- BiocCheck:::parseFile(
    .bioctest, .bioctest$VigSources["vignettes/testpkg0.Rmd"]
)
expect_true(all(c("2", "+", "1") %in% incl[, "text"]))
unlink(temp_dir, recursive = TRUE)

# checkForBrowser ---------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
parsedCode <- BiocCheck:::parseFiles(.bioctest)
res <- BiocCheck:::findSymbolsInParsedCode(
    parsedCodeList = parsedCode,
    symbolNames = "browser",
    tokenTypes = "SYMBOL_FUNCTION_CALL"
)
expect_equivalent(length(res), 1)
.BiocCheck$zero()

# findSymbolsInRFiles -----------------------------------------------------
.bioctest <- read_test_package("testpkg0")
msg <- BiocCheck:::findSymbolsInRFiles(
    .bioctest, BiocCheck:::.BAD_INSTALL_CALLS, "SYMBOL_FUNCTION_CALL"
)
tinytest::expect_match(
    msg, "update\\.packages\\(\\)|install\\(\\)"
)
.BiocCheck$zero()

# checkCatInRCode ---------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
msg <- BiocCheck:::checkCatInRCode(.bioctest, c("cat", "print"))
expect_equivalent(length(msg), 9)
.BiocCheck$zero()

# checkDepDefInRCode ------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
msg <- BiocCheck:::findSymbolsInRFiles(
    .bioctest, c(".Deprecated", ".Defunct"), "SYMBOL_FUNCTION_CALL"
)
expect_equivalent(length(msg), 2L)
.BiocCheck$zero()

# checkEqInAssignment -----------------------------------------------------
.bioctest <- read_test_package("testpkg0")
msg <- BiocCheck:::checkEqInAssignment(
    .bioctest, symbol = "=", tokenType = "EQ_ASSIGN"
)
expect_equivalent(length(msg), 3)
.BiocCheck$zero()


# checkVignetteDir for Rhtml ----------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(
        VignetteBuilder="knitr", Suggests="knitr,rmarkdown"
    ),
    extraActions = function(pkgpath) {
        vigdir <- file.path(pkgpath, "vignettes")
        if (!dir.exists(vigdir))
            dir.create(vigdir, recursive = TRUE)
        file.copy(
            system.file(
                "testfiles", "test.Rhtml",
                package = "BiocCheck", mustWork = TRUE
            ),
            file.path(vigdir, "test.Rhtml")
        )
    }
)
BiocCheck:::checkVignetteDir(.bioctest)
expect_equivalent(
    length(.BiocCheck$get("note")[["checkChunkLabels"]]), 3
)
checkCounter(
    "Rhtml vignette missing chunk labels didn't cause note!",
    "note"
)
.BiocCheck$zero()

# checkVigInstalls --------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkVigInstalls(.bioctest)
expect_equivalent(.BiocCheck$getNum("error"), 1)
tinytest::expect_match(
    .BiocCheck$get("error")[[1L]][1L],
    "Package installation calls"
)
.BiocCheck$zero()

# checkDupChunkLabels -----------------------------------------------------
vigfile <-  system.file(
    "testpackages", "testpkg0", "vignettes", "dupChunks.Rmd",
    package="BiocCheck", mustWork = TRUE
)
BiocCheck:::checkDupChunkLabels(vigfile)
expect_equivalent(
    length(.BiocCheck$get("error")[["checkDupChunkLabels"]]), 3
)
checkCounter("Duplicate chunk labels didn't cause error!")

# checkTFSymbolUsage ------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkTFSymbolUsage(.bioctest)
expect_equivalent(.BiocCheck$getNum("warning"), 1)
.BiocCheck$zero()

# checkVigSessionInfo -----------------------------------------------------
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkVigSessionInfo(.bioctest)
expect_equivalent(.BiocCheck$getNum("note"), 1)
.BiocCheck$zero()

# checkForInstall ---------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
parsedCode <- BiocCheck:::parseFiles(.bioctest)
res <- BiocCheck:::findSymbolInParsedCode(
    parsedCode, "testpkg0", "install", "SYMBOL_FUNCTION_CALL"
)
expect_equivalent(res, 2)

# checkVigBiocInst --------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkVigBiocInst(.bioctest)
expect_true(.BiocCheck$getNum("warning") == 1)
.BiocCheck$zero()

# checkClassNEEQLookup ----------------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    extraActions = function(path) {
        Rdir <- file.path(path, "R")
        if (!dir.exists(Rdir))
            dir.create(Rdir)
        fl <- tempfile(tmpdir = Rdir, fileext = ".R")
        cat(
            paste(
                ## bad
                "class(a)=='foo'", "class(a)!='foo'",
                "if (is(a) == 'character')", "is( a ) != 'numeric'",
                ## ok
                "is(a, 'List')", "is.numeric(a)",
                sep="\n"),
            "\n", file = fl
        )
    }
)
match <- BiocCheck:::checkClassNEEQLookup(.bioctest)
expect_identical(4L, length(match))
unlink(temp_dir, recursive = TRUE)

# checkDESCRIPTIONfile ----------------------------------------------------
dcf <- matrix("https://example.com", dimnames = list(NULL, "URL"))
BiocCheck:::checkDESCfields(dcf)
expect_equivalent(.BiocCheck$getNum("note"), 1)
.BiocCheck$zero()

dcf <- matrix("https://example.com", dimnames = list(NULL, "BugReports"))
BiocCheck:::checkDESCfields(dcf)
expect_equivalent(.BiocCheck$getNum("note"), 1)
.BiocCheck$zero()

dcf <- matrix(
    c("https://example.com", "https://example.com"), nrow = 1,
    dimnames = list(NULL, c("BugReports", "URL"))
)
BiocCheck:::checkDESCfields(dcf)
expect_equivalent(.BiocCheck$getNum("note"), 0)
.BiocCheck$zero()

dcf <- matrix(
    c("https://example.com", "https://example.com"), nrow = 1,
    dimnames = list(NULL, c("BugReports", "URL"))
)
BiocCheck:::checkBiocDepsDESC(dcf)
expect_equivalent(.BiocCheck$getNum("warning"), 1)
.BiocCheck$zero()

dcf <- matrix(
    "S4Vectors (== 0.99.0)", nrow = 1,
    dimnames = list(NULL, "Depends")
)
BiocCheck:::checkBiocDepsDESC(dcf)
expect_equivalent(.BiocCheck$getNum("warning"), 0)
.BiocCheck$zero()

dcf <- matrix(
    "S4Vectors (== 0.99.0)", nrow = 1,
    dimnames = list(NULL, "Depends")
)
BiocCheck:::checkPinnedDeps(dcf)
expect_equivalent(.BiocCheck$getNum("error"), 1)
.BiocCheck$zero()

# remotesUsage ------------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkRemotesUsage(.BiocPackage = .bioctest)
expect_equivalent(1, BiocCheck:::.BiocCheck$getNum("error"))
expect_true(grepl("Remotes:", BiocCheck:::.BiocCheck$get("error")[1]))
.BiocCheck$zero()
.bioctest <- read_test_package("testpkg1")
BiocCheck:::checkRemotesUsage(.bioctest)
expect_equivalent(0, BiocCheck:::.BiocCheck$getNum("error"))
.BiocCheck$zero()

# LazyDataUsage -----------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkLazyDataUsage(.bioctest)
expect_equivalent(1, BiocCheck:::.BiocCheck$getNum("note"))
.BiocCheck$zero()

# checkForLibraryRequire -------------------------------------------------
.bioctest <- read_test_package("testpkg0")
msg <- BiocCheck:::checkForLibraryRequire(.bioctest)
expect_equivalent(1L, .BiocCheck$getNum("warning"))
expect_equivalent(length(msg), 14L)
.BiocCheck$zero()

# getFunctionLengths ------------------------------------------------------
file <- system.file(
    "testpackages", "testpkg0", "R", "parseme.R",
    package = "BiocCheck"
)
df <- getParseData(parse(file, keep.source = TRUE))
res <- BiocCheck:::getFunctionLengths(df)
res0 <- tibble::tribble(
    ~length, ~startLine, ~endLine, ~codingLines,
    2,          1,        2,            2,
    1,          3,        3,            1,
    1,          6,        6,            1,
    5,          9,       13,            4,
    4,         16,       19,            4,
    6,         23,       28,            3,
    1,         31,       31,            1,
    1,         33,       33,            1,
    6,         35,       40,            2,
    7,         44,       50,            4
)
res0 <- apply(res0, 1L, force, simplify = FALSE)
names(res0) <- c(
    "_anonymous_.1", "fa", "f2", "f3", "f4", "_anonymous_.23",
    "f5", "f6", "f7", "f8"
)
expect_identical(res0, res)

# getFunctionLengths2 -----------------------------------------------------
## 1 function is greater than 50 lines long
.bioctest <- read_test_package("testpkg0")
parsedCode <- BiocCheck:::parseFiles(.bioctest)
res <- BiocCheck:::checkFunctionLengths(parsedCode, "testpkg0")
expect_equivalent(BiocCheck:::.BiocCheck$getNum("note"), 1)
expect_true(
    grepl(
        pattern = "There is 1 function greater than 50 lines",
        x = BiocCheck:::.BiocCheck$note$checkFunctionLengths[[1]]
    ),
    info = "Checking we report functions > 50 lines long."
)
.BiocCheck$zero()

# checkExportsAreDocumented ------------------------------------------------
.bioctest <- read_test_package("testpkg0")
instdir <- BiocCheck:::.tryInstallwLoad(.bioctest)
res <- BiocCheck:::checkExportsAreDocumented(
    .bioctest, lib.loc = file.path(instdir, "lib")
)
expect_equivalent(1, .BiocCheck$getNum("error"))
.BiocCheck$zero()
res <- BiocCheck:::checkUsageOfDont(.bioctest)
expect_equivalent(2, .BiocCheck$getNum("note"))
.BiocCheck$zero()

# checkNEWS ---------------------------------------------------------------
BiocCheck:::checkNEWS(system.file("testpackages", "testpkg0",
    package="BiocCheck"))
expect_equivalent(1, .BiocCheck$getNum("note"))
.BiocCheck$zero()
if (!dir.exists(UNIT_TEST_TEMPDIR))
    dir.create(UNIT_TEST_TEMPDIR)
cat("lalala", file = file.path(UNIT_TEST_TEMPDIR, "NEWS"))
BiocCheck:::checkNEWS(UNIT_TEST_TEMPDIR)
stillZero()
unlink(file.path(UNIT_TEST_TEMPDIR, "NEWS"))
dir.create(file.path(UNIT_TEST_TEMPDIR, "inst"), FALSE)
cat("lalala", file = file.path(UNIT_TEST_TEMPDIR, "inst", "NEWS.Rd"))
BiocCheck:::checkNEWS(UNIT_TEST_TEMPDIR)
expect_equivalent(1, .BiocCheck$getNum("warning"))
.BiocCheck$zero()
cat("lalala", file = file.path(UNIT_TEST_TEMPDIR, "NEWS.md"))
BiocCheck:::checkNEWS(UNIT_TEST_TEMPDIR)
expect_equivalent(1, .BiocCheck$getNum("note"))
expect_equivalent(1, .BiocCheck$getNum("warning"))
.BiocCheck$zero()

# checkFormatting ---------------------------------------------------------
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkFormatting(.bioctest)
expect_equivalent(3, .BiocCheck$getNum("note"))
.BiocCheck$zero()

# checkForPromptComments -------------------------------------------------
.bioctest <- read_test_package("testpkg0")
BiocCheck:::checkForPromptComments(.bioctest)
expect_equivalent(1, .BiocCheck$getNum("note"))
.BiocCheck$zero()

# getPkgType -------------------------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir, description = list(Foo = "bar")
)
expect_identical("", .bioctest$packageType)

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(biocViews = "bad, Software")
)
expect_identical(.bioctest$packageType, NA_character_)

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(biocViews = "DifferentialExpression, CellBiology")
)
expect_identical("Software", .bioctest$packageType)

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description =
        list(biocViews = "DifferentialExpression, ChipManufacturer")
)
expect_identical(.bioctest$packageType, NA_character_)

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description =
        list(biocViews = "GeneCardsCustomSchema, ChipManufacturer")
)
expect_identical("AnnotationData", .bioctest$packageType)

# Cancer is not a valid biocView, so return exception
.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(biocViews = "Cancer, HapMap")
)
expect_identical(.bioctest$packageType, NA_character_)
unlink(temp_dir, recursive = TRUE)

# checkForBiocDevelSubscription -------------------------------------------
if (nchar(Sys.getenv("BIOC_DEVEL_PASSWORD"))) {

    temp_dir <- tempfile()
    .bioctest <- create_test_package(
        test_dir = temp_dir,
        description = list(Maintainer = "Joe Blow <foo@bar.com>")
    )
    BiocCheck:::checkForBiocDevelSubscription(.bioctest)
    checkCounter("Maintainer subscribed to the bioc-devel mailing list")

    .bioctest <- create_test_package(
        test_dir = temp_dir,
        description = list(
            Maintainer =
                "Bioconductor Maintainer <maintainer@bioconductor.org>"
        ),
        use.canned = FALSE
    )
    BiocCheck:::checkForBiocDevelSubscription(.bioctest)
    expect_true(stillZero())
    .BiocCheck$zero()

    .bioctest <- create_test_package(
        test_dir = temp_dir,
        description = list(
            Maintainer =
                "Bioconductor Maintainer <MAINTAINER@bioconductor.ORG>"
        ),
        use.canned = FALSE
    )
    BiocCheck:::checkForBiocDevelSubscription(.bioctest)
    expect_true(stillZero())
    .BiocCheck$zero()

    result_email <- BiocCheck:::getMaintainerEmail(.bioctest)
    expect_true(
        identical(result_email, "MAINTAINER@bioconductor.ORG")
    )

    .bioctest <- create_test_package(
        test_dir = temp_dir,
        description = list(
            Package = "uniTestTempDir",
            Version = "0.99.0",
            `Authors@R` = c("person('BioC', 'Maintainer',",
                "email = 'Maintainer@bioconductor.org',",
                "role = c('aut', 'cre'))"
            )
        ),
        use.canned = FALSE
    )
    result_email <- BiocCheck:::getMaintainerEmail(.bioctest)
    expect_identical(result_email, "Maintainer@bioconductor.org")

    .bioctest <- create_test_package(
        test_dir = temp_dir,
        description = list(
            Version = "0.99.0",
            `Authors@R` = c(
                "c(person('Joe', \n  'Blow', email='joe@blow.org',",
                "role=c('aut', 'cre')))"
            )
        ),
        use.canned = FALSE
    )
    BiocCheck:::checkForBiocDevelSubscription(.bioctest)
    checkCounter("Maintainer subscribed to the bioc-devel mailing list")

    .bioctest <- create_test_package(
        test_dir = temp_dir,
        description = list(
            Version = "0.99.0",
            `Authors@R` = c(
                "c(person('BioC', \n  'Maintainer',",
                "email='maintainer@bioconductor.org',",
                "role=c('aut', 'cre')))"
            )
        ),
        use.canned = FALSE
    )
    BiocCheck:::checkForBiocDevelSubscription(.bioctest)
    expect_true(stillZero())
    .BiocCheck$zero()
    unlink(temp_dir, recursive = TRUE)

}

# checkForSupportSiteRegistration ----------------------------------------
connect <- suppressWarnings(
    tryCatch({
        readBin("https://support.bioconductor.org", n=1L, what="raw")
        TRUE
    }, error = function(...) {
        FALSE
    })
)

if (connect) {

    # Email registration
    .BiocCheck$zero()
    BiocCheck:::checkSupportReg("lori.shepherd@roswellpark.org")
    expect_true(stillZero())
    BiocCheck:::checkSupportReg("foo@bar.com")
    expect_equivalent(.BiocCheck$getNum("error"), 1)
    .BiocCheck$zero()
    ## api is case insensitivy
    BiocCheck:::checkSupportReg("lori.shePhErd@roswellpark.org")
    expect_true(stillZero())


    # tags
    BiocCheck:::checkWatchedTag(
        "lori.shepherd@roswellpark.org", "biocfilecache"
    )
    expect_true(stillZero())
    BiocCheck:::checkWatchedTag(
        "lori.shepherd@roswellpark.org", "unwatchedpackage"
    )
    expect_equivalent(.BiocCheck$getNum("error"), 1)
    .BiocCheck$zero()
    ## email is case insensitive
    BiocCheck:::checkWatchedTag(
        "lori.shePherd@rosWellpark.org", "biocfilecache"
    )
    expect_true(stillZero())
    ## check tag is case insenstive
    BiocCheck:::checkWatchedTag(
        "lori.shepherd@rosWellpark.org", "bioCfiLecache"
    )
    expect_true(stillZero())

}

# checkForVersionNumberMismatch -------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(Version="0.0.1")
)
pkgname <- .bioctest$packageName

oldname <- devtools::build(.bioctest$sourceDir)

newname <- file.path(dirname(oldname), paste0(pkgname, "_9.9.9.tar.gz"))
if (!file.rename(oldname, newname)) {
    file.remove(oldname)
    stop("'file.rename()' failed to rename badkpgk",
         "\n  oldname: ", oldname, " newname: ", newname,
         "\n  cmd: ", cmd,
         "\n  result:",
         "\n    ", paste(result, collapse="\n    "),
         "\n")
}
.newbioctest <- .BiocPackage$initialize(newname)

BiocCheck:::checkForVersionNumberMismatch(
    .newbioctest
)
expect_equivalent(.BiocCheck$getNum("error"), 1)
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)

# checkForDirectSlotAccess ------------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(VignetteBuilder="knitr"),
    extraActions = function(pkgpath) {
        vigdir <- file.path(pkgpath, "vignettes")
        if (!dir.exists(vigdir))
            dir.create(vigdir, recursive = TRUE)
        file.copy(
            system.file(
                "testfiles", "directSlotAccess.Rmd",
                package = "BiocCheck", mustWork = TRUE
            ),
            file.path(vigdir, "directSlotAccess.Rmd")
        )
        file.copy(
            system.file(
                "testfiles", "noDirectSlotAccess.Rmd",
                package = "BiocCheck", mustWork = TRUE
            ),
            file.path(vigdir, "noDirectSlotAccess.Rmd")
        )
    }
)
pkgpath <- .bioctest$sourceDir

parsedCode <- list(
    FooBar = BiocCheck:::parseFile(
        .bioctest, .bioctest$VigSources[1]
    )
)
res <- BiocCheck:::checkForDirectSlotAccess(parsedCode, pkgpath)
expect_equivalent(BiocCheck:::.BiocCheck$getNum("note"), 1)
.BiocCheck$zero()
parsedCode <- list(
    FooBar = BiocCheck:::parseFile(
        .bioctest, .bioctest$VigSources[2]
    )
)
res <- BiocCheck:::checkForDirectSlotAccess(parsedCode, pkgpath)
expect_equivalent(.BiocCheck$getNum("note"), 0)
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)

# checkRVersionDependency -------------------------------------------------
temp_dir <- tempfile()
.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(Depends = "R (>= 1.0.0)")
)
BiocCheck:::checkRVersionDependency(.bioctest)
expect_equivalent(.BiocCheck$getNum("note"), 1)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(Depends = "R")
)
BiocCheck:::checkRVersionDependency(.bioctest)
expect_equivalent(.BiocCheck$getNum("note"), 0)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(Imports = "foobar)")
)
BiocCheck:::checkRVersionDependency(.bioctest)
expect_equivalent(.BiocCheck$getNum("warning"), 0)
.BiocCheck$zero()

.bioctest <- create_test_package(
    test_dir = temp_dir,
    description = list(Depends = "R (>= 10000.0.0)")
)
BiocCheck:::checkRVersionDependency(.bioctest)
expect_equivalent(.BiocCheck$getNum("note"), 0)
.BiocCheck$zero()
unlink(temp_dir, recursive = TRUE)

# doesManPageHaveRunnableExample -------------------------------------------
good <- tools::parse_Rd(system.file("testpackages", "testpkg0", "man",
        "has-devel.Rd", package = "BiocCheck"))

bad <- tools::parse_Rd(system.file("testpackages", "testpkg0", "man",
        "baddep.Rd", package = "BiocCheck"))

expect_true(BiocCheck:::doesManPageHaveRunnableExample(good))

expect_false(BiocCheck:::doesManPageHaveRunnableExample(bad))

# checkForValueSection ----------------------------------------------------
.bioctest <- read_test_package("testpkg0")
mans <-
    BiocCheck:::.read_all_rds(.bioctest$manSources, .bioctest$usesRdpack)
tags <- lapply(mans, BiocCheck:::.RdTags)
expect_true(!BiocCheck:::.valueInParsedRd(mans[[1]], tags[[1]]))
expect_true(!BiocCheck:::.valueInParsedRd(mans[[2]], tags[[2]]))
expect_true(BiocCheck:::.valueInParsedRd(mans[[3]], tags[[3]]))

.bioctest <- read_test_package("testpkg1")
mans <-
    BiocCheck:::.read_all_rds(.bioctest$manSources, .bioctest$usesRdpack)
tags <- lapply(mans, BiocCheck:::.RdTags)
expect_true(!BiocCheck:::.valueInParsedRd(mans[[1]], tags[[1]]))
expect_true(!BiocCheck:::.valueInParsedRd(mans[[2]], tags[[2]]))

# packageAlreadyExists -----------------------------------------------------
.BiocCheck$zero()
nerrors <- 0L
BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "CRAN")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("devtools", "CRAN")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "BioCsoft")
nerrors <- nerrors + 1L
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("gwascatData", "BioCann")
nerrors <- nerrors + 1L
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("TENxBrainData", "BioCexp")
nerrors <- nerrors + 1L
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("annotation", "BioCworkflows")
nerrors <- nerrors + 1L
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "BioCexp")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "BioCann")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("GenomicRanges", "BioCworkflows")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "BioCexp")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "BioCann")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "BioCworkflows")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "CRAN")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
BiocCheck:::checkIsPackageNameAlreadyInUse("ImNotFound", "BioCsoft")
expect_equivalent(.BiocCheck$getNum("error"), nerrors)
.BiocCheck$zero()

# BiocCheckReporters -------------------------------------------------------
pkgdir <- system.file("testpackages", package="BiocCheck")
hypo_checkdir <- file.path(pkgdir, "hypoPkg.BiocCheck")
oldCheckDir <- .BiocCheck$metadata$BiocCheckDir
.BiocCheck$metadata$BiocCheckDir <- hypo_checkdir
.BiocCheck$report(debug = FALSE, isOnBBS = TRUE)
expect_true(
    !dir.exists(hypo_checkdir)
)
expect_true(
    !dir.exists(hypo_checkdir)
)
.BiocCheck$metadata$BiocCheckDir <- oldCheckDir

# checkUsageOfDont ---------------------------------------------------------
## testpkg0 should trigger this note for 2 out of 3 man pages
.bioctest <- read_test_package("testpkg0")
BiocCheck:::.tryInstallwLoad(.bioctest)
notemsg <- capture.output(
    BiocCheck:::checkUsageOfDont(.bioctest), type = "message"
)
expect_equivalent(2, .BiocCheck$getNum("note"))
# here we verify the correct number of pages were detected
expect_true( any(grepl("67%", notemsg)) )
.BiocCheck$zero()

## testpkg1 contains a man page with keyword 'internal'
## this shouldn't trigger the note
.bioctest <- read_test_package("testpkg1")
BiocCheck:::.tryInstallwLoad(.bioctest)
BiocCheck:::checkUsageOfDont(.bioctest)
expect_equivalent(0, .BiocCheck$getNum("note"))
.BiocCheck$zero()

# checkORCID ---------------------------------------------------------------
orcid <- c(
    "0000-0001-6197-3471",
    "0000-0001-6197-347X",
    "0000-0001-6197-34XX",
    "0000-0001-6197-3471-0000",
    "",
    NA_character_
)
valid <- c(TRUE, TRUE, FALSE, FALSE, FALSE, FALSE)
expect_identical(valid, BiocCheck:::.checkORCID(orcid))

# getBiocCheckDir <- function() {
.bioctest <- read_test_package("testpkg0")
expect_identical(
    basename(.bioctest$BiocCheckDir), "testpkg0.BiocCheck"
)
expect_identical(
    basename(dirname(.bioctest$BiocCheckDir)),
    "testpackages"
)

# getDirFiles --------------------------------------------------------------
vigfiles <- list.files(
    system.file(
        "testpackages", "testpkg0", "vignettes", package="BiocCheck"
    ),
    full.names = TRUE
)
targets <- file.path(basename(dirname(vigfiles)), basename(vigfiles))
expect_identical(
    targets[1], unname(BiocCheck:::.getDirFiles(vigfiles[1]))
)
expect_identical(targets, unname(BiocCheck:::.getDirFiles(vigfiles)))

.HIDDEN_FILE_EXTS <- c(
    ".renviron", ".rprofile", ".rproj", ".rproj.user", ".rhistory",
    ".rapp.history", ".o", ".sl", ".so", ".dylib", ".a", ".dll", ".def",
    ".ds_store", "unsrturl.bst", ".log", ".aux", ".backups", ".cproject",
    ".directory", ".dropbox", ".exrc", ".gdb.history", ".gitattributes",
    ".gitmodules", ".hgtags", ".project", ".seed", ".settings",
    ".tm_properties", ".rdata"
)

# taken from
# https://github.com/wch/r-source/blob/trunk/src/library/tools/R/build.R#L462
# https://github.com/wch/r-source/blob/trunk/src/library/tools/R/check.R#L4025
hidden_file_data <- data.frame(
    file_ext = .HIDDEN_FILE_EXTS,
    hidden_only = c(TRUE, TRUE, FALSE, TRUE, TRUE,
        TRUE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE,
        TRUE, TRUE, FALSE, FALSE, FALSE, FALSE,
        FALSE, FALSE, FALSE, FALSE, TRUE,
        TRUE, FALSE, TRUE, FALSE, FALSE,
        FALSE, TRUE)
)

#' Checks specific to a Git clone of a package repository
#'
#' Analyzes an R package for adherence with Bioconductor package guidelines and
#' best practices. The check outputs are categorized into ERROR, WARNING, and
#' NOTE. This function is typically used in the Bioconductor Build System (BBS)
#' and not intended for general use.
#'
#' `BiocCheckGitClone()` reviews R packages for adherence with
#' Bioconductor package guidelines and best practices. See
#' <https://contributions.bioconductor.org> for the latest guidance for
#' writing Bioconductor software. This function should only be run on a source
#' directory and not on a tarball.
#'
#' `BiocCheckGitClone` is called within R with, as
#' `BiocCheckGitClone("package")` where `package` is the source directory
#' containing the `R` package.
#'
#' @param package A directory containing an R source package. Not a package tar
#' ball.
#'
#' @param \dots Currently, only `quit-with-status` is available.  See
#' `BiocCheck`
#'
#'
#' @return `BiocCheckGitClone()` is chiefly called for the side effect of the
#'   check reporting. The function returns a `BiocCheck` reference class with
#'   three main list elements:
#'
#' * error: Items to address before the package can be accepted
#'
#' * warning: Strongly suggested items that may require attention
#'
#' * note: Items to consider, though not required, before acceptance
#'
#' @author Lori Shepherd
#'
#' @references <https://contributions.bioconductor.org>
#' @seealso [BiocCheck-class]
#'
#' @examples
#'
#' packageDir <- system.file("testpackages", "testpkg0", package="BiocCheck")
#' BiocCheckGitClone(packageDir, `quit-with-status`=FALSE)
#'
#' @export BiocCheckGitClone
BiocCheckGitClone <- function(package=".", ...)
{
    .BiocCheck$zero()
    package <- normalizePath(package)
    if (!dir.exists(package))
        .stop("Package directory does not exist")
    .BiocPackage <- .BiocPackage$initialize(package)
    if (.BiocPackage$isTar)
        .stop("Run 'BiocCheckGitClone' on the Git-cloned package directory.")
    # be careful here:
    if (identical(.Platform$OS.type, "windows"))
        package <- gsub("\\\\", "/", package)

    dots <- list(...)
    if (length(dots) == 1L && is.list(dots[[1]]))
        dots <- dots[[1]]               # command line args come as list

    oldwarn <- getOption("warn")
    oldwidth <- getOption("cli.width")
    on.exit({
        options(warn = oldwarn, cli.width = oldwidth)
    })
    options(warn = 1, cli.width = 80)

    .BiocCheck$addMetadata(.BiocPackage)
    .BiocCheck$show_meta()

    # BiocCheck checks --------------------------------------------------------
    handleCheck("Checking valid files...")
    checkBadFiles(.BiocPackage)

    handleCheck("Checking individual file sizes...")
    checkIndivFileSizes(.BiocPackage)
    checkDataFileSizes(.BiocPackage)

    handleCheck("Checking for stray BiocCheck output folders...")
    checkBiocCheckOutputFolder(.BiocPackage)

    handleCheck("Checking for inst/doc folders...")
    checkInstDocFolder(.BiocPackage)

    checkDESCRIPTION(.BiocPackage)

    handleCheck("Checking for remote package usage...")
    checkRemotesUsage(.BiocPackage)

    checkNAMESPACE(.BiocPackage)
    validMaintainer(.BiocPackage)

    handleCheck("Checking CITATION...")
    checkForCitationFile(.BiocPackage)

    # BiocCheck results -------------------------------------------------------
    cli::cli_rule(
        left = paste0("BiocCheck v", packageVersion("BiocCheck"), " results")
    )
    cli::cli_text(
        paste0(
            "{symbol$cross} { .BiocCheck$getNum('error') } ERRORS | ",
            "{symbol$warning} { .BiocCheck$getNum('warning') } WARNINGS | ",
            "{symbol$info} { .BiocCheck$getNum('note') } NOTES\n"
        )
    )
    cli::cli_alert_info(
        "\nFor more details, run\n  browseVignettes(package = 'BiocCheck')"
    )

    if (isTRUE(dots[["quit-with-status"]])) {
        errcode <- as.integer(.BiocCheck$getNum("error") > 0)
        q("no", errcode)
    }

    return(.BiocCheck)
}

# Checks for BiocCheckGitClone --------------------------------------------

checkBadFiles <- function(.BiocPackage) {
    package_dir <- .BiocPackage$sourceDir
    swith <- ifelse(hidden_file_data[["hidden_only"]], .Platform$file.sep, "")
    ext_expr <- paste0(
        swith, "\\", hidden_file_data[["file_ext"]], "$", collapse = "|"
    )

    fls <- dir(package_dir, recursive=TRUE, all.files=TRUE)
    flist <- split(fls, startsWith(fls, "inst"))
    warns <- grep(ext_expr, ignore.case = TRUE, flist[['TRUE']], value = TRUE)
    errs <- grep(ext_expr, ignore.case = TRUE, flist[['FALSE']], value = TRUE)

    ## use gitignore to filter out false positives
    gitignore <- file.path(package_dir, ".gitignore")
    if (file.exists(gitignore)) {
        gitignore <- readLines(gitignore)
        filter_expr <- paste0(utils::glob2rx(gitignore), collapse = "|")
        ignored <- grep(
            filter_expr, ignore.case = TRUE, flist[["FALSE"]], value = TRUE
        )
        errs <- errs[!errs %in% ignored]
    }
    if (length(warns)) {
        handleWarning(
            "System files in '/inst' should not be Git tracked.",
            messages = warns
        )
    }

    if (length(errs)) {
        handleError(
            "System files found that should not be Git tracked.",
            messages = errs
        )
    }
}

checkForCitationFile <- function(.BiocPackage) {
    package_dir <- .BiocPackage$sourceDir
    citfile_location <- file.path(package_dir, "inst", "CITATION")
    if (file.exists(citfile_location)) {
        handleCheck(
            "Checking that provided CITATION file is correctly formatted..."
        )
        cit <- try(readCitationFile(citfile_location), silent = TRUE)
        if (is(cit, "try-error"))
            handleWarning(
                "Unable to read CITATION file with 'utils::readCitationFile()'"
            )
        else if (is.null(cit$doi))
            handleWarning(
                "The 'doi' argument is missing or empty in the CITATION's ",
                "'bibentry()'. Only include a CITATION file if there is a ",
                "preprint or publication associated with this Bioconductor ",
                "package."
            )
    } else {
        handleNote(
            "(Optional) CITATION file not found. Only include a CITATION ",
            "file if there is a preprint or publication for this Bioconductor ",
            "package. Note that Bioconductor packages are not required to ",
            "have a CITATION file but it is useful both for users and for ",
            "tracking Bioconductor project-wide metrics. When including a ",
            "CITATION file, add the publication using the  'doi' argument ",
            "of 'bibentry()'."
        )
    }
}

# check R coding practice -------------------------------------------------

checkCodingPractice <- function(.BiocPackage, parsedCode)
{
    package_name <- .BiocPackage$packageName
    pkgdir <- .BiocPackage$sourceDir
    Rdir <- file.path(pkgdir, "R")

    # sapply
    msg_sapply <- checkSapply(.BiocPackage)
    if (length(msg_sapply)) {
        handleNoteFiles(
            " Avoid sapply(); use vapply()",
            messages = msg_sapply
        )
    }

    # 1:...
    msg_seq <- check1toN(.BiocPackage)
    if (length(msg_seq)) {
        handleNoteFiles(
            " Avoid 1:...; use seq_len() or seq_along()",
            messages = msg_seq
        )
    }

    # pkg:fun...
    msg_sc <- checkSingleColon(.BiocPackage)
    if (length(msg_sc)) {
        handleErrorFiles(
            " Use double colon for qualified imports: 'pkg::foo()'",
            messages = msg_sc
        )
    }

    # cat() and print()
    msg_cat <- checkCatInRCode(.BiocPackage)
    if (length(msg_cat)) {
        handleNoteFiles(
            " Avoid 'cat' and 'print' outside of 'show' methods",
            messages = msg_cat
        )
    }

    # assignment with =
    msg_eq <- checkEqInAssignment(.BiocPackage)
    if (length(msg_eq)) {
        handleNoteFiles(
            " Avoid using '=' for assignment and use '<-' instead",
            messages = msg_eq
        )
    }

    # message(paste(...))
    msg_mp <- checkPasteInSignaler(.BiocPackage)
    if (length(msg_mp)) {
        handleNoteFiles(
            " Avoid the use of 'paste' in condition signals",
            messages = msg_mp
        )
    }

    # stop("Error: ")
    msg_ss <- checkSignalerInSignaler(.BiocPackage)
    if (length(msg_ss)) {
        handleNoteFiles(
            "Avoid redundant 'stop' and 'warn*' in signal conditions",
            messages = msg_ss
        )
    }

    # T/F
    msg_tf <- findSymbolsInRFiles(
        .BiocPackage, c("T", "F"), "SYMBOL", notLookback = "$"
    )
    if (length(msg_tf)) {
        handleWarning(
            " Avoid T/F variables; If logical, use TRUE/FALSE ",
            help_text = paste("Found", length(msg_tf), "times:"),
            messages = msg_tf
        )
    }

    # class() ==
    msg_class <- checkClassNEEQLookup(.BiocPackage)
    if (length(msg_class)) {
        handleWarningFiles(
            " Avoid class membership checks with class() / is() and == / !=",
            "; Use is(x, 'class') for S4 classes",
            messages = msg_class
        )
    }

    # system() vs system2()
    msg_sys <- findSymbolsInRFiles(
        .BiocPackage, "system", "SYMBOL_FUNCTION_CALL"
    )
    if(length(msg_sys)) {
        handleNoteFiles(
            " Avoid system() ; use system2()",
            messages = msg_sys
        )
    }

    # external data
    msg_eda <- checkExternalData(.BiocPackage)
    if (length(msg_eda)) {
        handleErrorFiles(
            " Avoid references to external hosting platforms",
            messages = msg_eda
        )
    }

    # download / download.file in .onAttach / .onLoad
    msg_dl <- checkOnAttachLoadCalls(.BiocPackage)
    if (length(msg_dl)) {
        handleErrorFiles(
            " Avoid downloads in '.onAttach' or '.onLoad' functions",
            messages = msg_dl
        )
    }

    # set.seed
    msg_seed <-
        findSymbolsInRFiles(.BiocPackage, "set.seed", "SYMBOL_FUNCTION_CALL")
    if (length(msg_seed)){
        handleWarning(
            " Remove set.seed usage (found ", length(msg_seed), " times)",
            messages = msg_seed
        )
    }

    # .Deprecated / .Defunct usage should be updated after every release
    msg_depr <- findSymbolsInRFiles(
        .BiocPackage,
        c(
            ".Deprecated", ".Defunct", "lifeCycle",
            "deprecate_warn", "deprecate_stop"
        ),
        "SYMBOL_FUNCTION_CALL"
    )
    if (length(msg_depr)) {
        handleWarning(
            ".Deprecated / .Defunct usage (found ",
            length(msg_depr), " times)",
            messages = msg_depr
        )
    }

    handleCheck("Checking parsed R code in R directory, examples, vignettes...")

    # direct slot access
    checkForDirectSlotAccess(parsedCode, package_name)

    # browser() calls
    msg_b <-
        findSymbolsInRFiles(.BiocPackage, "browser", "SYMBOL_FUNCTION_CALL")
    if (length(msg_b)) {
        handleWarning(
            "Remove browser() statements (found ", length(msg_b), " times)",
            messages = msg_b
        )
    }

    # <<-
    msg_da <- findSymbolsInRFiles(.BiocPackage, "<<-", "LEFT_ASSIGN")
    if (length(msg_da)) {
        handleNote(
            "Avoid '<<-' if possible (found ", length(msg_da), " times)",
            messages = msg_da
        )
    }

    # Sys.setenv calls
    msg_env <-
        findSymbolsInRFiles(.BiocPackage, "Sys.setenv", "SYMBOL_FUNCTION_CALL")
    if (length(msg_env)) {
        handleWarning(
            "Avoid 'Sys.setenv' (found ", length(msg_env), " times)",
            messages = msg_env
        )
    }

    # suppressWarnings/Messages calls
    msg_supp <- findSymbolsInRFiles(
        .BiocPackage,
        c("suppressWarnings", "suppressMessages"),
        "SYMBOL_FUNCTION_CALL"
    )
    if (length(msg_supp)) {
        handleNote(
            "Avoid 'suppressWarnings'/'*Messages' if possible (found ",
            length(msg_supp), " times)",
            messages = msg_supp
        )
    }
}

checkSapply <- function(.BiocPackage) {
    msg_sapply <- findSymbolsInRFiles(
        .BiocPackage, "sapply", "SYMBOL_FUNCTION_CALL", FALSE
    )
}

check1toN <- function(.BiocPackage) {
    rfiles <- .BiocPackage$RSources
    msg_seq <- lapply(rfiles, function(rfile) {
        tokens <- getParseData(parse(rfile, keep.source=TRUE))
        tokens <- tokens[tokens[,"token"] != "expr", ,drop=FALSE]
        colons <- which(tokens[,"text"] == ":") - 1
        colons <- colons[tokens[colons, "text"] == "1"]
        tokens <- tokens[colons, , drop=FALSE]
        tokens <- tokens[ tokens[,"text"] == "1", , drop=FALSE]
        sprintf(
            "%s (line %d, column %d)",
            basename(rfile), tokens[,"line1"], tokens[,"col1"]
        )
    })
    msg_seq <- unlist(msg_seq)
}

checkSingleColon <- function(.BiocPackage, avail_pkgs = character(0L)) {

    rfiles <- .BiocPackage$RSources
    names(rfiles) <- basename(rfiles)
    colon_pres <- lapply(rfiles, function(rfile) {
        tokens <- getParseData(parse(rfile, keep.source = TRUE))
        tokens <- tokens[tokens[,"token"] != "expr", ,drop=FALSE]
        colons <- which(tokens[,"text"] == ":") - 1
        colons <- colons[grepl("[[:alpha:]]", tokens[colons, "text"])]
        tokens[colons, , drop = FALSE]
    })
    colon_pres <- Filter(nrow, colon_pres)
    if (length(colon_pres))
        avail_pkgs <- BiocManager::available()
    msg_sc <- lapply(names(colon_pres), function(rfile, framelist) {
        tokens <- framelist[[rfile]]
        tokens <- tokens[tokens[, "text"] %in% avail_pkgs, , drop = FALSE]
        sprintf(
            "%s (line %d, column %d)",
            rfile, tokens[, "line1"], tokens[, "col1"]
        )
    }, framelist = colon_pres)
    msg_sc <- unlist(msg_sc)
}

.filtTokens <-
    function(ind, tokens, keywords = c("paste0", "paste"))
{
    txt <- tokens[ind, "text"]
    filt <- tolower(txt) %in% keywords
    #filt <- grepl(txt, keywords, ignore.case = ignore.case)
    if (any(filt) && "collapse" %in% txt)
        filt <- FALSE
    ind[filt]
}

.getTokens <- function(rfile) {
    tokens <- getParseData(parse(rfile, keep.source = TRUE))
    tokens[tokens[,"token"] != "expr", ,drop=FALSE]
}

.grepSymbolRanges <- function(
    tokens, patterns, tokenType = "SYMBOL_FUNCTION_CALL", isExp = FALSE
) {
    txt <- tokens[, "text"]
    found <- lapply(patterns, function(pattern) grepl(pattern, txt))
    found <- Reduce(`|`, found)
    hits <- which(found & tokens[, "token"] == tokenType)
    openBracket <- if (isExp) "{" else "("
    .getSigRange(
        tokens, hits, openBracket
    )
}

.findMinNext <- function(tokens, after, cname = c("token", "text"), cvalue) {
    cname <- match.arg(cname)
    which(
        seq_len(nrow(tokens)) > after &
            tokens[, cname] == cvalue
    ) |>
        min()
}

#' @importFrom BiocBaseUtils isScalarNumber
.getSigRange <- function(tokens, signalers, bracket) {
    opar <- which(tokens[, "text"] == bracket)
    lapply(
        signalers, function(x) {
            next_opar <- opar[opar > x]
            if (length(next_opar)) {
                startSig <- min(next_opar)
                parnum <- tokens[startSig, "parent"]
                endSig <- nrow(tokens) - match(parnum, rev(tokens[, "parent"]))
            } else {
                sigFun <- .findMinNext(
                    tokens, x, "token", "FUNCTION"
                )
                parnum <- tokens[sigFun, "parent"]
                endFun <- nrow(tokens) - match(parnum, rev(tokens[, "parent"]))

                startSig <- .findMinNext(
                    tokens, after = endFun, "token", "SYMBOL_FUNCTION_CALL"
                ) |>
                    .findMinNext(
                        tokens, after = _, "text", "("
                    )
                parnum <- tokens[startSig, "parent"]
                endSig <- nrow(tokens) - match(parnum, rev(tokens[, "parent"]))
            }
            if (!isScalarNumber(startSig) || !isScalarNumber(endSig))
                integer(0L)
            else
                seq(startSig, endSig)
        }
    )
}

.findSymbolRanges <-
    function(tokens, symbols, tokenType = "SYMBOL_FUNCTION_CALL", isExp = FALSE)
{
    txt <- tokens[, "text"]
    signalers <- which(
        txt %in% symbols & tokens[, "token"] == tokenType
    )
    openBracket <- if (isExp) "{" else "("
    .getSigRange(
        tokens, signalers, openBracket
    )
}

.findInSignaler <- function(rfile, symbols, FUN, ...) {
    tokens <- .getTokens(rfile)
    sigRanges <- .findSymbolRanges(tokens, symbols)
    pasteInd <- lapply(sigRanges, FUN, tokens = tokens, ...)
    tokens <- tokens[unlist(pasteInd), , drop = FALSE]
    rfile <- paste0("R/", basename(rfile))
    sprintf(
        "%s (line %d, column %d)",
        rfile, tokens[, "line1"], tokens[, "col1"]
    )
}

.SIGNALERS_TXT <- c("message", "warning", "stop")

.findPasteInSignaler <- function(rfile, symbols = .SIGNALERS_TXT) {
    .findInSignaler(rfile, symbols, .filtTokens)
}

.filtersetMethodRanges <- function(tokens) {
    excl <- .findSymbolRanges(tokens, "setMethod")
    if (length(excl)) {
        showHits <- vapply(excl,
            function(x) '"show"' %in% tokens[x, "text"], logical(1))
        negind <- unlist(lapply(excl[showHits], `-`))
        tokens <- tokens[negind, ]
    }
    tokens
}

.filterS3printRanges <- function(tokens) {
    excl <- .grepSymbolRanges(tokens, "^print\\..*", tokenType = "SYMBOL")
    if (length(excl)) {
        showHits <- vapply(excl,
            function(x) "cat" %in% tokens[x, "text"], logical(1)
        )
        negind <- unlist(lapply(excl[showHits], `-`))
        tokens <- tokens[negind, ]
    }
    tokens
}

checkCatInRCode <-
    function(.BiocPackage, symbols = c("cat", "print"))
{
    rfiles <- .BiocPackage$RSources
    parsedCodes <- lapply(
        structure(rfiles, .Names = rfiles), parseFile,
        .BiocPackage = .BiocPackage
    )
    parsedCodes <- lapply(parsedCodes, .filtersetMethodRanges)
    parsedCodes <- lapply(parsedCodes, .filterS3printRanges)
    msg_res <- findSymbolsInParsedCode(
        parsedCodeList = parsedCodes,
        symbolNames = symbols,
        tokenTypes = c("SYMBOL_FUNCTION_CALL", "SYMBOL")
    )
    unlist(msg_res)
}

checkEqInAssignment <-
    function(.BiocPackage, symbol = "=", tokenType = "EQ_ASSIGN")
{
    rfiles <- .BiocPackage$RSources
    parsedCodes <- lapply(
        structure(rfiles, .Names = rfiles), parseFile,
        .BiocPackage = .BiocPackage
    )
    msg_res <- findSymbolsInParsedCode(
        parsedCodeList = parsedCodes,
        symbolNames = symbol,
        tokenTypes = tokenType,
        fun = FALSE
    )
    unlist(msg_res)
}

.grepTokens <-
    function(ind, tokens, keywords)
{
    txt <- tokens[ind, , drop = FALSE]
    strs <- txt$token == "STR_CONST"
    ind <- ind[strs]
    txt <- txt[strs, "text"]
    filt <- grepl(paste0(keywords, collapse = "|"), txt, ignore.case = TRUE)
    ind[filt]
}

.findSignalerInSignaler <- function(rfile, symbols) {
    .findInSignaler(rfile, symbols, .grepTokens,
        keywords = c("message", "warn", "error"))
}

checkPasteInSignaler <- function(.BiocPackage) {
    rfiles <- .BiocPackage$RSources
    pasteSig <- lapply(rfiles, .findPasteInSignaler)
    pasteSig <- unlist(pasteSig)
}

checkSignalerInSignaler <- function(.BiocPackage) {
    rfiles <- .BiocPackage$RSources
    sisig <- lapply(rfiles, .findSignalerInSignaler, symbols = .SIGNALERS_TXT)
    sisig <- unlist(sisig)
}

.checkValidNEEQPattern <- function(tokens, eqnums) {
    tokens[["rowID"]] <- seq_len(nrow(tokens))
    unlist(lapply(eqnums, function(eq) {
        parnum <- tokens[eq, "parent"]
        hits <- which(tokens[, "parent"] %in% parnum)
        if (!length(hits)) { return(NULL) }
        startEQ <- min(hits)
        endEQ <- max(hits)
        EQblock <- tokens[startEQ:endEQ, ]
        hasIS <- EQblock[, "token"] == "SYMBOL_FUNCTION_CALL" &
            EQblock[, "text"] %in% c("is", "class")
        if (
            any(hasIS) &&
            "STR_CONST" %in% EQblock[EQblock[["rowID"]] > eq, "token"]
        )
            eq
        else
            NULL
    }))
}

getClassNEEQLookup <- function(rfile) {
    tokens <- getParseData(parse(rfile, keep.source = TRUE))
    eqtoks <- which(tokens[, "token"] %in% c("NE", "EQ"))
    eqtoks <- .checkValidNEEQPattern(tokens, eqtoks)
    tokens[eqtoks, , drop = FALSE]
}

checkClassNEEQLookup <- function(.BiocPackage) {
    rfiles <- .BiocPackage$RSources
    names(rfiles) <- basename(rfiles)
    NEEQ_pres <- lapply(rfiles, getClassNEEQLookup)
    NEEQ_pres <- Filter(nrow, NEEQ_pres)
    msg_neeq <- lapply(names(NEEQ_pres), function(rfile, framelist) {
        tokens <- framelist[[rfile]]
        sprintf(
            "%s (line %d, column %d)",
            rfile, tokens[, "line1"], tokens[, "col1"]
        )
    }, framelist = NEEQ_pres)
    unlist(msg_neeq)
}

checkExternalData <- function(.BiocPackage) {
    rfiles <- .BiocPackage$RSources
    msg_eda <- lapply(rfiles, function(rfile) {
        tokens <- getParseData(parse(rfile, keep.source=TRUE))
        tokens <- tokens[tokens[,"token"] == "STR_CONST", ,drop=FALSE]

        platforms <- paste0(
            "githubusercontent|github.*[^html\"]$|",
            "gitlab|bitbucket|[^\\.]dropbox"
        )
        txtkns <- tokens[, "text"]
        hits <- grepl(platforms, txtkns, ignore.case = TRUE) &
            grepl("dl|\\.\\w+\"$", txtkns)
        tokens <- tokens[hits, , drop = FALSE]

        sprintf(
            "%s (line %d, column %d)",
            basename(rfile), tokens[,"line1"], tokens[,"col1"]
        )
    })
    unlist(msg_eda)
}

checkOnAttachLoadCalls <- function(.BiocPackage) {
    rfiles <- .BiocPackage$RSources
    parsedCodes <- lapply(
        structure(rfiles, .Names = rfiles), parseFile,
        .BiocPackage = .BiocPackage
    )
    parsedCodes <- lapply(parsedCodes, function(tokens) {
        tokens <- tokens[!tokens[, "token"] %in% c("expr", "COMMENT"), ]
        incl <- .findSymbolRanges(
            tokens, c(".onLoad", ".onAttach"), "SYMBOL", TRUE
        )
        tokens[unlist(incl), ]
    })
    parsedCodes <- Filter(nrow, parsedCodes)
    msg_dl <- findSymbolsInParsedCode(
        parsedCodeList = parsedCodes,
        symbolNames = "download.*",
        tokenTypes = "SYMBOL_FUNCTION_CALL",
        FUN = .grepTokenTextCode
    )
    unlist(msg_dl)
}

checkForDirectSlotAccess <- function(parsedCode, package_name)
{
    idx <- grepl("\\.R$", names(parsedCode), ignore.case=TRUE)
    parsedCode <- parsedCode[!idx]
    res <- findSymbolInParsedCode(parsedCode, package_name, "@", "'@'")
    if (res > 0)
    {
        handleNote(
            "Use accessors; don't access S4 class slots via ",
            "'@' in examples/vignettes.")
    }
}

checkManDocumentation <- function(.BiocPackage, libloc) {
    package_dir <- .BiocPackage$sourceDir
    package_name <- .BiocPackage$packageName
    # canned man prompts
    checkForPromptComments(.BiocPackage)

    # non empty value section exists
    checkForValueSection(.BiocPackage)

    # exports are documented and 80% runnable
    checkExportsAreDocumented(.BiocPackage, lib.loc = libloc)

    # usage of donttest and dontrun
    checkUsageOfDont(.BiocPackage)
}

checkForPromptComments <- function(.BiocPackage) {
    manfiles <- .BiocPackage$manSources
    bad <- vapply(
        manfiles,
        function(manpage) {
            lines <- readLines(manpage, warn = FALSE)
            any(grepl("^%%\\s+~", lines))
        },
        logical(1L)
    )

    if (any(bad))
        handleNote(
            "Auto-generated '%% ~' comments found in Rd man pages.",
            messages = names(bad)[bad]
        )
}

.tagListExtract <- function(rd, tags, Tag) {
    if (missing(tags))
        tags <- .RdTags(rd)
    if (!Tag %in% tags)
        character(0L)
    else
        unlist(rd[tags == Tag], recursive = FALSE)
}

.tagsExtract <- function(rd, tags, Tag) {
    tagList <- .tagListExtract(rd = rd, tags = tags, Tag = Tag)
    as.character(tagList)
}

.valueInParsedRd <- function(rd, tags) {
    tagList <- .tagListExtract(rd, tags, "\\value")
    values <- Filter(function(x) attr(x, "Rd_tag") != "COMMENT", tagList)
    value <- paste(values, collapse = "")
    nzchar(trimws(value)) && length(values)
}

.parse_Rd_pack <- function(manpage, usesRdpack) {
    sysfile_rdpack <- system.file(package = "Rdpack")
    rdpack_avail <- nzchar(sysfile_rdpack)
    if (usesRdpack && rdpack_avail)
        rdmacros <- file.path(
            sysfile_rdpack, "help", "macros", "refmacros.Rd"
        )
    else
        rdmacros <- file.path(R.home("share"), "Rd", "macros", "system.Rd")

    tools::parse_Rd(manpage, macros = rdmacros)
}

.read_all_rds <- function(manpages, usesRdpack) {
    lapply(
        manpages,
        function(manpage, usesRdpack) {
            .parse_Rd_pack(manpage, usesRdpack)
        },
        usesRdpack = usesRdpack
    )
}

.formatsInParsedRd <- function(rd, tags) {
    formats <- .tagsExtract(rd, tags, "\\format")
    value <- paste(formats, collapse = "")
    nzchar(trimws(value)) && length(formats)
}

.skipRdCheck <- function(rd, tags) TRUE

.whichRdCheck <- function(docType) {
    switch(
        docType,
        internal = ,
        package = ,
        class = .skipRdCheck,
        data = .formatsInParsedRd,
        fun = ,
        .valueInParsedRd
    )
}

checkForValueSection <- function(.BiocPackage) {
    all_rds <- .read_all_rds(.BiocPackage$manSources, .BiocPackage$usesRdpack)
    all_tags <- lapply(all_rds, .RdTags)
    docTypes <- mapply(docType, rd = all_rds, tags = all_tags, SIMPLIFY = FALSE)
    hasUsage <- vapply(
        all_tags,
        function(dtag) {
            "\\usage" %in% dtag
        },
        logical(1L)
    )
    isInternal <- mapply(
        function(rd, tags, keyword) {
            if ("\\keyword" %in% tags)
                "internal" %in% unlist(.tagListExtract(rd, tags, "\\keyword"))
            else
                FALSE
        },
        rd = all_rds,
        tags = all_tags,
        SIMPLIFY = TRUE
    ) |>
        as.logical()
    docTypes[isInternal] <- "internal"
    isData <- docTypes == "data"
    docTypes[!lengths(docTypes) | (hasUsage & !isInternal & !isData)] <- "fun"
    funs <- lapply(docTypes, .whichRdCheck)
    ok <- mapply(
        function(afun, rds, atags) {
            afun(rds, atags)
        },
        afun = funs,
        rds = all_rds,
        atags = all_tags,
        SIMPLIFY = TRUE
    )
    dataOK <- ok[isData]
    elseOK <- ok[!isData]
    if (!all(dataOK)) {
        not_oks <- names(dataOK[!dataOK])
        handleWarningFiles(
            "Empty or missing \\format sections found in data man page(s).",
            messages = not_oks
        )
    }
    if (!all(elseOK)) {
        not_oks <- names(elseOK[!elseOK])
        handleWarningFiles(
            "Empty or missing \\value sections found in man page(s).",
            messages = not_oks
        )
    }
}

# Which pages document things that are exported?
checkExportsAreDocumented <- function(.BiocPackage, lib.loc) {
    pkgdir <- .BiocPackage$sourceDir
    pkgname <- .BiocPackage$packageName
    uses_rd_pack <- .BiocPackage$usesRdpack
    manpages <- .BiocPackage$manSources
    pkg_ns <- loadNamespace(pkgname, lib.loc = lib.loc)
    exports <- getNamespaceExports(pkg_ns)
    ## attempt to unload package namespace
    try(unloadNamespace(pkg_ns), silent = TRUE)
    badManPages <- character(0)
    exportingPagesCount <- 0L
    noExamplesCount <- 0L

    for (manpage in manpages) {
        rd <- .parse_Rd_pack(manpage, usesRdpack = uses_rd_pack)
        tags <- .RdTags(rd)
        name <- .tagsExtract(rd, tags = tags, Tag = "\\name")
        aliases <- .tagsExtract(rd, tags = tags, Tag = "\\alias")
        namesAndAliases <- c(name, aliases)
        exportedTopics <- unique(namesAndAliases[namesAndAliases %in% exports])
        if (length(exportedTopics)) {
            exportingPagesCount <- exportingPagesCount + 1
        }
        if (
            length(exportedTopics) &&
                !doesManPageHaveRunnableExample(rd)
        ) {
            noExamplesCount <- noExamplesCount + 1
            badManPages <- append(badManPages, basename(manpage))
        }
    }

    ratio <- (exportingPagesCount - noExamplesCount) / exportingPagesCount

    if (exportingPagesCount > 0 && ratio < 0.8)
        handleError(
            "At least 80% of man pages documenting exported objects must ",
            "have runnable examples.",
            help_text = "The following pages do not:",
            messages = badManPages
        )
    else if (length(badManPages))
        handleNote(
            "Consider adding runnable examples to man pages that document ",
            "exported objects.",
            messages = badManPages
        )

    badManPages # for testing
}

checkUsageOfDont <- function(.BiocPackage) {
    manpages <- .BiocPackage$manSources

    hasBad <- rep(FALSE, length(manpages))
    hasdontrun <- rep(FALSE, length(manpages))
    uses_rd_pack <- .BiocPackage$usesRdpack
    for (dx in seq_along(manpages)) {
        manpage <- manpages[dx]
        rd <- .parse_Rd_pack(manpage, usesRdpack = uses_rd_pack)
        hasExamples <- "\\examples" %in% .RdTags(rd)
        if (hasExamples) {
            rdCode <- as.character(rd)
            exampleCode <- rdCode[which(rdCode == "\\examples"):length(rdCode)]
            donttest <- "\\donttest" %in% exampleCode
            dontrun <- "\\dontrun" %in% exampleCode
            ## check for the 'internal' keyword - this will be a false positive
            keyword <- .RdTags(rd) == "\\keyword"
            internalVec <- FALSE
            if (any(keyword))
                internalVec <- vapply(
                    as.character(rd[keyword]),
                    grepl,
                    logical(1L),
                    pattern = "internal",
                    USE.NAMES = FALSE
                )
            if ((donttest || dontrun) && !any(internalVec))
                hasBad[dx] <- TRUE

            if (dontrun && !any(internalVec))
                hasdontrun[dx] <- TRUE
        }
    }
    if (any(hasBad)) {
        perVl <- as.character(round(
            length(which(hasBad)) / length(hasBad) * 100
        ))
        handleNoteFiles(
            "Usage of dontrun{} / donttest{} tags found in man page examples. ",
            paste0(perVl, "% of man pages use at least one of these tags."),
            messages = basename(manpages)[hasBad]
        )
    }
    if (any(hasdontrun))
        handleNoteFiles(
            "Use donttest{} instead of dontrun{}.",
            messages = basename(manpages)[hasdontrun]
        )
}

# BiocCheck-class ---------------------------------------------------------

#' @name BiocCheck-class
#'
#' @docType class
#'
#' @title An internal class for composing BiocCheck reports
#'
#' @description The `BiocCheck` class provides a framework for reporting checks
#'   based on Bioconductor guidelines. The class has several methods for working
#'   with the provided checks that handle and display messages and the display
#'   of the metadata. These methods also record the output of the `BiocCheck()`
#'   report in both plain text and JSON formats.
#'
#'   **Note** that currently, multiple `BiocCheck` runs will interfere with
#'   each other given that they are implemented via a reference class semantic.
#'   When running multiple checks in the same session, you can separate these
#'   instances by running them in separate processes (e.g., via `BiocParallel`).
#'
#' @details The metadata includes a number of standard fields to allow easier
#'   troubleshooting and display of potentially relevant information. Currently,
#'   the fields included are:
#'
#'   * BiocCheckVersion:  The version of the BiocCheck package
#'   * BiocVersion:  The version of Bioconductor
#'   * Package:  The name of the package in check
#'   * PackageVersion:  The version of the package in check
#'   * sourceDir:  The directory of the package source or tarball in check
#'   * installDir: The directory where the package is installed for
#'     testing, a temporary location by default
#'   * BiocCheckDir: The directory where the `<package>.BiocCheck` folder
#'     is saved. Usually the same folder as the package in check
#'   * platform:  The platform/OS where the check is taking place
#'   * isTarBall: Whether the package in check is a source directory or a
#'     tarball
#'
#' @field log `list()` A running list of all conditions raised (i.e., notes,
#'   warnings, errors)
#'
#' @field check `character(1)` The title of the last check used for logging
#'   purposes.
#'
#' @field error,warning,note `list()` Finer extraction of each condition type
#'
#' @field metadata `list()` A list of additional information relevant to the
#'   package and its state. See details.
#'
#' @param ... `character()` A vector that makes up the `BiocCheck` exception
#'   message (e.g., 'Vignette must be built by R CMD build'). The character
#'   vector is handled with `paste0` and made into a list and appended with
#'   `help_text` and `messages`.
#'
#' @param help_text `character(1)` Additional text prompting a list of files
#'   (e.g,. "Found in files:")
#'
#' @param condition `character(1)` One of the three conditions handled: `error`,
#'   `warning`, or `note`
#'
#' @param messages `character()` Often a vector of file names where the check
#'   was triggered.
#'
#'
#' @param debug `logical(1)` Whether to append the name of the originating check
#'   name into for trace-ability
#'
#' @param checkName `character(1)` The title of the current group of checks. It
#'   can be set with `handleCheck`, e.g.,
#'   `handleCheck("Checking for version number mismatch...")`. Internally, it
#''  is saved with `setCheck` and obtained with `getLastCheck`.
#'
#' @param isOnBBS `logical(1)` Indicates whether the checks are being run on the
#'   Bioconductor Build System (BBS). This is helpful for avoiding the creation
#'   of folders in the BBS.
#'
#' @param file `character(1)` A path to a JSON file for writing or reading as
#'   created by `toJSON` and `fromJSON` `BiocCheck` methods.
#'
#' @importFrom BiocBaseUtils checkInstalled
#' @importFrom utils tail
#'
#' @section methods:
#'   * `add`: Include a condition to the `BiocCheck` report
#'   * `addMetadata`: Add metadata to the `BiocCheck` object from a
#'     `BiocPackage` object
#'   * `getLastCheck`: Obtain the name of the last check run
#'   * `setCheck`: Create a new element in the internal list for a check
#'   * `get`: Extract the list of conditions raised by `BiocCheck`
#'   * `getNum`: Tally the number of condition provided by the input
#'   * `zero`: Reset the internal log of the condition provided
#'   * `getBiocCheckDir`: Report and create the `<package>.BiocCheck`
#'     directory as obtained from the metadata
#'   * `composeReport`: Simplify the list structure from the `log` and
#'     provide a character vector of conditions raised
#'   * `report`: Write the `00BiocCheck.log` report into the `BiocCheck`
#'     folder
#'   * `toJSON`: Write a JSON file to the location indicated with the
#'     conditions raised
#'   * `fromJSON`: Read a JSON file from the location indicated with the
#'     output of previous conditions raised in the check
#'   * `show`: Display the information in the class. Currently empty.
#'   * `show_meta`: Display the metadata information stored in the `metadata`
#'     field
#'
#' @return An internal `BiocCheck` R5 Reference Class used to document
#'   conditions such as errors, warnings, and notes
#'
#' @seealso [Message-class], [BiocPackage-class]
#'
#' @examples
#'
#' bc <- BiocCheck:::.BiocCheck
#'
#' @exportClass BiocCheck
NULL

.BiocCheck <- setRefClass("BiocCheck",
    fields = list(
        log = "list",
        # checkName
        check = "character",
        # conditions
        error = "list",
        warning = "list",
        note = "list",
        metadata = "list"
    ),
    methods = list(
        initialize = function(...) {
            callSuper(...)
        },
        add = function(
            ..., condition, help_text, messages
        ) {
            if (missing(condition))
                stop(
                    "<Internal> 'condition' should be:",
                    " 'error', 'warning', or 'note'"
                )
            checkName <- .self$getLastCheck()
            mlist <- list(...)[[1]]
            stopifnot(
                "<Internal> Input to '$add' must be a list" = is.list(mlist)
            )
            ins <- Filter(length, list(mlist, help_text, messages))
            nist <- structure(list(ins), .Names = names(mlist))
            .messages$setMessage(nist, condition = condition)
            .self[[condition]] <- append(.self[[condition]], nist)
            .self$log[[checkName]] <- append(.self$log[[checkName]], nist)
        },
        addMetadata = function(BiocPackage, ...) {
            args <- list(...)
            .self$metadata <- list(
                sourceDir = BiocPackage$sourceDir,
                BiocVersion = as.character(BiocManager::version()),
                Package = BiocPackage$packageName,
                PackageVersion = BiocPackage$packageVersion,
                BiocCheckDir = BiocPackage$BiocCheckDir,
                BiocCheckVersion = as.character(packageVersion("BiocCheck")),
                sourceDir = BiocPackage$sourceDir,
                installDir = args[["installDir"]],
                isTarBall = BiocPackage$isTar,
                platform = .Platform$OS.type
            )
        },
        getLastCheck = function() {
            checkName <- .self$check
            if (!length(checkName))
                "undefined"
            else
                checkName
        },
        setCheck = function(checkName) {
            .self$check <- checkName
            ## create a list for appending
            .self$log[[checkName]] <- list()
        },
        get = function(condition) {
            cond <- .self[[condition]]
            if (length(cond)) {
                length_elements <- vapply(
                    cond,
                    function(x) length(unlist(x, use.names = FALSE)),
                    integer(1L)
                )
                split(
                    unlist(cond, use.names = FALSE),
                    rep(names(cond), length_elements)
                )
            } else {
                cond
            }
        },
        getNum = function(conditions = c("error", "warning", "note")) {
            vapply(
                conditions,
                function(condition) {
                    length(.self[[condition]])
                },
                integer(1L)
            )
        },
        zero = function(conditions = c("error", "warning", "note")) {
            for (condition in conditions) {
                .self[[condition]] <- list()
            }
        },
        getBiocCheckDir = function() {
            bioccheck_dir <- .self$metadata$BiocCheckDir
            if (!dir.exists(bioccheck_dir))
                dir.create(bioccheck_dir, recursive = TRUE)
            bioccheck_dir
        },
        composeReport = function(debug = FALSE) {
            unlist(Map(
                    f = function(...) {
                        .composeReport(..., debug = debug)
                    },
                    checkName = names(.self$log),
                    lowerElements = lapply(.self$log, .flattenElement)
            ), use.names = FALSE)
        },
        report = function(debug, isOnBBS) {
            if (isOnBBS)
                return()
            bioccheck_dir <- .self$getBiocCheckDir()
            outputs <- .self$composeReport(debug = debug)
            writeLines(
                outputs, con = file.path(bioccheck_dir, "00BiocCheck.log")
            )
        },
        toJSON = function(file) {
            out <- Filter(length, .self$log)
            checkInstalled("jsonlite")
            jlog <- jsonlite::toJSON(out, auto_unbox = FALSE)
            jsonlite::write_json(jlog, file)
        },
        fromJSON = function(file) {
            checkInstalled("jsonlite")
            infile <- jsonlite::read_json(file)[[1]]
            .self[["log"]] <- jsonlite::fromJSON(infile, simplifyVector = FALSE)
        },
        show = function() {
            invisible()
        },
        show_meta = function() {
            meta <- .self$metadata
            if (!length(meta))
                stop("<Internal> No metadata to show.")
            lapply(
                paste(names(meta), meta, sep = ": "),
                cli::cli_alert
            )
        }
    )
)

.flattenElement <- function(listElem) {
    debugFun <- names(listElem)
    lowerElem <- unlist(listElem, use.names = FALSE)
    attributes(lowerElem) <- list(debugNames = debugFun)
    lowerElem
}

.composeReport <- function(checkName, lowerElements, debug = FALSE) {
    if (!length(lowerElements))
        checkName <- paste(checkName, "OK")
    else if (debug)
        lowerElements <-
            c(lowerElements, paste("DEBUG:", attr(lowerElements, "debugNames")))
    c(checkName, lowerElements)
}

## singletons. Exported but 'hidden' from ls() by the '.'

#' @export
.BiocCheck <- .BiocCheck()

UNIT_TEST_PKG <- "unitTestTempDir"
UNIT_TEST_TEMPDIR <- file.path(tempdir(), UNIT_TEST_PKG)

create_test_package <-
    function(
        test_dir = tempfile(),
        description = list(),
        pkgpath = tempfile(tmpdir = test_dir),
        extraActions = function(path = NULL) {},
        use.canned = TRUE
    )
{
    canned <- list()
    if (use.canned) {
        canned <- list(
            Author = "Test Author",
            Maintainer = "Test Maintainer <test@test.com>",
            "Authors@R" = NULL
        )
    }
    for (name in names(description))
        canned[[name]] <- description[[name]]

    if (!dir.exists(pkgpath))
        dir.create(pkgpath, recursive = TRUE)
    capture.output({
        suppressWarnings(
            suppressMessages(
                usethis::create_package(
                    path = pkgpath,
                    fields = canned,
                    rstudio = FALSE,
                    open = FALSE
                )
            )
        )
    })
    cat("#", file = file.path(pkgpath, "NAMESPACE"))
    extraActions(pkgpath)
    .BiocPackage$initialize(pkgpath)
}

checkCounter <- function(msg, type = "error") {
    if (missing(msg))
        stop("<internal> Provide message input")
    conds <- c("note", "warning", "error")
    res <- as.integer(conds %in% type)
    names(res) <- conds
    expect_identical(
        .BiocCheck$getNum(c("note", "warning", "error")), res,
        msg
    )
    .BiocCheck$zero()
}

read_test_package <- function(pkgname) {
    pkgdir <- system.file(
        "testpackages", pkgname, package="BiocCheck", mustWork = TRUE
    )
    .BiocPackage$initialize(pkgdir)
}

stillZero <- function()
{
    identical(
        .BiocCheck$getNum(c("note", "warning", "error")),
        c(note = 0L, warning = 0L, error = 0L)
    )
}

a <<- 1
# this is a really long line with many characters in it. too many characters! So many that a NOTE is triggered.
#ooh, this has a tab here:  that is so terrible!

# the following line is terrible because it is indented by
     # something other than a multiple of 5 spaces!
is(a) == "numeric"
# good code (sort of)
is(a, "numeric")

is(a) != "character"
class(a) == "character"
class(a) != "character"

%\VignetteIndexEntry{Vignette Title}

```{r echo=FALSE}
session_info()
install_bioc <- function() {
    message("Installing...")
}
```

```{r eval=FALSE}
if (!requireNamespace("BiocCheck", quietly = TRUE))
    BiocManager::install("BiocCheck")
```

```{r eval=TRUE}
## This should trigger checkVigInstalls (2x)
if (!requireNamespace("BiocCheck", quietly = TRUE))
    BiocManager::install("BiocCheck")
## trigger with grep
install_bioc("BiocCheck")
```

```{r}
## This should trigger checkVigBiocInst
if (!requireNamespace("BiocCheck", quietly = TRUE))
    BiocInstaller::biocLite("BiocCheck")
```

```{r eval=FALSE}
## This should not trigger checkVigInstalls
if (!requireNamespace("BiocCheck", quietly = TRUE))
    BiocInstaller::biocLite("BiocCheck")
check_install("BiocCheck")
```

```{r eval=FALSE}
```

```{r eval=FALSE}
```

```{r eval=FALSE}
```

```{r, eval=TRUE}
if (T) {
    cat("bad practice")
}
```

```{r eval=FALSE}
```

```{r eval=FALSE}
```

```{r, child = "testpkg0_child.Rmd"}
```

%\VignetteIndexEntry{A new Title}
%\VignetteEngine{ThisWillFail}
%\VignetteEngine{MultipleVigEngineLines}

```{r}
knitr::opts_chunk$set(
    cache = TRUE,
    eval = FALSE
)
```

```{r echo=FALSE}
vl <- T
```

```R
```

```{r,eval=FALSE}
# this is a test
```

```{r,eval=FALSE}
# to increase proportion of eval = FALSE
```

---
title: "Test Duplicate Chunks Vignette"
author: "BiocCheck Maintainer"
date: "`r format(Sys.time(), '%B %d, %Y')`"
output:
  BiocStyle::html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

```{r,dupname}
if (!requireNamespace("BiocCheck", quietly = TRUE))
    BiocManager::install("BiocCheck")
```

```{r,dupname}
## This should trigger checkVigInstalls (2x)
if (!requireNamespace("BiocCheck", quietly = TRUE))
    BiocManager::install("BiocCheck")
## trigger with grep
install_bioc("BiocCheck")
```

```{r,eval=FALSE}
## adding more eval=FALSE chunks
```

```{r,eval=FALSE}
print("hello world")
```

```{r, eval=FALSE}
## This should trigger checkVigChunkEval
```

---
title: "testpkg0"
vignette: >
  %\VignetteIndexEntry{Test Qmd Format}
  %\VignetteEngine{quarto}
  %\VignetteEncoding{UTF-8}
---

```{r}
#| label: calculate

1 + 1
```

```{r}
#| echo: true

2 * 2
```



```{r}
#| echo: false
#| label: mtcars-scatterplot
#| fig.cap: "A scatterplot of mtcars"

data("mtcars", package = "datasets")

plot(
    x = mtcars$wt, y = mtcars$mpg,
    xlab = "Weight", ylab = "Milage",
    xlim = c(1,6), ylim = c(10,35),
    main = "Weight vs Milage"
)
```

---
title: "BiocCheck: Ensuring Bioconductor package guidelines"
output:
  BiocStyle::html_document:
    toc: true
vignette: >
  % \VignetteIndexEntry{BiocCheck: Ensuring Bioconductor package guidelines}
  % \VignetteEngine{knitr::rmarkdown}
  % \VignetteEncoding{UTF-8}
---

```{r biocstyle_load, include=FALSE,results="hide",message=FALSE,warning=FALSE}
library(BiocStyle)
```

# `BiocCheck` Summary

```{r libs, include=TRUE,results="hide",message=FALSE,warning=FALSE}
library(BiocCheck)
```

`BiocCheck` encapsulates _Bioconductor_ package guidelines and best
practices, analyzing packages and reporting three categories of
issues:

* **ERROR**. This means the package is missing something critical and
  it cannot be accepted into _Bioconductor_ until the issue is
  fixed. (`BiocCheck` will continue past an `ERROR`, thus it is
  possible to have more than one, but it will exit with an error code
  if run from the OS command line.)
* **WARNING**. These issues almost always need to be addressed before
  the package is added to _Bioconductor_. In the weeks leading up to a
  _Bioconductor_ release we will ask package authors to fix these
  issues.
* **NOTE**: Not necessarily something bad, just something we wanted to
  point out. package authors don't need to take action on these, but
  they can.

# Using `BiocCheck`

`BiocCheck` is meant to run within R on a directory containing an R package, or
a source tarball (`.tar.gz` file):

```{r usage, eval=FALSE}
BiocCheck("<packageDirOrTarball>")
```

`BiocCheck` takes options which can be seen with `?BioCheck`.

Note that the `--new-package` option is turned on in the Single Package
Builder (SPB) during the new package submission process.

# When should `BiocCheck` be run

`BiocCheck` should always be run after `R CMD check`.

Note that `BiocCheck` is not a replacement for `R CMD check`; it is
complementary. It should be run after `R CMD check` completes
successfully.

`BiocCheck` can also be run via
[GitHub Actions](https://docs.github.com/en/actions),
a continuous integration system on GitHub. This service allows automatic
testing of R packages in a controlled build environment.

See the `r Biocpkg("biocthis")` package for more details.

# Installing `BiocCheck`

`BiocCheck` should be installed as follows:

```{r install, eval = FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("BiocCheck")
```

# Interpreting `BiocCheck` output

Actual `BiocCheck` output is shown below in **bold**.

## Installation

To skip the installation step, set the `--install` flag to `NULL` or `FALSE`.
`BiocCheck` loads the installed package to run some of its checks. When this
flag is set to `NULL` or `FALSE`, it will search for the package in the first
path in the local library (i.e., `.libPaths()[1]`).

Similar to `R CMD check`, the `--install` flag can optionally include a
`check:<file>` key-value pair indicating the file where the installation log can
be found (primarily for compiled packages) and it will be copied into the
`<pkg>.BiocCheck` output folder.

Note that `libloc` can be included along with the `--install` flag to specify
a custom library location for package installation. By default, when not set,
`libloc` points to the `lib` folder in the package installation directory.

## Deprecated Package Checks

**Checking for deprecated package usage...**

Can be disabled with `--no-check-deprecated`.

At present, this looks to see whether your package has a dependency on
the `multicore` package (`ERROR`).

Our recommendation is to use `r Biocpkg('BiocParallel')`. Note that 'fork'
clusters do not provide any gain from parallelizing code on
Windows. Socket clusters work on all operating systems.

Also checks `Deprecated` Packages currently specified in release and devel
versions of Bioconductor (`ERROR`).

## Remotes Usage Check

**Checking for remote package usage...**

Can be disabled with `--no-check-remotes`

Bioconductor only allows dependencies that are hosted on CRAN or
Bioconductor. The use of `Remotes:` in the DESCRIPTION to specify a unique
remote location is not allowed.

## LazyData Usage Check

**Checking for 'LazyData: true' usage...**

For packages that include data, we recommend not including `LazyData: TRUE`.
This rarely proves to be a good thing. In our experience it only slows down
the loading of packages with large data (`NOTE`).

## Version Checks

Can be disabled with `--no-check-version-num` and `--no-check-R-ver`.

**Checking version number...**

* **Checking for version number mismatch...**
  Checks that the package version specified in your package tarball
  (if you are checking a tarball) matches the value of the `Version:`
  field in your `DESCRIPTION` file.  If it doesn't, it usually means
  you did not build the tarball with `R CMD build`. (`ERROR`)
* **Checking new package version number...**
  Checks that the pre-release version for an potential _Bioconductor_
  package uses a `99` 'y' version in the `x.y.z` versioning scheme
  (`ERROR`). Package versions starting with a non-zero value will
  get flagged with a warning. Typical new package submissions
  start with a zero 'x' version (e.g., `0.99.*`; `WARNING`). This
  is only done if the `--new-package` option is supplied. An 'x' nonzero will
  only be accepted if the package was pre-released or published under such a
  case.
* **Checking version number validity...**
  Checks for a valid version, that format is correct and that version
  number is appropriate for this version of _Bioconductor_ (`ERROR`).
* **Checking R Version dependency...**
  If you specify an R version in the `Depends:` field of your
  `DESCRIPTION` file, `BiocCheck` checks to make sure that the R
  version specified matches the version currently used in
  _Bioconductor_. This helps to prevent mixing of Bioconductor release and
  devel versions (esp. when R versions differ) which is a frequent source of
  confusion and errors (`NOTE`).

For more information on package versions, see the
[Version Numbering HOWTO][1].

[1]: https://contributions.bioconductor.org/versionnum.html

## Package and File Size Check

Can be disabled with `--no-check-pkg-size` and `--no-check-file-size`.

* **Checking package size**
  Checks that the package size meets _Bioconductor_ requirements. The current
  package size limit is 10 MB for Software packages. Experiment Data and
  Annotation packages are excluded from this check. This check is only run if
  checking a source tarball. (ERROR)

* **Checking individual file sizes**
  The current size limit for all individual files is 5 MB. Checks inspect both
  package-wide files and data files found in the `data`, `inst/extdata`, and
  `data-raw` folders. (WARNING)

It may be necessary to remove large files from your Git history; see
[Remove Large Data Files and Clean Git Tree][2]

[2]: https://contributions.bioconductor.org/git-version-control.html#remove-large-data-files-and-clean-git-tree

## biocViews Checks

These can be disabled with the `--no-check-bioc-views` option, which
might be useful when checking non-_Bioconductor_ packages (since
biocViews is a concept unique to _Bioconductor_).

**Checking biocViews...**

Can be disabled with `--no-check-bioc-views`

* **Checking that biocViews are present...**
  Checks that a `biocViews` field is present in the DESCRIPTION file
  (`ERROR`).
* **Checking package type based on biocViews**
  Gives an indication if the package is identified as a Software, Annotation,
  Experiment, or Workflow package.
* **Checking for non-trivial biocViews...**
  Checks that biocViews are more specific than the top-level terms
  Software, AnnotationData, or ExperimentData (`ERROR`).
* **Checking biocViews validity...**
  Checks for valid views and displays invalid ones. Note that
  biocViews are case-sensitive (`WARNING`).
* **Checking that biocViews come from the same category...**
  Checks that all views come from the same parent (one of Software,
  AnnotationData, ExperimentData) (`WARNING`).
* **Checking for recommended biocViews...**
  Uses the `recommendBiocViews()` function from `biocViews` to
  automatically suggest some biocViews for your package.

More information about biocViews is available in the
[Using biocViews HOWTO][3].

[3]: https://contributions.bioconductor.org/important-bioconductor-package-development-features.html#biocviews

## Build System Compatibility Checks

The _Bioconductor_ Build System (BBS) is our nightly build system and
it has certain requirements. Packages which don't meet these
requirements can be silently skipped by BBS, so it's important to make
sure that every package meets the requirements.

Can be disabled with `--no-check-bbs`

**Checking build system compatibility...**

* **Checking for blank lines in DESCRIPTION...**
  Checks to make sure there are no blank lines in the DESCRIPTION
  file (`ERROR`).
* **Checking if DESCRIPTION is well formatted...**
   Checks if the DESCRIPTION can be parsed with read.dcf (`ERROR`)
* **Checking Description: field length...**
  Checks that the Description field in the DESCRIPTION file has a minimum
  * number of characters (`WARNING` if less than 50)
  * number of words (`WARNING` if less than 20)
  * number of sentences (`NOTE` if less than 3)
* **Checking for whitespace in DESCRIPTION field names...**
  Checks to make sure there is no whitespace in DESCRIPTION file field
  names (`ERROR`).
* **Checking that Package field matches dir/tarball name...**
  Checks to make sure that `Package` field of DESCRIPTION file matches
  directory or tarball name (`ERROR`).
* **Checking for Version field...**
  Checks to make sure a `Version` field is present in the DESCRIPTION
  file (`ERROR`).
* **Checking for valid maintainer...**
  Checks to make sure the DESCRIPTION file has a valid `Authors@R` field which
  resolves to a valid `Maintainer` (`ERROR`).

  A valid `Authors@R` field consists of:
    * A valid R object of class `person`.
    * Only one person with the `cre` (creator) role.
    * That person must have a syntactically valid email address.
    * That person must have either `family` or `given` name defined.
    * (optional) A syntactically valid [ORCID iD][], results in `NOTE` if not.

  Suggests that the maintainer provide an [ORCID iD][] in the `Authors@R`
  field as an argument in the person function, e.g., `comment = c(ORCID = ...)`
  (`NOTE`).

[ORCID iD]: https://orcid.org/

## DESCRIPTION checks

* **Checking License: for restrictive use...**
  Checks to make sure that the `License:` in the `DESCRIPTION` file does not
  restrict use, e.g., to academic-use only (`ERROR`). Licenses are compared to
  R's internal database provided at `r BiocCheck:::.LICENSE_DB_LOCATION` and
  read with `read.dcf`. Licenses not listed in the database or with spelling
  deviations e.g., `GPL-3.0` vs `GPL-3` are flagged with a `NOTE`. A `NOTE` is
  also generated if the license is not a valid SPDX license identifier (with the
  exception of those already in the database file) or if the license cannot be
  verified in the database. A `NOTE` is also generated if the `License:` field
  is malformed, or the database cannot be located. We also recommend developers
  to browse to the [choosealicense][] to find a suitable license for their
  package as well as the [SPDX License List][] website.
* **Checking for pinned package versions...**
  Ensures that maintainers are not indicating a specific dependency version
  using `==` in the `DESCRIPTION` file (`ERROR`).
* **Checking for recommended fields in DESCRIPTION...** Looks through the
  `DESCRIPTION` file to see whether recommended fields i.e., 'URL', 'Date' and
  'BugReports' are populated (`NOTE`). `Date` field is checked for the format
  `YYYY-MM-DD`.
* **Checking for Bioconductor software dependencies...** Checks to see if
  the package depends on any Bioconductor software packages in the `Depends:`
  and `Imports:` fields; if none (`WARNING`).
* **Checking for 'fnd' role in Authors@R...** Checks to see if the `Authors@R`
  field has a person or organization with the `fnd` (funder) role (`NOTE`).

[choosealicense]: https://choosealicense.com/appendix
[SPDX License List]: https://spdx.org/licenses/

## NAMESPACE checks

Can be disabled with `--no-check-namespace`.

* **Checking NAMESPACE...** ensures that the NAMESPACE file does not contain a
  match all export pattern, i.e., `exportPattern("^[[:alpha:]]+")` or similar
  (`ERROR`).

## .Rbuildignore checks

* **Checking .Rbuildignore...** ensures that the 'tests' folder is
  not accidentally added to the `.Rbuildignore` file (`ERROR`).

## BiocCheck output folder check

* **Checking for stray BiocCheck output folders...** ensures that the
  `<package_name>.BiocCheck` folder byproduct when running `BiocCheck(".")`
  locally does not get included in the package directory (`ERROR`).

## Check for inst/doc folder

* **Checking for inst/doc folders...** ensures that there are no pre-built
  vignettes and their products in the _source_ package directory. Vignettes are
  built when running `R CMD build`; therefore, `inst/doc` folder is not needed
  (`ERROR`).

## Vignette Checks

Can be disabled with `--no-check-vignettes`.

**Checking vignette directory...**

* Checks that the `vignettes` directory exists (`ERROR`).
* Checks that the `vignettes` directory only contains vignette sources
  *(*.Rmd, *.qmd, *.Rnw, *.Rrst, .Rhtml, *.Rtex) (`ERROR`).
* Checks for `.Rnw` vignettes, if any found, suggest RMarkdown (`.Rmd`)
  vignettes instead (`WARNING`)
* Checks for `.qmd` vignettes, if any found, a 'SystemRequirements' field
  must be present in the `DESCRIPTION` file (`WARNING`). The field should
  list `quarto` as a system requirement.
* Checks whether, while checking a directory (not a tarball), vignette
  sources exist in inst/doc (`ERROR`).
* Checks that vignetteBuidler/vignetteEngine are listed in, minimally, Suggests
  field of DESCRIPTION file (`WARNING`)
* Checks that vignetteBuilder in DESCRIPTION and VignetteEngine in vignette
  are compatible (`ERROR`)
* Checks whether vignette title is still using template value (`WARNING`)
* Checks whether the number of `eval=FALSE` chunks is more than 50% of
  the total (`WARNING`).
* Checks whether the global vignette code option is set to `eval=FALSE`.
  The majority of vignette code is expected to be evaluated (`WARNING`)
* Checks for any legacy `BiocInstaller` code (`WARNING`)
* Checks that vignette code contains `sessionInfo()` or `session_info()` for
  reproducibility (`NOTE`).
* Checks that evaluated vignette code does not invoke package installation
  functions (`ERROR`). Function calls in the vignette that match `install.*`
  will produce a warning (`WARNING`).
* Checks that there are no duplicate code chunk labels in the vignettes
  (`ERROR`).
* Checks that all chunks have labels in vignettes (`NOTE`).

**Checking whether vignette is built with 'R CMD build'...**

Only run when `--build-output-file` is specified.

Analyzes the output of `R CMD build` to see if vignettes are built.
It simply looks for a line that starts:

    * creating vignettes ...

If this line is not present, it means `R` has not detected that a
vignette needs to be built (`ERROR`).

If you have vignette sources yet still get this message, there could
be several causes:

* Missing or invalid `VignetteBuilder` line in the `DESCRIPTION` file.
* Missing or invalid `VignetteEngine` line in the vignette source.

See `knitr`'s [package vignette][4] page, or the
[Non-Sweave vignettes][5] section of "Writing R Extensions" for more
information.

[4]: http://yihui.name/knitr/demo/vignette/
[5]: https://cran.r-project.org/doc/manuals/r-release/R-exts.html#Non_002dSweave-vignettes


## Checking Install or Update Package Calls in R code

Can be disabled with `--no-check-library-calls` and `--no-check-install-self`.

* **Checking library calls...** (`NOTE`)
  Check for use of functions that install or update packages. This list
  currently includes the use of `install`, `install.packages`,
  `install_packages` `update.packages` or `biocLite`.
* **Checking for library/require of *(your package name)*...** (`ERROR`)
  It is not necessary to call `library()` or `require()` on your own
  package within code in the R directory or in man page examples. In
  these contexts, your package is already loaded.

## Coding Practices Checks

Can be disabled with `--no-check-coding-practices`.

**Checking coding practices...**

Checks to see whether certain programming practices are found in the R
directory.

* We recommend that `vapply()` be used instead of `sapply()`. Problems
  arise when the `X` argument to `sapply()` has length 0; the return
  type is then a `list()` rather than a vector or array. (`NOTE`)

* We recommend that `seq_len()` or `seq_along()` be used instead of
  `1:...`. This is because the case `1:0` creates the sequence `c(1, 0)`
  which may be an unexpected or unwanted result (`NOTE`).

* Single colon typos are checked for when a user inputs 'package:function'
  instead of using double colons ('::') to import a function (`ERROR`).

* Users should not download data from external hosting platforms. This
  means avoiding references to major platforms such as GitHub, GitLab,
  and BitBucket. For the same reason we do not import GitHub packages,
  external data can be unstable and not well maintained. Maintainers
  should re-use data already available in Bioconductor or contribute
  an `ExperimentHub`, `AnnotationHub` or similar package (`ERROR`).

* A package should not download files at the time of loading or attaching
  i.e., using `library`. Using `download.file` and `download` should be avoided
  and when found, an `ERROR` will be emitted.

* `paste` and `paste0` function calls within signaling functions such as
  `message`, `warning`, and `stop` are redundant and should be avoided
  (`NOTE`). `paste` calls with the `collapse` argument are ignored.

* When notifying users, `message` should be used. When `cat` and `print` are
  used, users will get a note saying that these should only be used in show
  methods for classes (`NOTE`).

* `message`, `warn*`, and `error` keywords should not be included in
  signal condition functions: `message`, `warning`, and `stop`. This is
  redundant and should be avoided (`NOTE`).

* It is favorable to use the assignment arrow ('<-') over the equals assignment
  ('=') for clarity in the code and legibility. Any use of the `=` will be
  flagged with a `NOTE`.

* New submissions should not use any `.Deprecated`, `.Defunct`, `lifeCycle`,
  `deprecate_warn`, or `deprecate_stop` function calls (`WARNING`). Existing
  packages should evolve these functions after a Bioconductor release according
  to the [package guidelines][6].

[6]: https://contributions.bioconductor.org/deprecation.html

* **Checking for T...** **Checking for F...**
  It is bad practice to use `T` and `F` for `TRUE` and `FALSE`.  This
  is because `T` and `F` are ordinary variables whose value can be
  altered, leading to unexpected results, whereas the value of `TRUE`
  and `FALSE` cannot be changed  (`WARNING`).

* Avoid class membership checks with `class()` / `is()` and `==` / `!=`.
  Developers should use `is(x, 'class')` for S4 classes. (`WARNING`)

* Use `system2()` over `system()`. 'system2' is a more portable and
  flexible interface than 'system'.(`NOTE`)

* Use of `set.seed()` in R code.  The `set.seed` should not be set in
  R functions directly. The user should always have the option for
  the set.seed and know when it is being invoked. (`WARNING`)

**Checking parsed R code in R directory, examples, vignettes...**

`BiocCheck` parses the code in your package's R directory, and in
evaluated man page and vignette examples to look for various symbols,
which result in issues of varying severity.

* **Checking for direct slot access...**
  `BiocCheck` checks for direct slot access (via `@` or `slot()`) to
  S4 objects in vignette and example code. This code should **always**
  use accessors to interact with S4 classes. Since you may be using S4
  classes (which don't provide accessors) from another package, the
  severity is only `NOTE`. But if the S4 object is defined in your
  package, it's **mandatory** to write accessors for it and to use
  them (instead of direct slot access) in all vignette and example
  code (`NOTE`).
* **Checking for browser()...**
  `browser()` causes the command-line R debugger to be invoked, and
  should not be used in production code (though it's OK to wrap such
  calls in a conditional that evaluates to TRUE if some debugging
  option is set)  (`WARNING`).
* **Checking for <<-...**
  Non-local assignment using `<<-` is bad practice. It can over-write
  user-defined symbols, and introduces non-linear paths of evaluation
  that are difficult to debug (`NOTE`).
* **Checking for Sys.setenv calls...**
  Packages should not modify system environment variables with the
  `Sys.setenv()` function unless, in rare instances, the package has
  to configure the environment for subsequent `system2()` calls
  (`WARNING`).
* **Checking for suppressWarnings/Messages...**
  The excessive use of `suppressWarnings` and `suppressMessages` is
  problematic as it usually indicates a larger underlying issue with
  the fragility of the package codebase (`NOTE`).

## Function length checking

Can be disabled with `--no-check-function-len`.

**Checking function lengths...**

`BiocCheck` prints an informative message about the length (in lines)
of your five longest functions (this includes functions in your R
directory and in evaluated man page and vignette examples).

If there are functions longer than 50 lines, `BiocCheck` outputs (`NOTE`).
You may want to consider breaking up long functions into smaller ones. This is
a basic refactoring technique that results in code that's easier to
read, debug, test, reuse, and maintain.

## man page checking

Can be disabled with `--no-check-man-doc`.

**Checking man page documentation...**

* Checking for canned comments in man pages

It can be handy to generate man page skeletons with `prompt()` and/or
RStudio. These skeletons contain comments that look like this:

    %%  ~~ A concise (1-5 lines) description of the dataset. ~~

`BiocCheck` asks you to remove such comments (`NOTE`).

* Every man page must have a non-empty `\value` section (`WARNING`). `Rd`
  pages without `\usage` sections or documenting data sets are excluded.

* man page examples examples

**Checking exported objects have runnable examples...**

`BiocCheck` looks at all man pages which document exported objects and
lists the ones that don't contain runnable examples (either because
there is no `examples` section or because its examples are tagged with
`dontrun` or `donttest`). Runnable examples are a key part of literate
programming and help ensure that your code does what you say it does.

* Checks that at least 80% of man pages must have runnable examples (`ERROR`).
* Checks that, if more than 80% of the man pages have runnable
  examples, but some are still missing, `BiocCheck` lists the missing
  ones and asks you to add runnable examples to them (`NOTE`).
* Check the usage of `dontrun` or `donttest`. Use of these functions is not
  recommended and shoud be justified (`NOTE`). If exception is made the
  recommended usage is to use donttest over dontrun (`NOTE`) as donttest
  requires valid R code.

## NEWS checks

Can be disabled with `--no-check-news`.

**Checking package NEWS...**

`BiocCheck` looks to see if there is a valid NEWS file either in the 'inst'
directory or in the top-level directory of your package, and checks whether it
is properly formatted (`NOTE`).

The location and format of the NEWS file must be consistent with
`?news`. Meaning the file can be one of the following four options:

* `inst/NEWS.Rd`
* `./NEWS.md`
* `./NEWS`
* `inst/NEWS`


NEWS files are a good way to keep users up-to-date on changes to your
package. Excerpts from properly formatted NEWS files will be included
in _Bioconductor_ release announcements to tell users what has changed
in your package in the last release. In order for this to happen, your
NEWS file must be formatted in a specific way; you may want to
consider using an `inst/NEWS.Rd` file instead as the format is more
well-defined. Malformatted NEWS file outputs `WARNING`.

More information on NEWS files is available in the help topic `?news`.


## Unit Test Checks

Can be disabled with `--no-check-unit-tests`.

**Checking unit tests...**

We strongly recommend unit tests, though we do not at present require
them. For more on what unit tests are, why they are helpful, and how
to implement them, read our [Unit Testing HOWTO][7].

[7]: https://contributions.bioconductor.org/tests.html

At present we just check to see whether unit tests are present, and if not,
urge you to add them (`NOTE`).

**Checking skip_on_bioc() in tests...**

Can be disabled with `--no-check-skip-bioc-tests`.

Finds flag for skipping tests in the bioconductor environment (`NOTE`)

## Formatting checks

Can be disabled with `--no-check-formatting`.

**Checking formatting of DESCRIPTION, NAMESPACE, man pages, R source,
  and vignette source...**

There is no 100% correct way to format code. These checks adhere to the
[_Bioconductor_ Style Guide][8] (`NOTE`).

[8]: https://contributions.bioconductor.org/r-code.html

We think it's important to avoid very long lines in code.  Note that
some text editors do not wrap text automatically, requiring horizontal
scrolling in order to read it. Also note that R syntax is very
flexible and whitespace can be inserted almost anywhere in an
expression, making it easy to break up long lines.

These checks are run against not just R code, but the DESCRIPTION and
NAMESPACE files as well as man pages and vignette source files.  All
of these files allow long lines to be broken up.

The output of this check includes the first few lines of offending code for
many of the various checks.  To see the full output, users are encouraged to
run the check locally and browse to the `BiocCheck` output folder that was
created with the `<PackageName>.BiocCheck` naming convention. The full output
log file is named `00BiocCheck.log`.

There are several helpful packages that can be used for formatting of
R code to particular coding standards such as  [formatR][formatR] and
[styler][styler] as well as the "Reformat code" button in
[RStudio Desktop][RStudio]. Each solution has its advantages, though
[styler][styler] works with `roxygen2` examples and is actively
maintained. You can re-format your code using [styler][styler] as shown
below:

```{r reformat_code, eval = FALSE}
## Install styler if necessary
if (!requireNamespace("styler", quietly = TRUE)) {
    install.packages("styler")
}
## Automatically re-format the R code in your package
styler::style_pkg(transformers = styler::tidyverse_style(indent_by = 4))
```

If you are
working with [RStudio Desktop][RStudio] use also the "Reformat code"
button which will help you break long lines of code. Alternatively,
use [formatR][formatR], though beware that it can break valid R code
involving both types of quotation marks (`"` and `'`) and does not
support re-formatting `roxygen2` examples. In general,
it is best to version control your code before applying any
automatic re-formatting solutions and implement unit tests to
verify that your code runs as intended after you re-format your code.

[formatR]: https://cran.r-project.org/package=formatR
[styler]: https://cran.r-project.org/package=styler
[RStudio]: https://rstudio.com/products/rstudio/download/

## Duplication checks

* **Checking if package already exists in CRAN...**
  This can be disabled with the `--no-check-CRAN` option. A package with the
  same name (case differences are ignored) cannot exist on CRAN. Packages
  submitted to Bioconductor must be removed from CRAN before the next
  Bioconductor release (`WARNING`).

* **Checking if new package already exists in _Bioconductor_...**
  Only run if the `--new-package` flag is turned on.  A package
  with the same name (case differences are ignored) cannot  exist in
  _Bioconductor_ (`ERROR`).

## bioc-devel Subscription Check

**Checking for bioc-devel mailing list subscription...**

This only applies if `BiocCheck` is run on the _Bioconductor_ build
machines, because this step requires special authorization. This can be disabled
with the `--no-check-bioc-help` option.

* Check that the email address in the Maintainer (or Authors@R) field
  is subscribed to the bioc-devel mailing list (`ERROR`).

  All maintainers must subscribe to the bioc-devel mailing list, with
  the email address used in the DESCRIPTION file.  You can subscribe
  [here][9].

[9]: https://stat.ethz.ch/mailman/listinfo/bioc-devel

## Support Site Registration Check

**Checking for support site registration...**

* Check that the package maintainer is register at our
  [support site][10] using the same email address that is in the
  `Maintainer` field of their package `DESCRIPTION` file (`ERROR`).
  This can be disabled with the `--no-check-bioc-help` option.

  The main place people ask questions about _Bioconductor_ packages is
  the support site.  Please [register][11] and then include
  your package name in the list of watched tags.
  When a question is asked and tagged with your package name, you'll
  get an email.

* Package name is in support site watched tags is now a requirement.

[10]: https://support.bioconductor.org
[11]: https://support.bioconductor.org/accounts/signup/

# `BiocCheckGitClone`

`BiocCheckGitClone` provides a few additional _Bioconductor_ package checks that
can only should be run on a open source directory (raw Git clone) NOT a
tarball. Reporting similarly in three categories as discussed above:

* **ERROR**.

* **WARNING**.

* **NOTE**.

::: { .anote }
Developers should check packages with `BiocCheck()` within an R session
while `BiocCheckGitClone()` is meant to run on the source package folder i.e.,
the cloned git repository.
:::

# Using `BiocCheckGitClone`

`BiocCheckGitClone` is meant to run within R on a directory containing an R
package:

```{r BiocCheckGitClone_usage, eval=FALSE}
BiocCheckGitClone("packageDir")
```

# Installing `BiocCheckGitClone`

Please see previous Installing `BiocCheck` section.

# Interpreting `BiocCheckGitClone` output

Actual `BiocCheckGitClone` output is shown below in **bold**.

## Bad File Check

**Checking valid files**

There are a number of files that should not be Git tracked. This check notifies
if any of these files are present (`ERROR`)

The current list of files checked are given by this internal constant:

```{r hidden_files_exts}
BiocCheck:::.HIDDEN_FILE_EXTS
```

These files may be included in your personal directories but should be added to
a `.gitignore` file so they are not Git tracked.

## DESCRIPTION checks

**Checking DESCRIPTION**

Default R CMD build behavior will format the DESCRIPTION file; After this
occurs, it is hard to determine certain aspects of the original DESCRIPTION
file. An example would be how the Authors and Maintainers are specified. The
DESCRIPTION file is therefore checked in its raw original form.

*  **Checking if DESCRIPTION is well formatted**
   The DESCRIPTION file must be properly formatted and able to be read in with
   `read.dcf()` in order to function properly on the Bioconductor build
   machines. This check attempts to `read.dcf("DESCRIPTION")` and throws an
   ERROR if mal-formatted. (`ERROR`)

* **Checking for remote package usage...**
   The `Remotes` field is not allowed in Bioconductor packages as dependencies
   must be from CRAN or Bioconductor. (`ERROR`)

*  **Checking for valid maintainer**
   While in the past using the Author and Maintainer fields were acceptable, R
   has moved towards using the `Authors@R` standard for listing package
   contributors. This checks that Authors@R is utilized and that there are no
   instances of Author or Maintainer in the DESCRIPTION (`ERROR`)

## NAMESPACE checks

* **Checking NAMESPACE...**
   Ensures that the NAMESPACE file does not contain a match all export pattern,
   i.e., `exportPattern("^[[:alpha:]]+")` (`ERROR`).

## CITATION checks

**Checking that CITATION file is correctly formatted**

`BiocCheck` tries to read the provided `CITATION` file (i.e. not the one
automatically generated by each package) with `readCitationFile()` - this is
expected to be in the `INST` folder (`NOTE`). `readCitationFile()` needs to work
properly without the package being installed. Most common causes of failure
occur when trying to use helper functions like `packageVersion()` or
`packageDate()` instead of using `meta$Version` or `meta$Date`. See
[R documentation](https://cran.r-project.org/doc/manuals/r-release/R-exts.html#CITATION-files)
for more information.

Here is an example of a formatted `CITATION` file. See the `GenomicRanges`
package `CITATION` file for details.

```{r citation_example}
library(utils)
readCitationFile(
    system.file("CITATION", package = "GenomicRanges")
)
```

`CITATION` files are expected to contain a `doi` input within the `bibentry()`
function call. When a `doi` input is not present, a `WARNING` is emitted as most
modern publications should have an assigned DOI.

```{css anote_style, echo=FALSE}
.anote {
  font-size: 10pt;
  font-style: italic;
  font-family: times,serif;
}
```

::: { .anote }
Note that `citEntry()` should be updated to `bibentry()` as seen with
`R CMD check --as-cran`.
:::

Bioconductor packages are not required to have a `CITATION` file but it is
useful both for users and for tracking Bioconductor project-wide metrics.
Maintainers should update the `CITATION` file once a preprint or publication is
released. Packages that do not have a `CITATION` file are flagged with a `NOTE`.

# Expanding `BiocCheck`

We make an effort to reduce package reviewer burden and to increase the quality
of Bioconductor submissions via automated checks; therefore, `BiocCheck` is a
continually evolving package. Contributions are certainly most welcome. Consider
opening a pull request on GitHub with unit tests and updates to both the `NEWS`
file and vignette. Thank you for being part of the community!

# SessionInfo {-}

```{r sessionInfo}
sessionInfo()
```

---
title: "Test vignette"
author: "BiocCheck"
date: "`r format(Sys.time(), '%B %d, %Y')`"
output:
  BiocStyle::html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, eval = FALSE)
```

\name{internal_function}
\alias{internal_function}
\title{
internal_function
}
\description{
desc
}
\usage{
internal_function()
}
%- maybe also 'usage' for other objects documented here.
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\examples{
  \dontrun{
    x <- 1:10
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ internal }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiocCheck-class.R
\docType{class}
\name{BiocCheck-class}
\alias{BiocCheck-class}
\title{An internal class for composing BiocCheck reports}
\arguments{
\item{...}{\code{character()} A vector that makes up the \code{BiocCheck} exception
message (e.g., 'Vignette must be built by R CMD build'). The character
vector is handled with \code{paste0} and made into a list and appended with
\code{help_text} and \code{messages}.}

\item{help_text}{\code{character(1)} Additional text prompting a list of files
(e.g,. "Found in files:")}

\item{condition}{\code{character(1)} One of the three conditions handled: \code{error},
\code{warning}, or \code{note}}

\item{messages}{\code{character()} Often a vector of file names where the check
was triggered.}

\item{debug}{\code{logical(1)} Whether to append the name of the originating check
name into for trace-ability}

\item{checkName}{\code{character(1)} The title of the current group of checks. It
can be set with \code{handleCheck}, e.g.,
\code{handleCheck("Checking for version number mismatch...")}. Internally, it
'  is saved with \code{setCheck} and obtained with \code{getLastCheck}.}

\item{isOnBBS}{\code{logical(1)} Indicates whether the checks are being run on the
Bioconductor Build System (BBS). This is helpful for avoiding the creation
of folders in the BBS.}

\item{file}{\code{character(1)} A path to a JSON file for writing or reading as
created by \code{toJSON} and \code{fromJSON} \code{BiocCheck} methods.}
}
\value{
An internal \code{BiocCheck} R5 Reference Class used to document
conditions such as errors, warnings, and notes
}
\description{
The \code{BiocCheck} class provides a framework for reporting checks
based on Bioconductor guidelines. The class has several methods for working
with the provided checks that handle and display messages and the display
of the metadata. These methods also record the output of the \code{BiocCheck()}
report in both plain text and JSON formats.

\strong{Note} that currently, multiple \code{BiocCheck} runs will interfere with
each other given that they are implemented via a reference class semantic.
When running multiple checks in the same session, you can separate these
instances by running them in separate processes (e.g., via \code{BiocParallel}).
}
\details{
The metadata includes a number of standard fields to allow easier
troubleshooting and display of potentially relevant information. Currently,
the fields included are:
\itemize{
\item BiocCheckVersion:  The version of the BiocCheck package
\item BiocVersion:  The version of Bioconductor
\item Package:  The name of the package in check
\item PackageVersion:  The version of the package in check
\item sourceDir:  The directory of the package source or tarball in check
\item installDir: The directory where the package is installed for
testing, a temporary location by default
\item BiocCheckDir: The directory where the \verb{<package>.BiocCheck} folder
is saved. Usually the same folder as the package in check
\item platform:  The platform/OS where the check is taking place
\item isTarBall: Whether the package in check is a source directory or a
tarball
}
}
\section{Fields}{

\describe{
\item{\code{log}}{\code{list()} A running list of all conditions raised (i.e., notes,
warnings, errors)}

\item{\code{check}}{\code{character(1)} The title of the last check used for logging
purposes.}

\item{\code{error,warning,note}}{\code{list()} Finer extraction of each condition type}

\item{\code{metadata}}{\code{list()} A list of additional information relevant to the
package and its state. See details.}
}}

\section{methods}{

\itemize{
\item \code{add}: Include a condition to the \code{BiocCheck} report
\item \code{addMetadata}: Add metadata to the \code{BiocCheck} object from a
\code{BiocPackage} object
\item \code{getLastCheck}: Obtain the name of the last check run
\item \code{setCheck}: Create a new element in the internal list for a check
\item \code{get}: Extract the list of conditions raised by \code{BiocCheck}
\item \code{getNum}: Tally the number of condition provided by the input
\item \code{zero}: Reset the internal log of the condition provided
\item \code{getBiocCheckDir}: Report and create the \verb{<package>.BiocCheck}
directory as obtained from the metadata
\item \code{composeReport}: Simplify the list structure from the \code{log} and
provide a character vector of conditions raised
\item \code{report}: Write the \verb{00BiocCheck.log} report into the \code{BiocCheck}
folder
\item \code{toJSON}: Write a JSON file to the location indicated with the
conditions raised
\item \code{fromJSON}: Read a JSON file from the location indicated with the
output of previous conditions raised in the check
\item \code{show}: Display the information in the class. Currently empty.
\item \code{show_meta}: Display the metadata information stored in the \code{metadata}
field
}
}

\examples{

bc <- BiocCheck:::.BiocCheck

}
\seealso{
\linkS4class{Message}, \linkS4class{BiocPackage}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Message-class.R
\docType{class}
\name{Message-class}
\alias{Message-class}
\alias{.MessageCondition}
\alias{setMessage,Message-method}
\alias{setCondition,Message-method}
\alias{getCondition,Message-method}
\title{A lower level Message helper class for BiocCheck}
\arguments{
\item{condition}{\code{character(1)} One of the three conditions handled: \code{error},
\code{warning}, or \code{note}}

\item{\dots}{\code{list()} A nested list with the check name as the top level
layer. Second level lists include any \code{help_text} and \code{messages} that are
part of the check.}
}
\value{
\code{.MessageCondition}: An internal \code{R5} Reference Class to handle
messages and their conditions, e.g., for errors, warnings, or notes.
}
\description{
A lower level Message helper class for BiocCheck
}
\section{Fields}{

\describe{
\item{\code{msg}}{\code{list()} A list of character messages usually grown with \code{append}
with conditions raised by a check}

\item{\code{condition}}{\code{character(1)} One of the three conditions handled: \code{error},
\code{warning}, or \code{note}}
}}


\section{methods}{

\itemize{
\item \code{setMessage}: Set the message and condition (\code{error}, \code{warning}, or
\code{note}) for the check
\item \code{setCondition}: Change the condition for the check
\item \code{getCondition}: Get the condition from the \code{Message} class
}
}

\seealso{
\linkS4class{BiocCheck}, \linkS4class{BiocPackage}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Context.R
\name{Context}
\alias{Context}
\title{Report context of events to user with a data.frame of events and locations}
\usage{
Context(file = "", lines = character(), idx = logical(), offset = 0L)
}
\arguments{
\item{file}{character(1) full path (including package name) of file being
summarized.}

\item{lines}{character() vector of text lines in file}

\item{idx}{logical() same length as \code{lines} indicating lines in which
event occurs}

\item{offset}{\code{integer(1)} The number of lines to add to the 'Line' column
calculation. It is mainly used to account for the number of lines that the
YAML header occupies.}
}
\value{
Context: a data.frame() with columns File, Line, and Context
}
\description{
Report context of events to user with a data.frame of events and locations
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiocPackage-class.R
\docType{class}
\name{BiocPackage-class}
\alias{BiocPackage-class}
\alias{.BiocPackage}
\alias{BiocPackage}
\title{A class for representing files in a Bioconductor package}
\format{
An object of class \code{BiocPackage} of length 1.
}
\usage{
.BiocPackage
}
\value{
An object of class \code{BiocPackage}
}
\description{
The BiocPackage class is used to represent a Bioconductor
package. It is used by BiocCheck to store information about the package
being checked. The class has several methods to identify the type of
package, check for common issues, and store metadata about the package.
}
\section{Fields}{

\describe{
\item{\code{isValid}}{\code{logical} indicating whether the package's \code{DESCRIPTION} file
was able to be read without any errors}

\item{\code{isTar}}{\code{logical} indicating whether the package is a tarball}

\item{\code{isSourceDir}}{\code{logical} indicating whether the package being checked is
from a source directory}

\item{\code{isInfrastructure}}{\code{logical} indicating whether the package is an
Bioconductor infrastructure package based on the \code{biocViews} field}

\item{\code{usesRoxygen}}{\code{logical} indicating whether the package uses \code{roxygen2}
documentation}

\item{\code{usesRdpack}}{\code{logical} indicating whether the package uses \code{Rdpack}
package}

\item{\code{DESCRIPTION}}{\code{matrix} containing the DCF contents of the \code{DESCRIPTION}
file}

\item{\code{dependencies}}{\code{character} vector of package dependencies}

\item{\code{readError}}{\code{character} error message if the \code{DESCRIPTION} file could
not be read}

\item{\code{packageVersion}}{\code{character} version of the package}

\item{\code{packageType}}{\code{character} indicating the type of package based on the
\code{biocViews} field; can be \code{NA_character_} there are invalid \code{biocViews}
terms}

\item{\code{sourceDir}}{\code{character} path to the source directory}

\item{\code{vignettesDir}}{\code{character} path to the vignettes directory}

\item{\code{RSources}}{\code{character} vector of R source files}

\item{\code{VigSources}}{\code{character} vector of vignette source files}

\item{\code{manSources}}{\code{character} vector of Rd source files}

\item{\code{BiocCheckDir}}{\code{character} path to the directory where the package
BiocCheck logs are written}

\item{\code{packageName}}{\code{character} name of the package}

\item{\code{tarFilename}}{\code{character} filename of the tarball}

\item{\code{metadata}}{\code{list} containing metadata about the package}
}}

\section{methods}{

\itemize{
\item \code{initialize}: Initialize a \code{BiocPackage} object
\item \code{getPackageDir}: Get the package directory
\item \code{getRSources}: Get the R source files
\item \code{getVigSources}: Get the vignette source files
\item \code{getManSources}: Get the Rd source files
\item \code{getBiocCheckDir}: Get the directory where the BiocCheck logs are written
\item \code{getBiocViews}: Get the \code{biocViews} field from the \code{DESCRIPTION} file
\item \code{getPackageType}: Get the package type based on the \code{biocViews} field
\item \code{readDESCRIPTION}: Read the \code{DESCRIPTION} file
\item \code{getVigBuilder}: Get the vignette builder
\item \code{getAllDependencies}: Get all dependencies from the \code{DESCRIPTION} file
\item \code{findInfrastructure}: Is the package an infrastructure package?
\item \code{findRoxygen}: Does the package use \code{roxygen2}?
\item \code{getPackageVersion}: Get the package version
\item \code{untarTarball}: Untar the source tarball
}
}

\examples{

# Create a BiocPackage object
packageDirectory <- "path/to/package"
if (dir.exists(packageDirectory))
    .bioctest <- .BiocPackage$initialize(packageDirectory)

.bioctest <- BiocCheck:::.BiocPackage

.bioctest$DESCRIPTION

}
\seealso{
\linkS4class{BiocCheck}, \linkS4class{Message}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiocCheck.R
\name{BiocCheck}
\alias{BiocCheck}
\title{Check a package's adherence with the Bioconductor Package Guidelines}
\usage{
BiocCheck(
  package = getwd(),
  checkDir = dirname(package),
  debug = FALSE,
  callr = FALSE,
  ...
)
}
\arguments{
\item{package}{The path to an R package directory or tarball (\code{.tar.gz}).
The \code{BiocCheck} function is intended to be run from the package
directory; therefore, the current working directory (given by \code{getwd()})
is the default.}

\item{checkDir}{The directory where the \code{BiocCheck} output directory will be
stored. By default, it will be placed in the same directory as the package
directory i.e., \code{dirname(pkg_dir)}.}

\item{debug}{Whether to append the names of functions that correspond to
each condition raised by \code{BiocCheck} in the written log (i.e., in the
\code{'<package_name>.BiocCheck'} folder). This option is only relevant to
developers and contributors to \code{BiocCheck}.}

\item{callr}{logical(1) Whether to use the \code{callr} package to run \code{BiocCheck}
in an isolated R session to prevent namespace collisions.}

\item{\dots}{See the \code{dot-options} details section for available options.}
}
\value{
\code{BiocCheck()} is chiefly called for the side effect of the check
reporting. The function also creates a \verb{<package_name>.BiocCheck} folder
and returns a \code{BiocCheck} reference class with three main list elements:
\itemize{
\item \strong{error}: Items to address before the package can be accepted
\item \strong{warning}: Strongly suggested items that may require attention
\item \strong{note}: Items to consider, though not required, before acceptance
}
}
\description{
Analyzes an R package for adherence with Bioconductor package guidelines and
best practices. The check outputs are categorized into ERROR, WARNING, and
NOTE. See the vignette for more details. \code{BiocCheck} is complementary
to \verb{R CMD check}, which should always be run first.
}
\details{
\code{BiocCheck()} reviews R packages for adherence with Bioconductor
package guidelines and best practices. See
\url{https://contributions.bioconductor.org} for the latest guidance for
writing Bioconductor software. Some rationale behind these best practices
can be seen in the vignette and pages in the \code{references} section. The
vignette also provides detailed explanations of all the checks performed by
\code{BiocCheck}.

\code{BiocCheck} is called within R with \code{BiocCheck("package")}
where \code{package} points to the source directory or the \code{.tar.gz}
tarball that was created using \verb{R CMD build}.

\strong{Note} that \code{BiocCheck} is complementary to \verb{R CMD check}.
\verb{R CMD check} should always be run first for best results.

To skip installation of the package during the check, set the
\code{install} option to \code{FALSE} or \code{NULL}:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{BiocCheck(package, install=FALSE)
## OR
BiocCheck(package, install=NULL)
}\if{html}{\out{</div>}}

To re-use an existing installation log file, set the \code{install} option
to the name of the installation log file.
For example, the following will put the \code{install_out.txt} log file in the
\verb{<package_name>.BiocCheck} directory:
\code{BiocCheck(package, install="check:install_out.txt")}
}
\section{dot-options}{

To use the dot-options, \code{BiocCheck} can be called with named arguments
corresponding to the options below. Typically, these options are set to
\code{TRUE} to disable specific checks, e.g.,
\code{BiocCheck(package, 'no-check-vignettes'=TRUE)}. Unless
otherwise stated, these options can be left unset (i.e., \code{NULL}) to enable
checks but \code{FALSE} can also be used to explicitly enable them. The available
options are:
\itemize{
\item \code{build-output-file}: file containing \verb{R CMD build} output, for
additional analysis
\item \code{new-package}:  enable checks specific to new packages
\item \code{no-check-bbs}: disable BBS-specific checks (for non-BioC packages).
Valid DESCRIPTION
\item \code{no-check-bioc-help}: disable check for registration on Bioconductor
\item \code{no-check-bioc-views}: disable biocViews-specific checks (for non-BioC
packages)
mailing list and support site
\item \code{no-check-coding-practices}: disable check for some common best coding
practices
\item \code{no-check-CRAN}:  disable check for if package exists in CRAN
\item \code{no-check-dependencies}:  disable check for bad dependencies
\item \code{no-check-deprecated}:  disable check for usage of deprecated packages
\item \code{no-check-description}:  disable DESCRIPTION file checks
\item \code{no-check-file-size}:  disable check for individual file size
\item \code{no-check-formatting}:  disable checks for file formatting
\item \verb{no-check-function-len}:  disable check for function length
\item \code{no-check-install-self}: disable check for require or library of
itself
\item \code{no-check-library-calls}: disable check usage of functions that
install or update packages
\item \code{no-check-man-doc}:  disable checks for man page documentation
\item \code{no-check-namespace}:  disable NAMESPACE file checks
\item \code{no-check-news}:  disable checks for NEWS file
\item \code{no-check-pkg-size}:  disable check for package tarball size
\item \code{no-check-R-ver}:  disable check for valid R version
\item \code{no-check-remotes}: disable check for usage of remote packages other
than those hosted on CRAN or Bioconductor
\item \code{no-check-skip-bioc-tests}: disable check for tests that skip when on
bioc
\item \code{no-check-unit-tests}:  disable checks for unit tests
\item \code{no-check-version-num}:  disable check for valid version number
\item \code{no-check-vignettes}:  disable vignette checks
\item \code{quit-with-status}:  enable exit code option when performing check
\item \code{install}: if \code{FALSE}, the package is not installed; otherwise, if not
specified, the package is installed by default. Optionally, a
\verb{check:<file>} key-value pair is provided to identify the name of the
installation output file which will be copied to the
\verb{<package_name>.BiocCheck} directory.
\item \code{libloc}: when \code{install} is specified, the library location where the
package is installed. By default, this is \code{.libPaths()[1]}.
}
}

\examples{

packageDir <- system.file("testpackages", "testpkg0", package="BiocCheck")
BiocCheck(packageDir, `quit-with-status`=FALSE)

}
\references{
\url{https://contributions.bioconductor.org}
}
\seealso{
\linkS4class{BiocCheck}, \linkS4class{Message}
}
\author{
Dan Tenenbaum, Lori Shepherd, and Marcel Ramos
}

\name{baddep}
\alias{baddep}
\title{
baddep
}
\description{
desc
}
\usage{
baddep()
}
%- maybe also 'usage' for other objects documented here.
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
\dontrun{
function ()
{
    validate("{\"foo\": \"bar\"}")
    }
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{internal_too}
\alias{internal_too}
\title{
internal function too
}
\description{
desc
}
\usage{
internal_too()
}
%- maybe also 'usage' for other objects documented here.
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\examples{
    x <- 1:10
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ internal }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiocCheck-class.R
\name{Message-methods}
\alias{Message-methods}
\alias{setMessage,Message-method}
\alias{setCondition,Message-method}
\alias{getCondition,Message-method}
\title{A list of methods for the Message reference class}
\arguments{
\item{condition}{character(1) One of the three conditions handled: \code{error},
\code{warning}, or \code{note}}

\item{verbose}{logical(1) Whether to output the full text in the check or
only the check name itself in the report}

\item{\dots}{\code{list()} A nested list with the check name as the top level
layer. Second level lists include any \code{help_text} and \code{messages} that are
part of the check.}
}
\value{
An internal \code{R5} Reference Class to handle messages and their
conditions, e.g., for errors, warnings, or notes.
}
\description{
A list of methods for the Message reference class
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiocCheck-class.R
\name{BiocCheck-methods}
\alias{BiocCheck-methods}
\alias{add,BiocCheck-method}
\title{A list of methods for the BiocCheck reference class}
\arguments{
\item{...}{\code{character()} A vector that makes up the \code{BiocCheck} exception
message (e.g., 'Vignette must be built by R CMD build'). The character
vector is handled with \code{paste0} and made into a list and appended with
\code{help_text} and \code{messages}.}

\item{help_text}{\code{character(1)} Additional text prompting a list of files
(e.g,. "Found in files:")}

\item{condition}{\code{character(1)} One of the three conditions handled: \code{error},
\code{warning}, or \code{note}}

\item{messages}{\code{character()} Often a vector of file names where the check
was triggered.}

\item{debug}{\code{logical(1)} Whether to append the name of the originating check
name into for trace-ability}

\item{checkName}{\code{character(1)} The title of the current group of checks. It
can be set with \code{handleCheck}, e.g.,
\code{handleCheck("Checking for version number mismatch...")}. Internally, it
'  is saved with \code{setCheck} and obtained with \code{getLastCheck}.}

\item{isOnBBS}{\code{logical(1)} Indicates whether the checks are being run on the
Bioconductor Build System (BBS). This is helpful for avoiding the creation
of folders in the BBS.}

\item{file}{\code{character(1)} A path to a JSON file for writing or reading as
created by \code{toJSON} and \code{fromJSON} \code{BiocCheck} methods.}
}
\value{
An internal \code{BiocCheck} R5 Reference Class used to document
conditions such as errors, warnings, and notes
}
\description{
A list of methods for the BiocCheck reference class
}
\section{methods}{

\itemize{
\item \code{add}: Include a condition to the \code{BiocCheck} report
\item \code{getLastCheck}: Obtain the name of the last check run
\item \code{setCheck}: Create a new element in the internal list for a check
\item \code{get}: Extract the list of conditions raised by \code{BiocCheck}
\item \code{getNum}: Tally the number of condition provided by the input
\item \code{zero}: Reset the internal log of the condition provided
\item \code{addMetadata}: Add metadata to the \code{BiocCheck} object from a
\code{BiocPackage} object
\item \code{getBiocCheckDir}: Report and create the \verb{<package>.BiocCheck}
directory as obtained from the metadata
\item \code{composeReport}: Simplify the list structure from the \code{log} and
provide a character vector of conditions raised
\item \code{report}: Write the \verb{00BiocCheck.log} report into the \code{BiocCheck}
folder
\item \code{toJSON}: Write a JSON file to the location indicated with the
conditions raised
\item \code{fromJSON}: Read a JSON file from the location indicated with the
output of previous conditions raised in the check
\item \code{show}: Display the information in the class. Currently empty.
\item \code{show_meta}: Display the metadata information stored in the \code{metadata}
field
}
}

\name{has_devel}
\alias{has_devel}
\title{Check if you have a development environment installed.}
\usage{
has_devel()
}
\value{
TRUE if your development environment is correctly set up,
otherwise returns an error.
}
\description{
Thanks to the suggestion of Simon Urbanek.
}
\examples{
    foo_path <- file.path(tempdir(), "foo.c")

    cat("void foo(int *bar) { *bar=1; }\n", file = foo_path)
    on.exit(unlink(foo_path))

    devtools:::R("CMD SHLIB foo.c", tempdir())
    dylib <- file.path(tempdir(), paste("foo", .Platform$dynlib.ext, sep=''))
    on.exit(unlink(dylib), add = TRUE)

    dll <- dyn.load(dylib)
    on.exit(dyn.unload(dylib), add = TRUE)

    stopifnot(.C(dll$bar, 0L)[[1]] == 1L)


}

\name{a}
\alias{a}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ bla
%%  ~~function to do ... ~~
}
\description{ bla
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
a(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{x}{
%%     ~~Describe \code{x} here~~
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
#syntaks errir
    ##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.
\donttest{
    #valid syntax
    d2 = 2
    }


## The function is currently defined as
function (x) 
{



    }
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiocCheckGitClone.R
\name{BiocCheckGitClone}
\alias{BiocCheckGitClone}
\title{Checks specific to a Git clone of a package repository}
\usage{
BiocCheckGitClone(package = ".", ...)
}
\arguments{
\item{package}{A directory containing an R source package. Not a package tar
ball.}

\item{\dots}{Currently, only \code{quit-with-status} is available.  See
\code{BiocCheck}}
}
\value{
\code{BiocCheckGitClone()} is chiefly called for the side effect of the
check reporting. The function returns a \code{BiocCheck} reference class with
three main list elements:
\itemize{
\item error: Items to address before the package can be accepted
\item warning: Strongly suggested items that may require attention
\item note: Items to consider, though not required, before acceptance
}
}
\description{
Analyzes an R package for adherence with Bioconductor package guidelines and
best practices. The check outputs are categorized into ERROR, WARNING, and
NOTE. This function is typically used in the Bioconductor Build System (BBS)
and not intended for general use.
}
\details{
\code{BiocCheckGitClone()} reviews R packages for adherence with
Bioconductor package guidelines and best practices. See
\url{https://contributions.bioconductor.org} for the latest guidance for
writing Bioconductor software. This function should only be run on a source
directory and not on a tarball.

\code{BiocCheckGitClone} is called within R with, as
\code{BiocCheckGitClone("package")} where \code{package} is the source directory
containing the \code{R} package.
}
\examples{

packageDir <- system.file("testpackages", "testpkg0", package="BiocCheck")
BiocCheckGitClone(packageDir, `quit-with-status`=FALSE)

}
\references{
\url{https://contributions.bioconductor.org}
}
\seealso{
\linkS4class{BiocCheck}
}
\author{
Lori Shepherd
}
